*------------------------------------------------------------------------------
*- Version....: Sage Pro ERP 7.40.00
*- File Name..: $Workfile: ICREPT.PRG $
*- VCS Level..: $Revision: 39 $
*- Last Update: $Date: 1/22/07 8:10a $
*------------------------------------------------------------------------------
*- Copyright (C) 2006 Sage Accpac International, Inc.  All Rights Reserved.
*------------------------------------------------------------------------------
*- App ID.....: IC
*- App Name...: Inventory Control
*------------------------------------------------------------------------------
*- Description: Reports Menu
*------------------------------------------------------------------------------
*- Called By..: IC
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: lc_rept, report identifier defined in IC.PRG
*-                             F01 - Inventory Master
*-                             F02 - Inventory by Location
*-                             F03 - Inventory Distribution by Value
*-                             F05 - Suppliers File
*-                             F06 - Lots
*-                             F07 - Locations
*-                             F08 - Product Lines
*-                             F09 - Units of Measure
*-                             F10 - Item Price List
*-                             F11 - Price Group Items List Report
*-                             F12 - Price Group report
*-                             S01 - Aggregate Summary
*-                             S02 - Inventory On Hand
*-                             S03 - Usage By Location
*-                             S04 - Location Detail
*-                             S06 - Recommended Reorders
*-                             S07 - Slow Moving Items
*-                             S08 - Alternate Items
*-                             S09 - Physical Inventory Sheets
*-                             S11 - Inventory Analysis
*-                             S13 - Costing Tiers
*-                             S14 - ABC Exception
*-                             S15 - Serial/Lot Stock Status
*-                             T01 - Consolidated Transactions
*-                             T02 - Inventory Issues
*-                             T03 - Inventory Receipts
*-                             T04 - Inventory Adjustments
*-                             T05 - Stock Transfers
*-                             T06 - Inventory Journal
*-                             T07 - Sales History
*-                             T08 - Serial/Lot Issue History
*-                             T09 - Cost Variances
*-                             T10 - Serial Number History
*-                             T11 - Unposted Inter-Company Receipts
*-                             CCW - Cycle Count Worksheets
*------------------------------------------------------------------------------
PARAMETERS lc_rept

#include global.h
#include events.h

*\ [1 Line] PTR 82565 04/28/06 TIRS Declared variables
PRIVATE lc_actses1, ;
        lc_actses2, ;
        lc_actses3, ;
        lc_actses4, ;
        lc_applid, ;
        lc_bbatch, ;
        lc_byseria, ;
        lc_desc, ;
        lc_ebatch, ;
        lc_field2, ;
        lc_group, ;
        lc_lbatch, ;
        lc_nrange, ;
        lc_order, ;
        lc_sortdes, ;
        lc_sortkey, ;
        ll_sumserl, ;
        ll_opnbtch, ;
        ln_bbatch, ;
        ln_ebatch, ;
        ln_grdtot, ;
        ln_opnglac, ;
        ln_opnhist, ;
        ln_opniloc, ;
        ln_opniqty, ;
        ln_opnitem, ;
        ln_opnsupl, ;
        ln_opntran, ;
        ln_opnytrn, ;
        ln_opncyct, ;
        ln_opnysno, ;
        ln_rptcol, ;
        lc_popt, ;
        lc_scust, ;
        lc_deleted, ;
        lc_deleted, ;
        ln_bot, ;
        lc_frx, ;
        lc_frmfile, ;
        ll_gened, ;
        ll_export, ;
        lc_century, ;
        ld_fbdate, ;
        ld_fedate, ;
        lc_frpgrp, ;
        lc_topgrp, ;
        ln_lastkey, ;
        lc_loctid, ;
        lc_xapplid, ;
        ld_bdate, ;
        mdbdate, ;
        mdedate, ;
        lc_barcode, ;
        lc_BComp, ;
        lc_EComp, ;
        ln_opnicts, ;
        lc_Ictfilt, ;
        lc_TempAlias

*\ [1 Line] PTR# 79873 07/21/06 TIAI Declared variable lc_fcPrdBdate
PRIVATE lc_asofdt, ;
        lc_gtasof, ;
        ld_asofdt, ;
        lc_dcl, ;
        ld_begdte, ;
        lc_fld, ;
        ln_max, ;
        ld_trndt, ;
        ln_num, ;
        lc_lpcnt, ;
        ll_NoMatch, ;
        lc_OldAlias, ;
        ll_ExitLoop, ;
        lo_Globals, ;
        lc_fcPrdBdate

*-- Create a temporary DBC to hold the Connection and Views for the Reports

*-- Set initial value as .f.. This variable will determine whether user wants
*-- to preview/print the report even though there are no data
ll_NoMatch = .f.

*-- Initialise variable which will determine whether user has selected against
*-- printing/previewing report with the message no data found for CCW
ll_ExitLoop = .f.

PRIVATE ll_NoSelrpt

*-- Flag whether to prompt for selection of custom reports
ll_NoSelrpt = .f.

*-- Open the ic files as we are in a new sesion now
DO (gc_adrvprg + gc_applid + "opnf") WITH .t.

lc_gtasof = "No "

lc_asofdt = Cc_NullDate
ld_asofdt = {}
lc_dcl    = ""
ld_begdte = {}
lc_fld    = ""
ln_max    = 0
ld_trndt  = {}

ln_num    = 1
lc_frpgrp = SPACE(15)
lc_topgrp = SPACE(15)

*-- Save century setting
lc_century = SET("CENTURY")

ld_fbdate  = {}
ld_fedate  = {}
ld_bdate   = {}

mdbdate    = {}
mdedate    = {}

SET CENTURY OFF

*\ [4 Lines] PTR# 79873 07/21/06 TIAI Initialized variable lc_fcPrdBdate
*-- As beginning date is shown in option grid as a string having 2 characters
*-- for year, it is essential that CENTURY is OFF while getting the default 
*-- value from gd_fcPrdBdate
lc_fcPrdBdate = DTOC(gd_fcPrdBdate)

*-- Initially we have not generated
ll_gened  = .f.

*-- Default for all reports is exportable
ll_export = .t.

*-- Initialize report form variables
lc_frx = ""

*-- Initialize Active Session Report header variables
lc_actses1 = SPACE(0)
lc_actses2 = SPACE(0)
lc_actses3 = SPACE(0)
lc_actses4 = SPACE(0)
lc_byseria = PADR("No", 3)
lc_desc    = SPACE(0)
lc_field2  = SPACE(0)
lc_group   = SPACE(0)

*-- full name of the group by field
lc_sortdes = SPACE(0)
lc_sortkey = SPACE(0)

*-- Initialize inventory values
tcost    = 0.00
tret     = 0.00
taloc    = 0.00
tcurr    = 0.00
tover30  = 0.00
tover60  = 0.00
tover90  = 0.00
tover120 = 0.00

ln_grdtot = 0

*-- Report column width
ln_rptcol = 80
*\ [1 line] PTR# 79256 BAUG 07/01/05 Scan barcodes to add items to SO/AR/IC.
lo_Globals = go_Globals.m_GetObject(gc_applid, gc_compid)

*-- Disables any opened MDI forms and its hotkeys
= g_setmdi(.t.)

*-- Define report window
DEFINE WINDOW lw_rept ;
              FROM 0, 0 ;
              TO 23, 79 ;
              NONE ;
              COLOR SCHEME 1

gl_landscp = .f.

*-- Set report title, grid size, option grid defaults
IF INLIST(lc_rept, "S01", "S02")
  lc_type = "Inventory"
ELSE
  lc_type = PADR("All", 9)
ENDIF

lc_order   = "N"
lc_applid  = "All"
lc_xapplid = Cc_NullStr
lc_incld   = PADR("All items", 19)
lc_file    = "Current"

lc_uomin   = "Transaction Unit"

lc_status  = "All     " 

DO CASE
  CASE lc_rept = "F01"
    lc_title1  = " Inventory Master "
    ln_bot     = IIF(gl_locts, 23, 21)
    lc_order   = PADR("Item", 11)

  CASE lc_rept = "F02"
    lc_title1  = " Inventory by " + PROPER(gc_loct) + SPACE(1)

    ln_bot     = 17

  CASE lc_rept = "F03"
    lc_title1  = " Inventory Distribution by Value "
    ln_bot     = IIF(gl_locts, 12, 10)
    lc_type    = "All     "

    *-- Set Distribution Type to "I" for Inventory
    lc_dbvtype = "I"
    ln_minamt  = 1000

  CASE lc_rept = "F05"
    lc_title1  = " Suppliers File "

    ln_bot     = 17

  CASE lc_rept = "F06"
    lc_title1  = " Lots "
    ln_bot     = 8

  CASE lc_rept = "F07"
    lc_title1  = SPACE(1) + PROPER(gc_loct) + "s "
    ln_bot     = 6

  CASE lc_rept = "F08"
    lc_title1  = " Product Lines "
    ln_bot     = 4

  CASE lc_rept = "F09"
    lc_title1  = " Units of Measure "
    ln_bot     = 4

  CASE lc_rept = "F10"
    ln_bot     = 22
    lc_type    = PADR("All", 12)
    lc_title1  = "Item Price List "
    lc_zero   = "No "

  CASE lc_rept = "F11"
    ln_bot     = 6
    lc_title1  = "Price Group Items List "
    lc_title   = "Price Group Items List "
    lc_zero   = "No "

  CASE lc_rept = "F12"
    ln_bot     = 6
    lc_title1  = "Price Group "
    lc_zero   = "No "

  CASE lc_rept = "S01"
    lc_title1  = " Aggregate Summary "
    ln_bot     = IIF(gl_locts, 22, 20)

  CASE lc_rept = "S02"
    lc_title1   = IIF(lc_detail = "D", "Detailed ", "Summary ") + ;
                 "Inventory On Hand "

    ln_bot     = IIF(gl_locts, 18, 16) + IIF(lc_detail = "D", 2, 0)

    ln_bot     = ln_bot + 4
    lc_asofdt  = gc_sdate8

  CASE lc_rept = "S03"
    lc_title1   = " Usage By " + PROPER(gc_loct) + SPACE(1)
    ln_bot     = 18

  CASE lc_rept = "S04"
    lc_title1   = PROPER(gc_loct) + " Detail "
    ln_bot     = 22

    *-- If not using stores, shorten option grid
    IF NOT gl_store
      ln_bot = ln_bot - 4
    ENDIF

    *-- If not using bins, shorten option grid
    IF NOT gl_bin
      ln_bot = ln_bot - 4
    ENDIF

  CASE lc_rept = "S06"
    lc_title1   = " Recommended Reorders "
    ln_bot     = IIF(gl_locts, 26, 24)
    lc_order   = PADR(gc_loct, 13)
    lc_type    = PADR("All", 9)
    lc_incld   = PADR("All items", 19)

  CASE lc_rept = "S07"
    lc_title1   = " Slow Moving Items "
    ln_bot     = IIF(gl_locts, 20, 18)
    lc_type    = "Turnover"
    lc_resell  = "Resellable Stock"

  CASE lc_rept = "S08"
    lc_title1   = " Alternate Items "
    ln_bot     =  14

  CASE lc_rept = "S09"
    lc_title1   = " Physical Inventory Sheets "
    ln_bot     = 22
    lc_zero   = "No "

    *-- If not using locations, shorten option grid
    IF NOT gl_locts
      ln_bot = ln_bot - 2
    ENDIF

    *-- If not using stores, shorten option grid
    IF NOT gl_store
      ln_bot = ln_bot - 4
    ENDIF

    *-- If not using bins, shorten option grid
    IF NOT gl_bin
      ln_bot = ln_bot - 4
    ENDIF

  CASE lc_rept = "S11"
    lc_title1   = " Inventory Analysis "

*\ [1 Line] PTR 73877 10/27/04 TIMI Increase option grid height by 2 row
    ln_bot     = IIF(gl_locts, 22, 20)

  CASE lc_rept = "S13"
    lc_title1   = " Costing Tiers "
    ln_bot     = IIF(gl_locts, 8, 6)

  CASE lc_rept = "S14"
    lc_title1   = " ABC Exception "

    ln_bot     = 8

    *-- Select sysdata record, and store record number
    ln_icsysd  = g_setsys(gc_applid, gc_compid, .t.)
    lc_type    = IIF(SUBSTR(a_sysdat->str3, 13, 1) = "V", "Value", "Usage")
    ln_abpct   = a_sysdat->num2 * 100.0
    ln_bcpct   = a_sysdat->num3 * 100.0
    ln_accum   = 0.000
    ln_abamt   = 0
    ln_bcamt   = 0
    ln_totval  = 0

  CASE lc_rept = "S15"
    lc_title1   = " Serial/Lot Stock Status "
    ln_bot     = 10
    lc_order   = PADR("Item", 8)
    lc_applid  = PADR("All", 12)

    IF gl_locts
      ln_bot = ln_bot + 2
    ENDIF

    IF gl_lots
      ln_bot = ln_bot + 2
    ENDIF

    IF gl_serial
      ln_bot = ln_bot + 4
    ENDIF

  CASE lc_rept = "T01"
    lc_title1  = " Consolidated Transactions "
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    ln_bot     = IIF(gl_locts, 22, 20)
    lc_order   = PADR("Date", 6)

  CASE lc_rept = "T02"
    lc_title1   = " Inventory Issues "
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    ln_bot     = IIF(gl_locts, 22, 20)

*\ [1 Line] PTR 82565 04/28/06 TIRS Increased bottom width further to fit company option
    ln_bot     = ln_bot + 4

    lc_order   = PADR("Date", 11)
    lc_applid  =  PADR("All Issues", 12)

  CASE lc_rept = "T03"
    lc_title1   = " Inventory Receipts "
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    ln_bot     = IIF(gl_locts, 22, 20)

*\ [1 Line] PTR 82565 04/28/06 TIRS Increased bottom width further to fit company option
    ln_bot     = ln_bot + 4

    lc_order   = "Account"
    lc_applid  = PADR("All Receipts", 15)

*\ [3 Lines] PTR 83058 07/10/06 TIRS Setup option grid for Unposted intercomp receipts
  CASE lc_Rept = "T11"
    lc_title1   = " Unposted Inter-Company Receipts "
    ln_bot     = 16

  CASE lc_rept = "T04"
    lc_title1   = " Inventory Adjustments "
*\ [1 Line] PTR 82780 06/29/06 TIRS Changed the height as 20 instead of 18 for single loc
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*\ [1 Line] PTR# 67009 04/06/05 TINN Removed checking of gl_sbtmod to support date range
    ln_bot     = IIF(gl_locts, 22, 20)

  CASE lc_rept = "T05"
    lc_title1   = " Stock Transfers "
    lc_type    = PADR("All", 7)

*\ [Begin] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    DO CASE
      CASE gl_store AND gl_bin
        ln_bot = 22
      CASE gl_store OR gl_bin
        ln_bot = 20
      OTHERWISE
        ln_bot = 18
    ENDCASE
*\ [End] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid

    *-- If not using stores, shorten option grid
    IF NOT gl_store
      ln_bot = ln_bot - 2
    ENDIF

    *-- If not using bins, shorten option grid
    IF NOT gl_bin
      ln_bot = ln_bot - 2
    ENDIF

  CASE lc_rept = "T06"
    lc_title1   = " Inventory Journal "
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    ln_bot     = 16
    lc_order   = "Account"
    lc_applid  = "All Transactions"
    lc_nrange  = "Session"
    ln_bbatch = 0
    ln_ebatch = 0
    lc_bbatch = SPACE(6)
    lc_ebatch = SPACE(6)

    *-- Open General Ledger Account File
    ln_opnglac = g_opnfl(gf_glacntf, "a_glacnt", .f., .f., "glacnt")

    *-- Find the last batch number that was issued for IC postings
    *-- Search GL Batch Number file, must be linked to run journal report
    ll_opnbtch = (d_opnfl("GLBTCH", gc_link, SPACE(0), "a_glbtch", .f.) = 1)

    IF ll_opnbtch

      go_SQL.cmpA_Glbtch.m_SetOrder("batchno", .t.)

      go_SQL.so_CurrentAlias.m_Locate("FOR bdesc = 'Posting from IC, " + gc_compid + "'")

      IF go_SQL.so_CurrentAlias.m_IsFound()
        lc_lbatch = a_glbtch->batchno
      ELSE
        lc_lbatch = SPACE(6)
      ENDIF

      *-- Close GL batch file
      go_SQL.cmpA_Glbtch.m_CloseTable()
    ELSE
      lc_lbatch = SPACE(6)
    ENDIF

    *-- Refresh Active session array
    ll_actsess = g_retact(3)

    *-- Get highest completed session
    lc_hsess = g_retact(1)
    lc_hsess = PADL(ALLTRIM(lc_hsess), 6, "0")

    *-- Set default beginning session number
    lc_bsess = SPACE(LEN(lc_hsess))

    *-- Set default ending session number
    lc_esess = lc_hsess

  CASE lc_rept = "T07"
    lc_title1   = " Sales History "

    IF gl_ar AND gl_so
      ln_bot = 16
    ELSE
      ln_bot = 14
    ENDIF

    lc_applid  = SPACE(4)

  CASE lc_rept = "T08"
    lc_title1   = " Serial/Lot Issue History "
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    ln_bot     = IIF(gl_locts, 22, 20)

  CASE lc_rept = "T09"
    lc_title1   = " Cost Variances "
*\ [1 Line] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
    ln_bot     = IIF(gl_locts, 18, 16)
    lc_order   = PADR("Date", 11)
    lc_applid  = PADR("All Issues", 12)

  CASE lc_rept = "T10"
    lc_title1   = " Serial Number History "
    ln_bot     = 8
    ln_item    = 0

  CASE lc_rept = "CCW"
    lc_title1   = " Cycle Count Worksheets "
*\ [1 line] PTR# 79256 BAUG 06/02/05 Scan barcodes to add items to SO/AR/IC.
    ln_bot = IIF(lo_Globals.gl_Enablebarcode, 23, 22)
    lc_zero    = "No "
    lc_barcode = "No "
*\ [1 Line] PTR 83281 06/23/06 SGOU Disable print icon in preview
    *-- disable print icon in preview because it needs to update after printing
    gl_PreviewPrinting = .f.

ENDCASE

*-- Make sure data dictionary files are open

ln_opnflds  = g_opnfl("SYDFLDS", "a_sydfld", .f., .f.)

*-- Initialize var lengths from data dictionary

lc_blot     = SPACE(VAL(d_retfd("ICILOT  ", "LOTNO",6)))
lc_elot     = SPACE(VAL(d_retfd("ICILOT  ", "LOTNO",6)))
lc_bserial  = SPACE(VAL(d_retfd("ICIQTY  ", "QSERIAL",6)))
lc_eserial  = SPACE(VAL(d_retfd("ICIQTY  ", "QSERIAL",6)))
lc_bstore   = SPACE(VAL(d_retfd("ICIQTY  ", "QSTORE",6)))
lc_estore   = SPACE(VAL(d_retfd("ICIQTY  ", "QSTORE",6)))
lc_bbin     = SPACE(VAL(d_retfd("ICIQTY  ", "QBIN",6)))
lc_ebin     = SPACE(VAL(d_retfd("ICIQTY  ", "QBIN",6)))
lc_bvprtno  = SPACE(LEN(gc_ItemPic))
lc_evprtno  = SPACE(LEN(gc_ItemPic))
lc_bvendno  = SPACE(LEN(gc_CVNoPic))
lc_evendno  = SPACE(LEN(gc_CVNoPic))

lc_brate    = SPACE(VAL(d_retfd("ICSUPL  ", "RATING",6)))
lc_erate    = SPACE(VAL(d_retfd("ICSUPL  ", "RATING",6)))

lc_bcustno  = SPACE(LEN(gc_CVNoPic))
lc_ecustno  = SPACE(LEN(gc_CVNoPic))

lc_vpartno  = SPACE(LEN(gc_ItemPic))

lc_qstore   = SPACE(VAL(d_retfd("ICIQTY  ", "QSTORE",6)))
lc_qbin     = SPACE(VAL(d_retfd("ICIQTY  ", "QBIN",6)))

lc_bitem    = SPACE(LEN(gc_ItemPic))
lc_eitem    = SPACE(LEN(gc_ItemPic))
lc_bunms    = SPACE(LEN(a_icitem->stkumid))
lc_eunms    = SPACE(LEN(a_icitem->stkumid))
lc_bclass   = SPACE(LEN(a_icitem->ITMCLSS))
lc_eclass   = SPACE(LEN(a_icitem->ITMCLSS))
lc_bmcode   = SPACE(LEN(a_icitem->CODE))
lc_emcode   = SPACE(LEN(a_icitem->CODE))
lc_bpline   = SPACE(LEN(a_icitem->PLINID))
lc_epline   = SPACE(LEN(a_icitem->PLINID))
lc_bccode   = SPACE(LEN(a_icitem->COMCODE))
lc_eccode   = SPACE(LEN(a_icitem->COMCODE))
lc_cntcode  = SPACE(LEN(a_icitem->CNTCODE))
lc_class    = SPACE(LEN(a_icitem->ITMCLSS))
lc_abccode  = SPACE(LEN(a_icitem->ABCCODE))
lc_plinid   = SPACE(LEN(a_icitem->PLINID))

lc_bloc     = SPACE(LEN(a_iciloc->LOCTID))
lc_eloc     = SPACE(LEN(a_iciloc->LOCTID))
lc_loctid   = SPACE(LEN(a_iciloc->LOCTID))




lc_bglcode    = SPACE(VAL(d_retfd("ICGLAC  ", "GLCODE",6)))
lc_eglcode    = SPACE(VAL(d_retfd("ICGLAC  ", "GLCODE",6)))

ld_lpcnt      = gd_sdate
lc_lpcnt      = DTOC(gd_sdate)
lc_bcommid    = SPACE(6)
lc_ecommid    = SPACE(6)
lc_baccnt     = TRANSFORM(REPLICATE(SPACE(1), LEN(gc_acctpic)), gc_acctpic)
lc_eaccnt     = TRANSFORM(REPLICATE(SPACE(1), LEN(gc_acctpic)), gc_acctpic)

*\ [Begin] PTR# 79873 07/21/06 TIAI Set beg date as current period beg date
DO CASE
  CASE INLIST(lc_rept, "T01", "T02", "T03", "T04", "T05", ;
    "T06", "T07", "T08", "T09")
    *-- Set default beginning date to be the current period beginning date
    lc_bdate = lc_fcprdBdate

  OTHERWISE
    lc_bdate = Cc_NullDate

ENDCASE
*\ [End] PTR# 79873 07/21/06 TIAI Set beg date as current period beg date

lc_edate      = DTOC({})
lc_file       = "Current"
lc_inczero    = PADR("No", 3)

*\ [1 Line] PTR 73877 10/27/04 TIMI Initialise variable with "No"
lc_inctotzero = PADR("No", 3)

lc_range    = "All sales"
lc_loctype  = PADR("All", 10)
lc_adjtype  = PADR("All", 9)

IF lc_rept = "F10"
  lc_item   = SPACE(LEN(gc_ItemPic))
  lc_code   = SPACE(6)
  lc_type   = PADR("All", 13)
  lc_psched = SPACE(3)
  lc_reptyp = "List prices"
  lc_popt   = PADR("All", 8)
  lc_scust  = SPACE(LEN(gc_CVNoPic))
  lc_loctid = SPACE(6)
ENDIF

*\ [3 Lines] PTR 82565 04/28/06 TIRS Initialized variables
lc_Bcomp   = SPACE(10)
lc_Ecomp   = SPACE(10)
lc_Ictfilt = ""

IF lc_rept = "S02"
   lc_group = PADR("Class", 14)
ELSE
  lc_group = PADR("Item", 10)
ENDIF

IF lc_rept = "S02"
  lc_sort  = PADR("Item", 11)
ELSE
  lc_sort  = "Sales Qty"
ENDIF

lc_per      = "12"
lc_onhand   = PADR("All", 11)
ln_days     = 0
ln_units    = 0

*-- Set account range limits
lc_0accnt = TRANSFORM(REPLICATE("0", LEN(gc_acctpic)), gc_acctpic)
lc_9accnt = TRANSFORM(REPLICATE("9", LEN(gc_acctpic)), gc_acctpic)

*-- Initialize report heading lines
lc_head1 = SPACE(0)
lc_head2 = SPACE(0)
lc_head3 = SPACE(0)

*-- Initialize report form variables
lc_cond    = SPACE(0)

*-- Initialize filter condition
lc_filt  = SPACE(0)
lc_filt1 = SPACE(0)
lc_filt2 = SPACE(0)
lc_filt3 = SPACE(0)
lc_filt4 = SPACE(0)
lc_filt5 = SPACE(0)

*-- Initialised a lc_filter
lc_filter = SPACE(0)

*-- Initialize row numbers for validation
ln_bsess = 0
ln_esess = 0

DECLARE la_filt[3]
la_filt = SPACE(0)

*-- Initialize row numbers for validation
ln_rdays = 0
*-- Activate report window
ACTIVATE WINDOW lw_rept NOSHOW TOP
MOVE WINDOW lw_rept CENTER

lc_optitle = lc_title1

*-- Display option grid
DO g_dspgd WITH "Option Grid - " + lc_optitle + "Report:", (ln_bot), ;
                .f., 0, .t.

*-- Setup custom report button variables
PRIVATE ll_custfrx, ;
        ll_askfrx, ;
        lc_custom, ;
        lc_cusrept

ll_custfrx = .f.
ll_askfrx = .t.

lc_custom = ""

*-- If the standard report name is available at this juncture
*-- then display the same
IF TYPE("lc_frx") = "C" AND NOT EMPTY(lc_frx)
  lc_cusrept = UPPER(JUSTSTEM(lc_frx)) + "(Standard)"
ELSE
  lc_cusrept = ""
ENDIF

*-- Row source for report selection drop dowm
DIMENSION la_Custom[1]
la_Custom[1] = ""

DO CASE
  CASE lc_rept $ "CCW"
    *-- Limited options for Cycle Count Worksheet
    DECLARE la_pad[4], ;
            la_prmpt[4], ;
            la_skip[4]

    la_skip = ".f."
    la_skip[1]  = "ln_lastkey = gk_esc"

    la_pad[1]   = "Print"
    la_prmpt[1] = "Print"

    la_pad[2]   = "Pre\<view"
    la_prmpt[2] = "Preview"

    la_pad[3]   = "Reenter"
    la_prmpt[3] = "Reenter"

    la_pad[4]   = "E\<xit"
    la_prmpt[4] = "Exit"
    ll_askfrx = .f.

  CASE lc_rept $ "S09~CCW"
    *-- Limited options for physical inventory sheet
    DECLARE la_pad[3], ;
            la_prmpt[3], ;
            la_skip[3]
    la_skip = ".f."
    la_skip[1]  = "ln_lastkey = gk_esc"

    la_pad[1]   = "Print"
    la_prmpt[1] = "Print"

    la_pad[2]   = "Reenter"
    la_prmpt[2] = "Reenter"

    la_pad[3]   = "E\<xit"
    la_prmpt[3] = "Exit"
    ll_askfrx = .f.

  OTHERWISE


    *-- Set up arrays of menu choices and prompts
    DECLARE la_pad[5]
    DECLARE la_prmpt[5]
    DECLARE la_skip[5]

    la_skip = ".f."

    la_pad[1]   = "Generate"
    la_prmpt[1] = "Generate"
    *-- Skip if generated
    la_skip[1]  = "ll_gened OR ln_lastkey = gk_esc"

    la_pad[2]   = "Pre\<view"
    la_prmpt[2] = "Preview"
    *-- Skip if not yet generated
    la_skip[2]  = "NOT ll_gened"

    la_pad[3]   = "Print"
    la_prmpt[3] = "Print"
    *-- Skip if not yet generated
    la_skip[3]  = "NOT ll_gened"

    la_pad[4]   = "Reenter"
    la_prmpt[4] = "Reenter"
    *-- Always active
    la_skip[4]  = ".f."



    la_pad[5]   = "E\<xit"
    la_prmpt[5] = "Exit"
    *-- Always active
    la_skip[5]  = ".f."

    *-- Do not prompt for selection of reports for these
    *-- reports as selection will be available in the option
    *-- grid itself
    ll_NoSelrpt = .t.

ENDCASE

*-- Set to ignore deleted records
SET DELETED ON

*-- Set to continue
ll_cont = .t.

DO WHILE .t.
  DO g_dspst WITH gc_task, .f., gn_msgline, gc_applid, gc_compid, gc_userid

  IF NOT ll_gened
    *-- Get grid options
    DO l_getop

    ln_lastkey = LASTKEY()

    *-- Validate report options
    DO l_valop

    *-- Set print width
    *-- Reports requiring 132 columns
    IF lc_rept $ "F03|F05|F06|F07|F08|F11|F12|S01|S02|S03|S04|S06|S07|S08|" + ;
       "S11|S13|S14|S15|T01|T02|T03|T04|T05|T07|T08|T10|CCW" OR ;
       (lc_rept = "T06" AND lc_detail = "D")

      *-- Set print width to 132 columns
      ln_rptcol = 132
    ENDIF

    IF lc_rept = "F10" AND ALLTRIM(lc_reptyp) <> "List prices"
      ln_rptcol = 132
    ENDIF

    *-- Reports requiring 96 columns
    IF lc_rept $ "F02|S01"
      *-- Set print width to 96 columns
      ln_rptcol = 96
    ENDIF

  ELSE
    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

    *-- There are no records to generate the report. Allow ll_gened to be set as
    *-- .f. only when the user has chosen not to print/preview the report
    IF go_SQL.so_CurrentAlias.m_IsEof() AND NOT ll_NoMatch
      ll_gened = .f.
    ENDIF

  ENDIF

  DO CASE
    CASE LASTKEY() <> gk_esc
      *-- Esc was not pressed
      ln_resp = g_getch(1)
    CASE lc_rept =  "CCW"
      *-- Esc pressed for report having only 3 choices.Focus on Cancel button
      ln_resp = g_getch(4)
    CASE lc_rept =  "S09"
      *-- Esc pressed for reports having only 3 choices.Focus on Cancel button
      ln_resp = g_getch(3)
    OTHERWISE
      *-- Esc pressed. Focus on exit button.
      ln_resp = g_getch(5)
  ENDCASE

  IF lc_rept = "CCW"

    IF ln_resp = 2
      ln_resp = 1
      ll_prnt = .f.
    ELSE
      ll_prnt = .t.
    ENDIF

  ENDIF

  DO CASE
    CASE lc_rept = "S09" AND ln_resp = 1
      *-- Physical inventory sheets - print
      ll_prnt  = .t.
      DO l_physinv
      ll_cont = .f.
      EXIT

    CASE lc_rept = "CCW" AND ln_resp = 3
      *-- reenter
      ll_gened = .f.
      LOOP
    CASE lc_rept = "S09" AND ln_resp = 2
      *-- reenter
      LOOP
    CASE lc_rept $"S09~CCW" AND ln_resp <> 1
      *--  exit
      ll_cont = .f.
      EXIT

    CASE ln_resp = 1
      *--- Generate the report
      lc_filt    = ""
      lc_filt1 = SPACE(0)
      lc_filt2 = SPACE(0)
      lc_filt3 = SPACE(0)
      lc_filt4 = SPACE(0)
      lc_filt5 = SPACE(0)
      lc_field2  = SPACE(0)
      *-- Initialised a lc_filter
      lc_filter = SPACE(0)

*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Set headings after report generation
*!*	      *-- Set up report headings
*!*	      DO l_sethd

      IF go_SQL.m_IsUsed("a_tmpf1")
        go_SQL.cmpA_Tmpf1.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf2")
        go_SQL.cmpA_Tmpf2.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf3")
        go_SQL.cmpA_Tmpf3.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf4")
        go_SQL.cmpA_Tmpf4.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf5")
        go_SQL.cmpA_Tmpf5.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf6")
        go_SQL.cmpA_Tmpf6.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf7")
        go_SQL.cmpA_Tmpf7.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf8")
        go_SQL.cmpA_Tmpf8.m_CloseTable()
      ENDIF

      IF go_SQL.m_IsUsed("a_tmpf9")
        go_SQL.cmpA_Tmpf9.m_CloseTable()
      ENDIF

      *-- Execute the report setup
      DO l_icrept

*\ [2 Lines] PTR# 78641 06/16/05 TISJ Set up report headings
      *-- Set up report headings
      DO l_sethd

      *-- Mark as generated
      ll_gened = .t.

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      IF go_SQL.so_CurrentAlias.m_IsEof()

        IF g_getdlg(Cc_NoDataMsg, 2, 2, "Yes ", ;
                    "No ", Cc_NullStr, Cc_NullStr) = 1
          *-- Chosen to preview/print the report
          ll_NoMatch = .t.
        ELSE

          IF lc_rept = "CCW"
            *-- Determined to exit the loop
            ll_ExitLoop = .t.
          ELSE
            LOOP
          ENDIF

        ENDIF

      ENDIF


      *-- Check to see if there is a custom form , if so use it
      = g_getfrx(lc_frx, ;
                 "SYRFCUS", ;
                 @la_custom, ;
                 @lc_cusrept)

      ll_custfrx = .t.

      *-- Get the report name along with path info
      lc_frmfile = l_getfrx()

      IF lc_rept = "CCW"

        

        *-- Launch the report selection dialog if custom reports
        *-- are available
        IF NOT ll_NoSelrpt AND NOT ll_ExitLoop
           lc_frmfile = g_selrpt(lc_frmfile)
        ENDIF

        IF ll_NoMatch
          lc_OldAlias = ALIAS()

          *-- Call g_pnorec to create temporary frx and temporary dummy table
          *-- for printing report with the message no data found
          lc_frmfile = g_pnorec(.t., lc_frmfile)
        ENDIF

        *-- When there is no data and the selection is against print/preview
        *-- avoid the same
        IF NOT ll_ExitLoop

          IF ll_prnt

            *-- Pass the 4th parameter as .t. to disable print range button
            IF g_setprn(.f., .f., .f., .t.)

              DO g_prnrp WITH .f., .f., .f., .f., .t.
            ELSE
              IF ll_NoMatch
                = g_pnorec()

                *-- Restore back the previous alias
                go_SQL.m_TableChangeCurrent(lc_OldAlias)
              ENDIF
				
              LOOP
            ENDIF

          ELSE
            DO g_prvfrx WITH lc_frmfile, .f., .t.
          ENDIF

        ENDIF

        IF ll_NoMatch
          *-- Call without parameters to erase the created temporary files
          = g_pnorec()

          *-- Restore back the alias
          go_SQL.m_TableChangeCurrent(lc_OldAlias)
        ENDIF

        IF (ll_ExitLoop OR ll_NoMatch)
          *-- Whether chosen to print or not the message no data found,
          *-- exit the loop
          EXIT
        ENDIF

        IF lc_byseria = "No"
          go_SQL.m_TableChangeCurrent("ac_tmpf1")
          go_SQL.so_CurrentAlias.m_CloseTable()
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(1, "F"),, "F")

          go_SQL.m_SQLSelect("* FROM ac_tmpf2", "CURSOR", "ac_tmpf1", "F")
          go_SQL.m_TableChangeCurrent("ac_tmpf2")
          go_SQL.cmpAc_tmpf2.m_CloseTable()
        ENDIF

        *-- If printed CCW, copy records from ICIQTYnn to ICPHYSnn
        *-- for reconciliation.

        IF ll_prnt
          go_SQL.m_TableChangeCurrent("ac_tmpf1")

          go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

          *-- Display processing message
          DO g_dspst WITH "Building cycle count working file...", .t., ;
                          gn_msgline, SPACE(0), SPACE(0), SPACE(0)

          *-- Open Physical Inventory file
          ln_opnphys = g_opnfl(gf_icphysf, "a_icphys", .f., .f.)

          *-- SCAN the temp file into a_icphys, moving a_tmpf1->qserial into
          *-- a_icphys->pserial

          ll_flock = (go_SQL.cmpA_Icphys.m_LockFile(-1, .f.))
          go_SQL.m_TableChangeCurrent("ac_tmpf1")

          go_SQL.cmpAc_tmpf1.m_ScanBegin("", "")

          DO WHILE go_SQL.cmpAc_tmpf1.m_Scan()

*\ [Begin] PTR# 80130 BAUG 08/31/05 Do not freeze inventory during cycle count process.

            go_SQL.cmpA_icphys.m_SQLInsert("pserial, " + ;
                                           "loctid, " + ;
                                           "item, " + ;
                                           "lotno, " + ;
                                           "ponhand, " +  ;
                                           "qonhand, "  + ;
                                           "pstore, " + ;
                                           "pbin, " + ;
                                           "ccntdate, " + ;
                                           "ccnttime ", ;
                                           "ac_tmpf1.qserial, " + ;
                                           "ac_tmpf1.loctid, " + ;
                                           "ac_tmpf1.item, " + ;
                                           "ac_tmpf1.lotno, " + ;
                                           "ac_tmpf1.qonhand, " + ;
                                           "ac_tmpf1.qonhand, " + ;
                                           "ac_tmpf1.qstore, " + ;
                                           "ac_tmpf1.qbin, " + ;
                                           "DATE(), " + ;
                                           "TIME() ","") 


              *-- Lock the item at loction record
              go_SQL.m_TableChangeCurrent("a_iciloc")
              = go_SQL.cmpA_Iciloc.m_LockRow(-1, .f.)

              go_SQL.so_CurrentAlias.m_Seek(ac_tmpf1->item + ;
                                         ac_tmpf1->loctid)
*\ [5 lines] PTR# 82394 BAUG 08/04/06 Do not reprint worksheet if it is already printed.
              *-- When you print cycle count, if lock inventory option is not selected then update       
              *-- cntflag field with "C". We need this new flag because when we reprint the worksheet
              *-- we need to filter out the already printed records.
              IF gl_CcntLock 
                go_SQL.so_CurrentAlias.m_Replace("cntflag", 'L')
              ELSE
                go_SQL.so_CurrentAlias.m_Replace("cntflag", 'C')                
              ENDIF  

              go_SQL.cmpA_Iciloc.m_Unlock()


*\ [End] PTR# 80130 BAUG 08/31/05 Do not freeze inventory during cycle count process.            
          ENDDO
          go_SQL.cmpAc_tmpf1.m_ScanEnd()

          *-- Clean up after ourselves
          go_SQL.cmpA_Icphys.m_Unlock()

          go_SQL.m_TableChangeCurrent("ac_tmpf1")

          go_SQL.so_CurrentAlias.m_CloseTable()

          go_SQL.m_dropTable(go_SQL.m_getTempTableName(1, "F"),,"F")

          IF ln_opnphys = 2
            go_SQL.cmpA_Icphys.m_CloseTable()
          ENDIF

          ll_cont = .f.
          EXIT

        ENDIF && ll_prnt

        go_SQL.m_TableChangeCurrent("a_iciqty")
        go_SQL.CmpA_iciqty.m_SetIndex()
        go_SQL.so_CurrentAlias.m_SetRelation("", "", .f.)
        go_SQL.so_CurrentAlias.m_SetFilter("")

      ENDIF

    CASE ln_resp = 2
      *-- Preview

      lc_frmfile = l_getfrx()

      IF ll_NoMatch
        lc_OldAlias = ALIAS()

        *-- Call g_prvfrx with temporary frx and temporary dummy table
        DO g_prvfrx WITH g_pnorec(.t., lc_frmfile)

        *-- Call without parameters to erase the created temporary files
        = g_pnorec()

        *-- Restore back the alias
        go_SQL.m_TableChangeCurrent(lc_OldAlias)
      ELSE
        DO g_prvfrx WITH lc_frmfile, .f., ll_NoSelrpt
      ENDIF

      IF ln_bot <= 0
        EXIT
      ENDIF

    CASE ln_resp = 3
      *-- Print, set print destination flag
      ll_prnt  = .t.

      lc_frmfile = l_getfrx()

      IF ll_cont OR ll_NoMatch

        IF ll_NoMatch
          lc_OldAlias = ALIAS()

          *-- Call g_pnorec to create temporary frx and temporary dummy table for preview/print
          lc_frmfile = g_pnorec(.t., lc_frmfile)
        ENDIF

        DO g_prnrp WITH .t., .f., ll_export, .f., ll_NoSelrpt

        IF ll_NoMatch
          *-- Call without parameters to erase the created temporary files
          = g_pnorec()

          *-- Restore back the alias
          go_SQL.m_TableChangeCurrent(lc_OldAlias)
        ENDIF

      ENDIF

    CASE ln_resp = 4
      *-- Edit
      ll_gened = .f.
      ll_custfrx = .f.

      go_sql.m_closeTableAll()

      *-- Reset value
      ll_NoMatch = .f.

      DO l_clrtmp
      *# DOCCODE DO icopnf
      *# DOCCODE DO aropnf
      *# DOCCODE DO soopnf
      DO (gc_adrvprg + gc_applid + "opnf") WITH .f.

      IF lc_rept = "T06"
        *-- Open General Ledger Account File
        ln_opnglac = g_opnfl(gf_glacntf, "a_glacnt", .f., .f., "glacnt")

        *-- Make beg' accnt blank if filled with zero's.
        IF lc_baccnt = lc_0accnt
          lc_baccnt = TRANSFORM(REPLICATE(SPACE(1), ;
                      LEN(gc_acctpic)), gc_acctpic)
        ENDIF

        *-- Make end accnt blank if filled with nine's.
        IF lc_eaccnt = lc_9accnt
          lc_eaccnt   = TRANSFORM(REPLICATE(SPACE(1), ;
                        LEN(gc_acctpic)), gc_acctpic)
        ENDIF

      ENDIF

*\ [1 Line] PTR 82565 04/28/06 TIRS Refresh the option grid for Inv Issue and receipts
      IF lc_rept $ "F10~F11~F12~S02~S07~T06~T02~T03"
        *-- Repaint grid if conditional secondary options exist for report
        ACTIVATE WINDOW lw_rept NOSHOW TOP

        *-- Clear old options
        DO g_dspgd WITH "Option Grid - " + lc_optitle + "Report:", (ln_bot), ;
                        .f., 0, .t.
      ENDIF

      LOOP

    CASE ln_resp >= 5
      *-- Cancel, set continuation flag
      ll_custfrx = .f.
      ll_cont = .f.
      EXIT

  ENDCASE

  ERASE (gc_idrvtmp + gc_tmpf5 + ".frx")
  ERASE (gc_idrvtmp + gc_tmpf5 + ".frt")

  ll_cont = .t.

ENDDO && WHILE .t.

*-- Reset printer
SET PRINTER TO

*-- Display sign of life
DO g_dspst WITH "Returning to Main Menu...", ;
                .t., gn_msgline, SPACE(0), SPACE(0), SPACE(0)

go_sql.m_closeTableAll()

*-- Erase temporary files
DO l_clrtmp

*# DOCCODE DO icopnf
*# DOCCODE DO aropnf
*# DOCCODE DO soopnf

*-- Reset printer
SET PRINTER TO

*-- Release windows
RELEASE WINDOWS lw_rept

*-- Reset any disabled MDI forms and its hotkeys
= g_setmdi(.f.)

*-- Restore environment state

*-- Reset century
IF lc_century = "ON"
  SET CENTURY ON
ELSE
  SET CENTURY OFF
ENDIF

*-- Refresh status message
DO g_dspst WITH (gc_task), .t., gn_msgline, SPACE(0), SPACE(0), SPACE(0)

*-- Reset to standard portrait on exit
gl_landscp = .f.

*\ [1 Line] PTR 83281 06/23/06 SGOU Disable print icon in preview
*-- reset the flag to allow print button in preview toolbar
gl_PreviewPrinting = .t.

RETURN
*------------------------------------------------------------------------------
*- End Main: ICREPT.PRG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_GETOP
*------------------------------------------------------------------------------
*- Description: Get grid options
*------------------------------------------------------------------------------
*- Synopsis...: Display option grid and enter report options.
*------------------------------------------------------------------------------
*- Calls......: G_DSPCH, G_SAYOP, G_VLDDT(), G_WINGET()
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*-              ls_rept, report window
*-              lc_rept, report identifier
*-
*- Parameters.: None
*-
*- Files Open.: None
*-
*- Objects....: Assumes windows lw_rept
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: option variables - values determined by grid selection
*-              ln_bsess, row position for beginning session number
*-              ln_esess, row position for ending session number
*------------------------------------------------------------------------------
PROCEDURE l_getop

  PRIVATE ln_line, ;
          ll_read, ;
          ll_srl

  ll_srl  = .f.
  ll_read = .t.

  *-- Reset application var
  lc_applid = IIF(EMPTY(lc_xapplid), lc_applid, lc_xapplid)

  *-- Activate report window
  ACTIVATE WINDOW lw_rept TOP

  *-- Set grid entry line
  ln_line = 4

  *-- Display menu options
  DO g_dspch

  *-- Enter options
  DO CASE
    CASE lc_rept = "F01"
      *-- Inventory File

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      IF gl_locts
        @ ln_line, 57 GET lc_loctid PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(portion or blank for all)"
      ENDIF

      *-- HOOK BEGIN: <ACS>: Expand Options
      *-- Note: hook added if/else/endif structure around existing code
      IF gl_acs AND gl_acs_upos
        lc_lookup = ALLTRIM(gc_lookup)
        @ ln_line, 57 GET lc_order PICTURE "@M Description, Item, &lc_lookup."
        DO g_sayop WITH ln_line, "Order By", "{Description/Item/&lc_lookup.}"
      ELSE
        @ ln_line, 57 GET lc_order PICTURE "@M Description, Item"
        DO g_sayop WITH ln_line, "Order By", "{Description/Item}"
      ENDIF
	  *-- HOOK END: <ACS>: Expand Options

      @ ln_line, 57 GET lc_bdate PICTURE gc_datepi8 ;
                        VALID g_valdte()
      DO g_sayop WITH ln_line, "Last Sold", "(sold after or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_vpartno PICTURE gc_ItemPic ;
                                   SIZE 1, MIN(LEN(gc_ItemPic), 20)
      DO g_sayop WITH ln_line, "Part Number", "(portion or blank for all)"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"
      
   	  @ ln_line, 57 GET lc_status PICTURE "@M All,Active,Inactive"
      DO g_sayop WITH ln_line, "Item Status", "{All/Active/Inactive}"                      

    CASE lc_rept = "F02"
      *-- Inventory by location

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"
      
   	  @ ln_line, 57 GET lc_status PICTURE "@M All,Active,Inactive"
      DO g_sayop WITH ln_line, "Item Status", "{All/Active/Inactive}"                      

    CASE lc_rept = "F03"
      *-- Inventory Distribution by Value

      @ ln_line, 57 GET ln_minamt PICTURE "#########.##"
      DO g_sayop WITH ln_line, "Minimum Value", ;
                      "(Include values >= this amount)"

      lc_type    = "All     "
      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Stock,Nonstock"

      DO g_sayop WITH ln_line, "Include Only", "{All/Stock/Nonstock}"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_bdate PICTURE gc_datepi8 ;
                        VALID g_valdte()

      DO g_sayop WITH ln_line, "Last Sold", "(sold after or blank for all)"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

    CASE lc_rept = "F05"
      *-- Inventory Suppliers

      = g_getop(ln_line, 57, "lc_bvendno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                  "", "", "", "V", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Vendor", "(<F2> to list, first or blank for all)"
      = g_getop(ln_line, 57, "lc_evendno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                  "", "", "", "V", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Vendor", "(<F2> to list, last or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_bvprtno PICTURE gc_ItemPic ;
                                   SIZE 1, MIN(LEN(gc_ItemPic), 20)
      DO g_sayop WITH ln_line, "Begin Part Num", "(first or blank for all)"

      @ ln_line, 57 GET lc_evprtno PICTURE gc_ItemPic ;
                                   SIZE 1, MIN(LEN(gc_ItemPic), 20)
      DO g_sayop WITH ln_line, "Ending Part Num", "(last or blank for all)"

      @ ln_line, 57 GET lc_brate PICTURE "!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_erate PICTURE "!!!"
      DO g_sayop WITH ln_line, "Rating Code", "(range or blank for all)"
      
   	  @ ln_line, 57 GET lc_status PICTURE "@M All,Active,Inactive"
      DO g_sayop WITH ln_line, "Item Status", "{All/Active/Inactive}"                      

    CASE lc_rept = "F06"
      *-- Lot File
      @ ln_line, 57 GET lc_blot PICTURE "!!!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_elot PICTURE "!!!!!!!!"
      DO g_sayop WITH ln_line, "Lot ID", "(range or blank for all)"

*\ [1 Line] PTR # 77525 10/26/04 TIJH Added Filter condition for pick list
      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "uselots <> 'N'", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

*\ [1 Line] PTR # 77525 10/26/04 TIJH Added Filter condition for pick list
      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "uselots <> 'N'", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "F07"
      *-- Location File

      IF lc_loctype = "H"
        lc_loctype = "Warehouse "
      ENDIF

*\ [Begin] PTR # 81862 - SSHA Added new location types
      @ ln_line, 57 GET lc_loctype ;
                        PICTURE "@M All,Receiving,Shipping,Warehouse,Production,Repair,Scrap"

      DO g_sayop WITH ln_line, PROPER(gc_loct) + " Type ", ;
                      "{All/Prod/Rcv/Ship/Warehouse/Repair/Scrap}"
*\ [End] PTR # 81862 - SSHA Added new location types

      @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, PROPER(gc_loct) + " ID", ;
                      "(range or blank for all)"

    CASE lc_rept = "F08"
      *-- Product Line File

      @ ln_line, 57 GET lc_bpline PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_epline PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Product Line ID", "(range or blank for all)"

    CASE lc_rept = "F09"
      *-- Units of Measure File

      @ ln_line, 57 GET lc_bunms PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eunms PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "U/M ID", "(range or blank for all)"

    CASE lc_rept = "F10"
      *-- Item Price List
      @ ln_line, 57 GET lc_type PICTURE ;
                        "@M All          , Stock only   , Nonstock only"

      DO g_sayop WITH ln_line, "Include Only", ;
                      "{All/Stock only/Nonstock only}"

      = g_getop(ln_line, 57, "lc_item", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, portion or blank for all)"

      @ ln_line, 57 GET lc_class PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Inventory Class", "(portion or blank for all)"

      @ ln_line, 57 GET lc_code PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Misc Code", "(portion or blank for all)"

      @ ln_line, 57 GET lc_zero PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "Include 0 Price", ;
                       "(include 0 price items, Yes/No)"

      @ ln_line, 57 GET lc_reptyp PICTURE "@M List prices,Price codes," + ;
                        "Both       "
      DO g_sayop WITH ln_line, "Report Type", ;
                      "{List prices/Price codes/Both}"

      ACTIVATE WINDOW lw_rept

      *-- Call special READ function
      = g_read()

      IF INLIST(lc_reptyp, "Price codes", "Both") AND ;
         LASTKEY() <> gk_esc

        @ ln_line, 57 GET lc_psched PICTURE "!!!"
        DO g_sayop WITH ln_line, "Price Code", "(portion or blank for all)"

        IF gc_pmarkup = "L" AND gl_locts
          @ ln_line, 57 GET lc_loctid PICTURE "!!!!!!"
          DO g_sayop WITH ln_line, "Location Code", "(portion or blank for all)"
        ENDIF

        *-- Added line to specify type of scheme to report on
        @ ln_line, 57 GET lc_popt PICTURE "@M Item,Customer,Special,All"
        DO g_sayop WITH ln_line, "Pricing Type", "{Item/Customer/Special/All}"

        ACTIVATE WINDOW lw_rept

        *-- Call special READ function
        = g_read()

        IF lc_popt = "Customer" AND ;
           LASTKEY() <> gk_esc
          *-- Added line to specify customer if Customer type selected
          @ ln_line, 57 GET lc_scust PICTURE "!!!!!!" ;
                            VALID l_vcust("lc_scust")
          DO g_sayop WITH ln_line, "Customers", ;
                          "(<F2> to list or blank for all)"
        ELSE
          ll_read = .f.
        ENDIF

      ELSE
        ll_read = .f.
      ENDIF

    CASE lc_rept = "F11" OR lc_rept = "F12"
      *-- Beginning price group code
      @ ln_line, 57 GET lc_frpgrp PICTURE REPLICATE("!", 15)
      DO g_sayop WITH ln_line, "Beginning Group", "(First or blank for all)"

      *-- Ending price group code
      @ ln_line, 57 GET lc_topgrp PICTURE REPLICATE("!", 15)
      DO g_sayop WITH ln_line, "Ending Group", "(Last or blank for all)"

    CASE lc_rept = "S01"
      *-- Aggregate Summary

      @ ln_line, 57 GET lc_onhand PICTURE "@M All,Onhand"
      DO g_sayop WITH ln_line, "Include Only", "{All/Onhand greater than 0}"

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M Inventory,Asset,Expense,All"

      DO g_sayop WITH ln_line, "Item Type ", "{Inventory/Asset/Expense/All}"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_bvprtno PICTURE gc_ItemPic ;
                                   SIZE 1, MIN(LEN(gc_ItemPic), 20)
      DO g_sayop WITH ln_line, "Begin Part Number", "(first or blank for all)"

      @ ln_line, 57 GET lc_evprtno PICTURE gc_ItemPic ;
                                   SIZE 1, MIN(LEN(gc_ItemPic), 20)
      DO g_sayop WITH ln_line, "End Part Number", "(last or blank for all)"

    CASE lc_rept = "S02"
      *-- Inventory On Hand

      @ ln_line, 57 GET lc_gtasof PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "As of Report? ", "As of a given date"

      ACTIVATE WINDOW lw_rept

      *-- Call special READ function
      = g_read()

      IF LASTKEY() <> gk_esc

        IF lc_gtasof = "Yes"
          @ ln_line, 57 GET lc_asofdt ;
                            PICTURE gc_datepi8 VALID l_valdte()
         DO g_sayop WITH ln_line, "As of Date", ;
                         "(Inventory on hand as of this date)"
        ELSE

          lc_asofdt = Cc_NullDate
          ld_asofdt = {}
        ENDIF

      ELSE
        lc_gtasof = "No "
        lc_asofdt = Cc_NullDate
        ld_asofdt = {}
      ENDIF

      IF lc_detail = "D"
        @ ln_line, 57 GET lc_sort PICTURE "@M Item," + gc_loct + ;
                          ",Account"

        DO g_sayop WITH ln_line, "Sort Items By", "{Item/" + ;
                        gc_loct + "/Account}"

        *-- Call special READ function
        = g_read()
      ENDIF

      IF LASTKEY() <> gk_esc

        IF LEFT(lc_sort, 1) = "A"
          @ ln_line, 57 GET lc_group PICTURE "@M Item      ," + gc_loct
          DO g_sayop WITH ln_line, "Group Items By", "{Item/" + ;
                          gc_loct + "}"

        ELSE
          @ ln_line, 57 GET lc_group PICTURE "@M Class,Comm. Code,None"
          DO g_sayop WITH ln_line, "Group Items By", "{Class/Comm. Code/None}"
        ENDIF

        @ ln_line, 57 GET lc_onhand ;
                          PICTURE "@M All,Onhand,Shortage,Less than 0,Nonzero"

        DO g_sayop WITH ln_line, "Include Only", ;
                       "{All/Onhnd>0/Onhnd<=0/Onhnd<0/#0}"

        IF gl_locts
          @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
          @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
          DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
        ENDIF

        @ ln_line, 57 GET lc_type ;
                          PICTURE "@M Inventory,Asset,Expense,All"

        DO g_sayop WITH ln_line, "Item Type ", "{Inventory/Asset/Expense/All}"

        @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

        @ ln_line, 57 GET lc_bccode PICTURE "!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
        DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

        = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
        DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

        = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
        DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"
      ENDIF

    CASE lc_rept = "S03"
      *-- Usage By Location

      @ ln_line, 57 GET lc_sort PICTURE "@M Sales Qty,Sales Value," + ;
                        "Usage Qty,Usage Value"

      DO g_sayop WITH ln_line, "Report Order", ;
                     "{Sls Qty/Sls Val/Use Qty/Use Val}"

      @ ln_line, 57 GET lc_inczero PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "Include", "Zero Usage Items"

      @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "S04"
      *-- Location Detail

      *-- If using locations
      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
        @ ln_line, 57 GET lc_group PICTURE "@M Item," + gc_loct
        DO g_sayop WITH ln_line, "Group By", "{Item/" + gc_loct + "}"
      ENDIF

      *-- If using stores
      IF gl_store
        @ ln_line, 57 GET lc_bstore PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Beginning " + PROPER(gc_store), ;
                        "(first or blank for all)"
        @ ln_line, 57 GET lc_estore PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Ending " + PROPER(gc_store), ;
                        "(last or blank for all)"
      ENDIF

      *-- If using bins
      IF gl_bin
        @ ln_line, 57 GET lc_bbin PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Beginning " + PROPER(gc_bin), ;
                        "(first or blank for all)"
        @ ln_line, 57 GET lc_ebin PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Ending " + PROPER(gc_bin), ;
                        "(last or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "S06"
      *-- Recommended Reorders
      @ ln_line, 57 GET lc_order PICTURE "@M " + gc_loct + ;
                        ",Def. Supplier"
      DO g_sayop WITH ln_line, "Group Items By", "{" + gc_loct + ;
                      "/Def. Supplier}"

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory}"

      @ ln_line, 57 GET lc_inczero PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "Include", "Zero Order Point Items {Yes/No}"

      @ ln_line, 57 GET lc_incld PICTURE "@M All items,Below reorder point"
      DO g_sayop WITH ln_line, "Include", "(All items/Below reorder point)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      = g_getop(ln_line, 57, "lc_bvendno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                  "", "", "", "V", "", .t., .t.)
      DO g_sayop WITH ln_line, "Begin Supplier", "(<F2> to list, first or blank for all)"
      = g_getop(ln_line, 57, "lc_evendno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                  "", "", "", "V", "", .t., .t.)
      DO g_sayop WITH ln_line, "End Supplier", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_uomin ;
                        PICTURE "@M Transaction Unit,Stock Unit,Both"

      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction Unit/Stock Unit/Both}"

    CASE lc_rept = "S07"
      *-- Slow Moving Items
      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M Turnover, Usage"

      DO g_sayop WITH ln_line, "Type", "{Sales Turnover/Periodic Usage}"

      ACTIVATE WINDOW lw_rept

      *-- Call special READ function
      = g_read()

      IF LASTKEY() <> gk_esc
        ACTIVATE WINDOW lw_rept

        IF lc_type = "Usage"
          @ ln_line, 57 GET ln_units PICTURE "99999999999"
          DO g_sayop WITH ln_line, "Usage Threshold", "(Maximum Units Sold)"

          @ ln_line, 57 GET lc_per PICTURE "@M 12, 15, 18, 24, 36"
          DO g_sayop WITH ln_line, "Report Period", "{12/15/18/24/36}"
        ENDIF

        @ ln_line, 57 GET lc_resell PICTURE "@M All, Resellable Stock"
        DO g_sayop WITH ln_line, "Include Items", ;
                        "{All/Resellable Stock}"
        IF gl_locts
          @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
          @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
          DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
        ENDIF

        @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

        @ ln_line, 57 GET lc_bccode PICTURE "!!"
        @ ln_line, COL() + 1SAY "To" GET lc_eccode PICTURE "!!"
        DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

        = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
        DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

        = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                    "", "", "", "I", "", .t., .t.)
        DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"
      ENDIF

    CASE lc_rept = "S08"
      *-- Alternate Items

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "S09"
      *-- Physical Inventory Sheet

      *-- If using locations
      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      *-- If using stores
      IF gl_store
        @ ln_line, 57 GET lc_bstore PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Beginning " + PROPER(gc_store), ;
                        "(first or blank for all)"
        @ ln_line, 57 GET lc_estore PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Ending " + PROPER(gc_store), ;
                         "(last or blank for all)"
      ENDIF

      *-- If using bins
      IF gl_bin
        @ ln_line, 57 GET lc_bbin PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Beginning " + PROPER(gc_bin), ;
                        "(first or blank for all)"

        @ ln_line, 57 GET lc_ebin PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Ending " + PROPER(gc_bin), ;
                        "(last or blank for all)"

      ENDIF

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_zero PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "Include 0 Qty", ;
                     "(include 0 Quantity items, Yes/No)"

    CASE lc_rept = "S11"
      *-- Inventory Analysis Report

      @ ln_line, 57 GET lc_per PICTURE "##"
      DO g_sayop WITH ln_line, "Report Periods", "{1-36}"

      @ ln_line, 57 GET lc_sort PICTURE "@M Sales Qty,Sales Value," + ;
                         "Usage Qty,Usage Value"

      DO g_sayop WITH ln_line, "Based on", ;
                      "{Sls Qty/Sls Val/Use Qty/Use Val}"

      @ ln_line, 57 GET lc_inczero PICTURE "@M Yes, No "

*\ [1 Line] PTR 73877 10/27/04 TIMI Option grid text altered
      DO g_sayop WITH ln_line, "Include", "Zero YTD Usage Items"


*\ [2 Lines] PTR 73877 10/27/04 TIMI Added new option in option grid
      @ ln_line, 57 GET lc_inctotzero PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "Include", "Zero Total Sales Items"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "S13"
      *-- Costing Tiers

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_loctid PICTURE (gc_locpic)
        DO g_sayop WITH ln_line, (PROPER(gc_loct)), ;
                        "(portion or blank for all)"
      ENDIF

    CASE lc_rept = "S14"
      *-- ABC Exception

      @ ln_line, 57 GET lc_type PICTURE "@M Usage,Value"
      DO g_sayop WITH ln_line, [Based on], [{Usage/Value}]

      @ ln_line, 57 GET ln_abpct PICTURE "##.#"
      DO g_sayop WITH ln_line, ["A-B" Breakpoint], [% to include in "A"]

      @ ln_line, 57 GET ln_bcpct PICTURE "##.#"
      DO g_sayop WITH ln_line, ["B-C" Breakpoint], [% to include in "C"]

    CASE lc_rept = "S15"
      *-- Serial/Lot Stock Status

      lc_opstrng = "Item"

      IF gl_locts
        lc_opstrng = lc_opstrng + "," + PROPER(gc_loct)
      ENDIF

      @ ln_line, 57 GET lc_order PICTURE "@M " + lc_opstrng
      DO g_sayop WITH ln_line, "Order By", ;
                       "{Item/" + PROPER(gc_loct) + "}"

      @ ln_line, 57 GET lc_incld PICTURE "@M All items, Overshipments"
      DO g_sayop WITH ln_line, "Include Only", "{All items/Overshipments}"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      IF gl_lots
        @ ln_line, 57 GET lc_blot PICTURE "!!!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_elot PICTURE "!!!!!!!!"
        DO g_sayop WITH ln_line, "Lot", "(range or blank for all)"
      ENDIF

      IF gl_serial
        @ ln_line, 57 GET lc_bserial PICTURE REPLICATE("!", 20)
        DO g_sayop WITH ln_line, "Beg Serial Number", "(first or blank for all)"

        @ ln_line, 57 GET lc_eserial PICTURE REPLICATE("!", 20)
        DO g_sayop WITH ln_line, "End Serial Number", "(last or blank for all)"
      ENDIF

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "T01"
      *-- Consolidated Transactions
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                       "(range or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_order ;
                       PICTURE "@M Date,Source"

      DO g_sayop WITH ln_line, "Order By", "{Date/Source}"

      @ ln_line, 57 GET lc_uomin ;
                        PICTURE "@M Transaction Unit,Stock Unit,Both"

      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction Unit/Stock Unit/Both}"

    CASE lc_rept = "T02"
      *-- Inventory Issues
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	       DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      *-- Develope options based on installed programs
      lc_opstrng  = "All Issues,IC Issues"
      lc_apstrng  = "{All/IC"

      IF gl_ar
        lc_opstrng = lc_opstrng + ",AR Invoices"
        lc_apstrng = lc_apstrng + "/AR"
      ENDIF

      IF gl_po
        lc_opstrng = lc_opstrng + ",PO Returns"
        lc_apstrng = lc_apstrng + "/PO"
      ENDIF

      IF gl_so
        lc_opstrng = lc_opstrng + ",SO Shipments"
        lc_apstrng = lc_apstrng + "/SO"
      ENDIF
*\ [4 Lines] PTR# 83376 06/27/07 TINA Checked the gl_rm and Added RM Issues to Appl list
      IF gl_rm
        lc_opstrng = lc_opstrng + ",RM Issues"
        lc_apstrng = lc_apstrng + "/RM"
      ENDIF

      IF gl_bp
        lc_opstrng = lc_opstrng + ",BOM explosions"
        lc_apstrng = lc_apstrng + "/BM"
      ENDIF

*\ [2 Lines] PTR 82565 04/28/06 TIRS Add InterCompany option to application
      lc_apstrng = lc_apstrng + "/InterCompany"
      lc_opstrng = lc_opstrng + ",InterCompany"

      lc_apstrng = lc_apstrng + "}"

      @ ln_line, 57 GET lc_applid PICTURE "@M  " + lc_opstrng
      DO g_sayop WITH ln_line, "Application", lc_apstrng

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                     "(range or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service  "

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1  SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_order ;
                       PICTURE "@M Date,Item,Source,Transaction"

      DO g_sayop WITH ln_line, "Order By", "{Date/Item/Source/Transaction}"

      @ ln_line, 57 GET lc_uomin ;
                        PICTURE "@M Transaction Unit,Stock Unit,Both"

      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction Unit/Stock Unit/Both}"

*\ [Begin] PTR 82565 04/28/06 TIRS Implementation of Inter Company transfers
      ACTIVATE WINDOW lw_Rept

      *-- Read the current inputs here
      = g_read()

      *-- Only for All Issues and Inter company transfers throw the
      *-- options Begin and ending company to the user
      IF LASTKEY() <> gk_esc AND (INLIST(ALLTRIM(lc_applid), "InterCompany", "All Issues"))
        @ ln_line, 57 GET lc_BComp PICTURE "!!!!!!!!!!"
        DO g_sayop WITH ln_line, "Beg Comp Issue to", "(range or blank for all)"

        @ ln_line, 57 GET lc_EComp PICTURE "!!!!!!!!!!"
        DO g_sayop WITH ln_line, "End Comp Issue to", "(range or blank for all)"
      ENDIF
*\ [End] PTR 82565 04/28/06 TIRS Implementation of Inter Company transfers

    CASE lc_rept = "T03"
      *-- Inventory Receipts
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      *-- Develope options based on installed programs
      lc_opstrng   = "All Receipts,IC Receipts"
      lc_apstrng   = "{All/IC"

      IF gl_ar
        lc_opstrng = lc_opstrng + ",AR Credit Memos"
        lc_apstrng = lc_apstrng + "/AR"
      ENDIF

      IF gl_po
        lc_opstrng = lc_opstrng + ",PO Receipts"
        lc_apstrng = lc_apstrng + "/PO"
      ENDIF

      IF gl_so
        lc_opstrng = lc_opstrng + ",SO Returns"
        lc_apstrng = lc_apstrng + "/SO"
      ENDIF

*\ [4 Lines] PTR# 83376 06/27/07 TINA Checked the gl_rm and Added RM receipts to Appl list
      IF gl_rm
        lc_opstrng = lc_opstrng + ",RM Repl Receipts "
        lc_apstrng = lc_apstrng + "/RM"
      ENDIF

      IF gl_bp
        lc_opstrng = lc_opstrng + ",BP explosions"
        lc_apstrng = lc_apstrng + "/BP"
      ENDIF

*\ [2 Lines] PTR 82565 04/28/06 TIRS Add InterCompany option to application
      lc_apstrng = lc_apstrng + "/InterCompany"
      lc_opstrng = lc_opstrng + ",InterCompany"

      lc_apstrng = lc_apstrng + "}"

      @ ln_line, 57 GET lc_applid PICTURE "@M  " + lc_opstrng
      DO g_sayop WITH ln_line, "Application", lc_apstrng

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                      "(range or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_order ;
                       PICTURE "@M Account,Date,Source "

      DO g_sayop WITH ln_line, "Order By", "{Account/Date/Source}"

      @ ln_line, 57 GET lc_uomin ;
                        PICTURE "@M Transaction Unit,Stock Unit,Both"

      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction Unit/Stock Unit/Both}"

*\ [Begin] PTR 82565 04/28/06 TIRS Implementation of Inter Company transfers
      ACTIVATE WINDOW lw_Rept

      *-- Read the current inputs here
      = g_read()

      *-- Only for All Issues and Inter company transfers throw the
      *-- options Begin and ending company to the user
      IF LASTKEY() <> gk_esc AND (INLIST(ALLTRIM(lc_applid), "InterCompany", "All Receipts"))
        @ ln_line, 57 GET lc_BComp PICTURE "!!!!!!!!!!"
        DO g_sayop WITH ln_line, "Beg Comp Rcd from", "(range or blank for all)"

        @ ln_line, 57 GET lc_EComp PICTURE "!!!!!!!!!!"
        DO g_sayop WITH ln_line, "End Comp Rcd from", "(range or blank for all)"
      ENDIF
*\ [End] PTR 82565 04/28/06 TIRS Implementation of Inter Company transfers

*\ [Begin] PTR 83058 07/10/06 TIRS Display option grid for unposted intercomp reciepts
    CASE lc_Rept = "T11"
      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                      "(range or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_BComp PICTURE "!!!!!!!!!!"
      DO g_sayop WITH ln_line, "Beginning company", "(range or blank for all)"

      @ ln_line, 57 GET lc_EComp PICTURE "!!!!!!!!!!"
      DO g_sayop WITH ln_line, "Ending company", "(range or blank for all)"
*\ [End] PTR 83058 07/10/06 TIRS Display option grid for unposted intercomp reciepts

    CASE lc_rept = "T04"
      *-- Inventory Adjustments
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

*\ [1 Line] PTR# 67009 04/06/05 TINN Removed checking of gl_sbtmod to support date range
      @ ln_line, 57 GET lc_bdate ;
                          PICTURE gc_datepi8 ;
                          VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                          PICTURE gc_datepi8 ;
                                          VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                        "(range or blank for all)"

      @ ln_line, 57 GET lc_adjtype ;
                        PICTURE "@M All,Adjusting,Physical,Recosting"

      DO g_sayop WITH ln_line, "Adjustment Type ", ;
                      "{All/Adjusting/Physical/Recosting}"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory}"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_uomin ;
                        PICTURE "@M Transaction Unit,Stock Unit,Both"

      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction Unit/Stock Unit/Both}"

    CASE lc_rept = "T05"
      *-- Stock Transfers
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	       @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	       DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transfer Date", ;
                      "(range or blank for all)"

*\ [3 Lines] PTR 83055 05/31/06 TIRS Code change to fit in Intercompany Issue and Receipt
      lc_type = PADR(lc_type, 20)
      @ ln_line, 57 GET lc_type PICTURE "@M All,Issue,Receipt,Intercompany Issue, Intercompany Receipt"
      DO g_sayop WITH ln_line, "Transfer Type","{All/Issue/Receipt/Intercompany (Issue/Receipt)}"

      @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, PROPER(gc_loct), ;
                      "(range or blank for all)"

      IF gl_store
        @ ln_line, 57 GET lc_bstore PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Beginning " + PROPER(gc_store), ;
                        "(first or blank for all)"

        @ ln_line, 57 GET lc_estore PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Ending " + PROPER(gc_store), ;
                        "(last or blank for all)"

      ENDIF

      IF gl_bin
        @ ln_line, 57 GET lc_bbin PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Beginning " + PROPER(gc_bin), ;
                         "(first or blank for all)"

        @ ln_line, 57 GET lc_ebin PICTURE REPLICATE("!", 15)
        DO g_sayop WITH ln_line, "Ending " + PROPER(gc_bin), ;
                         "(last or blank for all)"
      ENDIF

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_uomin ;
                        PICTURE "@M Transaction Unit,Stock Unit,Both"

      DO g_sayop WITH ln_line, "Quantity in", ;
                      "{Transaction Unit/Stock Unit/Both}"

    CASE lc_rept = "T06"
      *-- Inventory Journal Report
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      *-- Develop options based on installed programs
      lc_opstrng = "All Transactions,IC Transactions"
      lc_apstrng = "{All/IC"

      IF gl_ar
        lc_opstrng = lc_opstrng + ",AR Transactions"
        lc_apstrng = lc_apstrng + "/AR"
      ENDIF

      IF gl_po
        lc_opstrng = lc_opstrng + ",PO Transactions"
        lc_apstrng = lc_apstrng + "/PO"
      ENDIF

      IF gl_so
        lc_opstrng = lc_opstrng + ",SO Transactions"
        lc_apstrng = lc_apstrng + "/SO"
      ENDIF

*\ [Begin] PTR 79484 06/06/05 KGUP Add option to select PE & WO transactions
      IF gl_laheype OR gl_laheypl
        lc_opstrng = lc_opstrng + ",PE Transactions"
        lc_apstrng = lc_apstrng + "/PE"
      ENDIF

      IF gl_laheywo
        lc_opstrng = lc_opstrng + ",WO Transactions"
        lc_apstrng = lc_apstrng + "/WO"
      ENDIF
*\ [End] PTR 79484 06/06/05 KGUP Add option to select PE & WO transactions

      lc_apstrng = lc_apstrng + "}"

      @ ln_line, 57 GET lc_applid PICTURE "@M  " + lc_opstrng
      DO g_sayop WITH ln_line, "Application", lc_apstrng

      IF LEN(gc_acctpic) <= 21
        *-- Enough room in grid
        @ ln_line, 57 GET lc_baccnt PICTURE gc_acctpic ;
                          VALID l_selact(@lc_baccnt, .t.)
      ELSE
        *-- Activate a windowed get
        @ ln_line, 57 GET lc_baccnt PICTURE LEFT(gc_acctpic, 21) ;
                          WHEN g_winget(gc_acctpic, "Beginning Account", ;
                          "", "l_selact(@lc_baccnt, .t.)")
      ENDIF

      DO g_sayop WITH ln_line, "Beginning Account", "(<F2> to list or" + ;
                      " blank for all)"

      IF LEN(gc_acctpic) <= 21
        *-- Enough room in grid
        @ ln_line, 57 GET lc_eaccnt PICTURE gc_acctpic ;
                          VALID l_selact(@lc_eaccnt, .t.)
      ELSE
        *-- Activate a windowed get
        @ ln_line, 57 GET lc_eaccnt PICTURE LEFT(gc_acctpic, 21) ;
                          WHEN g_winget(gc_acctpic, "Ending Account", ;
                          "", "l_selact(@lc_eaccnt, .t.)")
      ENDIF

      DO g_sayop WITH ln_line, "Ending Account", "(<F2> to list or" + ;
                      " blank for all)"

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                      "(range or blank for all)"

      @ ln_line, 57 GET lc_nrange PICTURE "@M Session, Batch  "
     DO g_sayop WITH ln_line, "Range Numbers", "{Session/Batch}"

      ACTIVATE WINDOW lw_rept

      *-- Call special READ function
      = g_read()

      IF  LASTKEY() <> gk_esc
        ACTIVATE WINDOW lw_rept

        IF lc_nrange = "Batch  "
          *-- initialize variables needed for validation routine
          ln_bbatch = ln_line
          ln_ebatch = ln_line

          *-- Set default to last batch
          IF lc_lbatch <> SPACE(6)
            lc_bbatch = lc_lbatch
            lc_ebatch = lc_lbatch
          ENDIF

          lc_bbatch = IIF(EMPTY(lc_bbatch), ;
                      "000000", ;
                      TRANSFORM(VAL(lc_bbatch), ;
                      "@L 999999"))

          lc_ebatch = IIF(EMPTY(lc_ebatch), ;
                      "999999", ;
                      TRANSFORM(VAL(lc_ebatch), ;
                      "@L 999999"))

          @ ln_line, 57 GET lc_bbatch PICTURE "@K ######"
          @ ln_line, COL() + 1 GET lc_ebatch PICTURE "@K ######"
          DO g_sayop WITH ln_line, "Batch Range", "(blank for all)"

          @ ln_line, 57 GET lc_order ;
                            PICTURE "@M Account,Batch  ,Date   ,Source "

          DO g_sayop WITH ln_line, "Order By", "{Account/Batch/Date/Source}"
        ELSE
          *-- Session numbers
          ln_bsess = ln_line
          ln_esess = ln_line
          @ ln_line, 57 GET lc_bsess PICTURE "@K ######"
          @ ln_line, COL() + 1 SAY "To" GET lc_esess PICTURE "@K ######"
          DO g_sayop WITH ln_line, "Session", "(range or blank for all)"

         @ ln_line, 57 GET lc_order ;
                            PICTURE "@M Account,Session,Date   ,Source "

          DO g_sayop WITH ln_line, "Order By", "{Account/Session/Date/Source}"
        ENDIF

      ENDIF

    CASE lc_rept = "T07"
      *-- Sales History
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      *-- Develop options based on installed programs

      DO CASE
        CASE gl_ar AND NOT gl_so
          lc_opstrng = "AR"
          lc_applid  = "AR"
        CASE gl_so AND NOT gl_ar
          lc_opstrng = "SO"
          lc_applid  = "SO"
        CASE gl_ar AND gl_so
          lc_opstrng = "AR,SO,Both"
          lc_applid  = "Both"
          @ ln_line, 57 GET lc_applid PICTURE "@M  " + lc_opstrng
          DO g_sayop WITH ln_line, "Application", "{AR/SO/Both}"
      ENDCASE

*\ [Begin] PTR# 78641 06/16/05 TISJ Added date range in option grid
      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                      "(range or blank for all)"
*\ [End] PTR# 78641 06/16/05 TISJ Added date range in option grid

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "T08"
      *-- Serial Lot Issue History
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	      DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      *-- Develope options based on installed programs
      lc_opstrng  = "All Issues,IC Issues"
      lc_apstrng  = "{All/IC"

      IF gl_ar
        lc_opstrng = lc_opstrng + ",AR Invoices"
        lc_apstrng = lc_apstrng + "/AR"
      ENDIF

      IF gl_po
        lc_opstrng = lc_opstrng + ",PO Returns"
        lc_apstrng = lc_apstrng + "/PO"
      ENDIF

      IF gl_so
        lc_opstrng = lc_opstrng + ",SO Shipments"
        lc_apstrng = lc_apstrng + "/SO"
      ENDIF

*\ [4 Lines] PTR# 83376 06/27/07 TINA Checked the gl_rm and Added RM Issues to Appl list
      IF gl_rm
        lc_opstrng = lc_opstrng + ",RM Issues"
        lc_apstrng = lc_apstrng + "/RM"
      ENDIF

      IF gl_bp
        lc_opstrng = lc_opstrng + ",BP explosions"
        lc_apstrng = lc_apstrng + "/BP"
      ENDIF

      lc_apstrng = lc_apstrng + "}"

      @ ln_line, 57 GET lc_applid PICTURE "@M  " + lc_opstrng
      DO g_sayop WITH ln_line, "Application", lc_apstrng

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Issue Date", ;
                      "(range or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_blot PICTURE "!!!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_elot PICTURE "!!!!!!!!"
      DO g_sayop WITH ln_line, "Lot", "(range or blank for all)"

      @ ln_line, 57 GET lc_bserial PICTURE REPLICATE("!", 20)
      DO g_sayop WITH ln_line, "Beg Serial Number", "(first or blank for all)"

      @ ln_line, 57 GET lc_eserial PICTURE REPLICATE("!", 20)
      DO g_sayop WITH ln_line, "End Serial Number", "(last or blank for all)"

      = g_getop(ln_line, 57, "lc_bcustno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                  "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "Begin Customer", "(<F2> to list, first or blank for all)"
      = g_getop(ln_line, 57, "lc_ecustno", gc_CVNoPic, "1, MIN(LEN(gc_CVNoPic), 20)", ;
                  "", "", "", "C", "", .t., .t.)
      DO g_sayop WITH ln_line, "End Customer", "(<F2> to list, last or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "useserl <> 'N' OR uselots <> 'N'", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "useserl <> 'N' OR uselots <> 'N'", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "T09"
      *-- Cost Variances
*\ [Deleted 2 Lines] PTR# 78641 06/16/05 TISJ Removed Current/History/Both from option grid
*!*	      @ ln_line, 57 GET lc_file PICTURE "@M Current, History, Both"
*!*	     DO g_sayop WITH ln_line, "File to Use", "{Current/History/Both}"

      @ ln_line, 57 GET lc_bdate ;
                        PICTURE gc_datepi8 ;
                        VALID g_valdte()

      @ ln_line, COL() + 1 SAY "To" GET lc_edate ;
                                        PICTURE gc_datepi8 ;
                                        VALID g_chkdt(lc_bdate, lc_edate)

      DO g_sayop WITH ln_line, "Transaction Date", ;
                     "(range or blank for all)"

      IF gl_locts
        @ ln_line, 57 GET lc_bloc PICTURE "!!!!!!"
        @ ln_line, COL() + 1 SAY "To" GET lc_eloc PICTURE "!!!!!!"
        DO g_sayop WITH ln_line, PROPER(gc_loct), "(range or blank for all)"
      ENDIF

      @ ln_line, 57 GET lc_type ;
                        PICTURE "@M All,Asset,Expense,Inventory,Service"

      DO g_sayop WITH ln_line, "Item Type ", "{All/Asset/Expense/Inventory/Svc}"

      @ ln_line, 57 GET lc_bclass PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eclass PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Item Class", "(range or blank for all)"

      @ ln_line, 57 GET lc_bccode PICTURE "!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_eccode PICTURE "!!"
      DO g_sayop WITH ln_line, "Commodity Code ", "(range or blank for all)"

      @ ln_line, 57 GET lc_bmcode PICTURE "!!!!!!"
      @ ln_line, COL() + 1 SAY "To" GET lc_emcode PICTURE "!!!!!!"
      DO g_sayop WITH ln_line, "Misc. Code", "(range or blank for all)"

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

    CASE lc_rept = "T10"
      *-- Serial Number History

      ln_item = ln_line

*\ [1 Line] PTR# 78633 03/08/05 TISD Wasmouse function added to handle mouse click on 'X'
      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", " WASMOUSE() OR l_vitem() ", "I", "useserl <> 'N'", .t., .t.)
      DO g_sayop WITH ln_line, "Item", "(<F2> to list, Enter Item Code)"

      @ ln_line, 57 GET lc_bserial PICTURE REPLICATE("!", 20) WHEN ll_srl
      DO g_sayop WITH ln_line, "Beg Serial Number", "(first or blank for all)"

      @ ln_line, 57 GET lc_eserial PICTURE REPLICATE("!", 20) WHEN ll_srl
      DO g_sayop WITH ln_line, "End Serial Number", "(last or blank for all)"


    CASE lc_rept = "CCW"
      *-- Cycle Count Worksheets

      = g_getop(ln_line, 57, "lc_bitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Beginning Item", "(<F2> to list, first or blank for all)"

      = g_getop(ln_line, 57, "lc_eitem", gc_ItemPic, "1, MIN(LEN(gc_ItemPic), 20)", ;
                  "", "", "", "I", "", .t., .t.)
      DO g_sayop WITH ln_line, "Ending Item", "(<F2> to list, last or blank for all)"

      @ ln_line, 57 GET lc_zero PICTURE "@M Yes, No "
      DO g_sayop WITH ln_line, "Include 0 Qty", ;
                     "(include 0 Quantity items, Yes/No)"

      @ ln_line, 57 GET lc_cntcode PICTURE (d_retfd("ICITEM  ", "CNTCODE", 2))
      DO g_sayop WITH ln_line, "Cycle Count Code", ;
                      "Count code or blank for all"

      @ ln_line, 57 GET lc_abccode PICTURE "@M " + ;
                        (d_retfd("ICITEM  ", "ABCCODE", 2))
      DO g_sayop WITH ln_line, "ABC Code", "(ABC code or blank for all)"

      @ ln_line, 57 GET lc_loctid PICTURE (gc_locpic)
      DO g_sayop WITH ln_line, (PROPER(gc_loct)), "(Portion or blank for all)"

      @ ln_line, 57 GET lc_class PICTURE (d_retfd("ICITEM  ", "ITMCLSS", 2))
      DO g_sayop WITH ln_line, "Class", "(Portion or blank for all)"

      @ ln_line, 57 GET lc_plinid PICTURE (d_retfd("ICITEM  ", "PLINID", 2))
      DO g_sayop WITH ln_line, "Product Line", "(Portion or blank for all)"

      @ ln_line, 57 GET lc_lpcnt PICTURE gc_datepi8 ;
                        VALID g_valdte()
      DO g_sayop WITH ln_line, "Due Date", "(Due to be counted on)"

      @ ln_line, 57 GET lc_byseria PICTURE ("@M Yes,No ")
      DO g_sayop WITH ln_line, "Print Serialized?", "(Yes/No)"
*\ [1 line] PTR# 79256 BAUG 06/02/05 Scan barcodes to add items to SO/AR/IC.
  	  IF lo_Globals.gl_Enablebarcode
  	     @ ln_line, 57 GET lc_barcode PICTURE ("@M Yes,No ")
  	     DO g_sayop WITH ln_line, "Item Barcode?", "(Yes/No)"
  	  ENDIF    
        
  ENDCASE

  IF ll_read AND ;
     LASTKEY() <> gk_esc
    ACTIVATE WINDOW lw_rept

    *-- Call special READ function
    = g_read()
  ENDIF

  IF lc_rept = "S02" AND gl_sbtmod AND ;
     LASTKEY() <> gk_esc
     ln_resp = g_getdlg("Include only 0.00 cost items?", ;
              0, 1, "Yes", "No", SPACE(0))

    IF ln_resp = 1
      *-- Used standard cost from location file for multiple locations
      lc_filt = lc_filt + IIF(gl_locts, "a_iciloc->lstdcst = 0.00 AND ", ;
                "a_icitem->stdcost = 0.00 AND ")
    ENDIF

  ENDIF

  *-- Save application ID
  lc_xapplid = lc_applid

  *-- Set applicaton ID
  DO CASE
    CASE LEFT(lc_applid,2) = "IC"
      lc_applid = "IC"
    CASE LEFT(lc_applid,2) = "AR"
      lc_applid = "AR"
    CASE LEFT(lc_applid,2) = "PO"
      lc_applid = "PO"
    CASE LEFT(lc_applid,2) = "SO"
      lc_applid = "SO"
*\ [4 lines] PTR 79484 06/06/05 KGUP Add option to select PE & WO transactions
    CASE LEFT(lc_applid,2) = "PE"
      lc_applid = "PE"
    CASE LEFT(lc_applid,2) = "WO"
      lc_applid = "WO"
    CASE LEFT(lc_applid,2) = "BP"
      lc_applid = "BP"

*\ [1 Line] PTR 82565 04/28/06 TIRS If Applid is InterCompany nothing needs to be done
    CASE lc_Applid = "InterCompany"
    
*\ [2 Lines] PTR# 83376 06/27/07 TINA Set the lc_applid for RM
    CASE LEFT(lc_applid,2) = "RM"
      lc_applid = "RM"

    OTHERWISE
      lc_applid = "All"
  ENDCASE

*\ [Begin] PTR# 77217 10/11/04 TIRH Escape key checked for Date conversions
  IF LASTKEY()<> gk_esc
    mdbdate     = CTOD(lc_bdate)
    mdedate     = CTOD(lc_edate)
    ld_bdate    = g_retdt(lc_bdate)
  ENDIF
*\ [End] PTR# 77217 10/11/04 TIRH Escape key checked for Date conversions

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_getop
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_VALOP
*------------------------------------------------------------------------------
*- Description: Validate report options
*------------------------------------------------------------------------------
*- Synopsis...: Validates report options.
*------------------------------------------------------------------------------
*- Calls......: G_DSPALT
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: valid option variables
*------------------------------------------------------------------------------
PROCEDURE l_valop

  PRIVATE lc_order, ;
          ln_area

  *-- Validate report options
  DO WHILE NOT BETWEEN(VAL(lc_per), 1, 36)
    lc_per = STR(g_valno(12, 4, 57, "##", ;
             "Number of periods must be between 1 and 36", -1), 2)

  ENDDO

  IF lc_rept = "T06"
*\ [Begin] PTR# 84465 09/28/06 TIKV Validated session number
    *-- Check for valid session numbers
    lc_bsess = IIF(EMPTY(lc_bsess) OR VAL(lc_bsess) = 0, "000000", ;
               TRANSFORM(VAL(lc_bsess), "@L 999999"))

    lc_esess = IIF(EMPTY(lc_esess) OR VAL(lc_esess) = 0, lc_hsess, ;
               TRANSFORM(VAL(lc_esess), "@L 999999"))
*\ [End] PTR# 84465 09/28/06 TIKV Validated session number

    DO WHILE lc_bsess > lc_hsess
      *-- Display alert
      DO g_dspalt WITH "Session numbers range from 000000 to " + ;
                       lc_hsess + "." + gc_oseol + ;
                       "Please reenter beginning session number.", 1

      *-- Reenter beginning session number
      @ ln_bsess, 57 GET lc_bsess PICTURE "@K ######"

      *-- Call special READ function
      = g_read()

      lc_bsess = TRANSFORM(VAL(lc_bsess), "@L 999999")
    ENDDO

    DO WHILE lc_esess > lc_hsess
      *-- Display alert
     DO g_dspalt WITH "Session numbers range from 000000 to " + ;
                       lc_hsess + "." + gc_oseol + ;
                        "Please reenter ending session number.", 1

      *-- Reenter ending session number
      @ ln_esess, 57 + (LEN(lc_bsess) + 4) GET lc_esess PICTURE "@K ######"

      *-- Call special READ function
      = g_read()

      lc_esess = TRANSFORM(VAL(lc_esess), "@L 999999")
    ENDDO

    IF lc_nrange = PADR("Batch", 7)
      *-- Check for valid batch numbers
      lc_bbatch = IIF(EMPTY(lc_bbatch), "000000", ;
                  TRANSFORM(VAL(lc_bbatch), "@L 999999"))

      lc_ebatch = IIF(EMPTY(lc_ebatch), "999999", ;
                  TRANSFORM(VAL(lc_ebatch), "@L 999999"))

      DO WHILE lc_bbatch > lc_ebatch
        *-- Display alert
        DO g_dspalt WITH "Beginning batch number cannot be" + gc_oseol + ;
                         "greater than ending batch number." + gc_oseol + ;
                         "Please reenter.", 1

        *-- Reenter batch numbers
        @ ln_bbatch, 57 GET lc_bbatch PICTURE "@K ######"
        @ ln_ebatch, COL() + 1 GET lc_ebatch PICTURE "@K ######"

        *-- Call special READ function
        = g_read()

        lc_bbatch = TRANSFORM(VAL(lc_bbatch), "@L 999999")
        lc_ebatch = TRANSFORM(VAL(lc_ebatch), "@L 999999")
      ENDDO

    ENDIF

  ENDIF && lc_rept = "T06"

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_valop
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_VALITM
*------------------------------------------------------------------------------
*- Description: Validate report options
*------------------------------------------------------------------------------
*- Synopsis...: Validates report options for serial number history
*------------------------------------------------------------------------------
*- Calls......: G_GETDLG
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: valid option variables
*------------------------------------------------------------------------------
PROCEDURE l_valitm

  PRIVATE ln_resp ;
          lx_return

  ln_resp   = 0
  lx_return = .t.

  IF EMPTY(lc_bitem)
    *-- Display alert
    ln_resp = g_getdlg("Item code cannot be blank.", ;
              2, 1, "Reenter", "Cancel")

    *-- Reenter Item code
  ELSE
    ln_area = SELECT()
    go_SQL.m_TableChangeCurrent("a_icitem")
    lc_order = go_SQL.cmpA_Icitem.m_GetOrder()
    go_SQL.cmpA_Icitem.m_SetOrder("item")
    go_SQL.so_CurrentAlias.m_Seek(TRIM(lc_bitem), "")

    IF NOT go_SQL.so_CurrentAlias.m_IsFound()
      *-- Display alert
      ln_resp = g_getdlg("Item " + ALLTRIM(lc_bitem) + " was not found" + ;
                " in the item file. ", 2, 1, "Reenter", "Cancel")

    ELSE

      IF NOT (a_icitem->useserl $ "OS")
        *-- Display alert
        ln_resp = g_getdlg("Item " + ALLTRIM(lc_bitem) + " does not use" + ;
                  " serial numbers. ", 2, 1, "Reenter", "Cancel")

      ELSE
        ll_srl = .t.
      ENDIF

    ENDIF

    *-- Restore order
    IF EMPTY(lc_order)
      go_SQL.cmpA_Icitem.m_SetOrder(0)
    ELSE
      go_SQL.cmpA_Icitem.m_SetOrder(lc_order)
    ENDIF

    *-- Reselect old area
    go_SQL.m_TableChangeCurrent(ln_area)

  ENDIF

  DO CASE
    CASE ln_resp = 1
      *-- Reenter Item code
      lx_return = 0

    CASE ln_resp = 2
      *-- Cancel

      *-- Set the last key value to Escape to position in Exit
      KEYBOARD CHR(gk_esc) PLAIN
      = INKEY(0)
  ENDCASE

RETURN lx_return
*------------------------------------------------------------------------------
*- End Procedure...: l_valitm
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SETHD
*------------------------------------------------------------------------------
*- Description: Set up report headings
*------------------------------------------------------------------------------
*- Synopsis...: Set up report headings according to entered options.
*------------------------------------------------------------------------------
*- Calls......:
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*-              lc_rept, report identifier
*-              lc_0accnt, lower account range limit
*-              lc_9accnt, upper account range limit
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: lc_head1, heading line 1
*-              lc_head2, heading line 2
*------------------------------------------------------------------------------
PROCEDURE l_sethd

  PRIVATE ld_hbdate, ;
          ld_hedate

  ld_hbdate = g_retdt(lc_bdate)
  ld_hedate = g_retdt(lc_edate)

  *-- Initialize headings
  lc_head1 = SPACE(0)
  lc_head2 = SPACE(0)
  lc_head3 = SPACE(0)

  DO CASE
    CASE lc_rept = "F01"
      *-- Inventory File

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      IF NOT SPACE(1) $ lc_bdate
        lc_head1 = lc_head1 + " Sold on or after " + lc_bdate
      ENDIF

      IF gl_locts AND NOT EMPTY(lc_loctid)
        lc_head1 = PROPER(gc_loct) + SPACE(1) + TRIM(lc_loctid) + ;
                   IIF(EMPTY(lc_head1), SPACE(0), ", " + lc_head1)

      ENDIF

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change to lc_head2
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head2 = lc_head2 + "Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "Items " + TRIM(lc_bitem) + ;
                     " to " + TRIM(lc_eitem)
      ENDCASE      

      IF NOT EMPTY(lc_vpartno)
        lc_head2 = lc_head2 + " Vendor Part " + TRIM(lc_vpartno)
      ENDIF

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change to lc_head3
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head3 = lc_head3 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head3 = lc_head3 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head3 = lc_head3 + "  Class " + TRIM(lc_bclass) + " to " + ;
                      TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change to lc_head3
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head3 = lc_head3 + " Beginning Commodity Code = " + TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head3 = lc_head3 + " Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + " Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head3 = lc_head3 + " Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change to lc_head3
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head3 = lc_head3 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head3 = lc_head3 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head3 = lc_head3 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)
      ENDCASE
      
      DO CASE
        CASE lc_status = "All"
         *-- No heading required.
        CASE lc_status = "Active"
      	  lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
        CASE lc_status = "Inactive"
          lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
      ENDCASE  

    CASE lc_rept = "F02"
      *-- Inventory by Location

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change

        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)

        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
           lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                    TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head3 = lc_head3 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head3 = lc_head3 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head3 = lc_head3 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)
      ENDCASE
      
      DO CASE
        CASE lc_status = "All"
         *-- No heading required.
        CASE lc_status = "Active"
      	  lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
        CASE lc_status = "Inactive"
          lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
      ENDCASE  

    CASE lc_rept = "F03"
      *-- Inventory Distribution by Value

      DO CASE
        CASE TRIM(lc_type) = "A"
          lc_head1 = "Stock and Nonstock"
        CASE TRIM(lc_type) = "S"
          lc_head1 = "Stock Only"
        CASE TRIM(lc_type) = "N"
          lc_head1 = "Nonstock Only"
      ENDCASE

      IF NOT EMPTY(CTOD(lc_bdate))
        lc_head1 = lc_head1 + ", Sales since " + lc_bdate
      ENDIF

      IF NOT EMPTY(lc_bclass)
        lc_head2 = lc_head2 + "Class = " + TRIM(lc_bclass)
      ENDIF

      IF ln_minamt <> 0
         lc_head2 = lc_head2 + "  Minimum Value Reported = " + ;
                   TRANSFORM(ln_minamt, "@B ###,###,###.##")

      ENDIF            

    CASE lc_rept = "F05"

      DO CASE
        CASE EMPTY(lc_bvendno) AND EMPTY(lc_evendno)
          *-- No change
        CASE NOT EMPTY(lc_bvendno) AND EMPTY(lc_evendno)
          lc_head2 = lc_head2 + "Beginning Vendor = " + TRIM(lc_bvendno)
        CASE EMPTY(lc_bvendno) AND NOT EMPTY(lc_evendno)
          lc_head2 = lc_head2 + "Ending Vendor = " + TRIM(lc_evendno)
        CASE lc_bvendno = lc_evendno
          lc_head3 = lc_head3 + "Vendor = " + TRIM(lc_bvendno)
        OTHERWISE
          lc_head2 = lc_head2 + "Vendors " + TRIM(lc_bvendno) + " to " + ;
                     TRIM(lc_evendno)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bvprtno) AND EMPTY(lc_evprtno)
          *-- No change
        CASE NOT EMPTY(lc_bvprtno) AND EMPTY(lc_evprtno)
          lc_head2 = lc_head2 + "  Beginning Part Number = " + TRIM(lc_bvprtno)
        CASE EMPTY(lc_bvprtno) AND NOT EMPTY(lc_evprtno)
          lc_head2 = lc_head2 + "  Ending Part Number = " + TRIM(lc_evprtno)
        CASE lc_bvprtno = lc_evprtno
          lc_head3 = lc_head3 + "  Part Number = " + TRIM(lc_bvprtno)
        OTHERWISE
          lc_head2 = lc_head2 + "  Part Numbers " + TRIM(lc_bvprtno) + ;
                     " to " + ;
                     TRIM(lc_evprtno)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_brate) AND EMPTY(lc_erate)
          *-- No change
        CASE NOT EMPTY(lc_brate) AND EMPTY(lc_erate)
          lc_head2 = lc_head2 + "  Beginning Rating = " + TRIM(lc_brate)
        CASE EMPTY(lc_brate) AND NOT EMPTY(lc_erate)
          lc_head2 = lc_head2 + "  Ending Rating = " + TRIM(lc_erate)
        CASE lc_brate = lc_erate
          lc_head3 = lc_head3 + "  Rating = " + TRIM(lc_brate)
        OTHERWISE
          lc_head2 = lc_head2 + "  Ratings " + TRIM(lc_brate) + " to " + ;
                     TRIM(lc_erate)
      ENDCASE
      
      DO CASE
        CASE lc_status = "All"
         *-- No heading required.
        CASE lc_status = "Active"
      	  lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
        CASE lc_status = "Inactive"
          lc_head2 = lc_head2 + "  Status = " + RTRIM(lc_status)
      ENDCASE  

    CASE lc_rept = "F06"
      *-- Lot File

      DO CASE
        CASE EMPTY(lc_blot) AND EMPTY(lc_elot)
          *-- No change
        CASE NOT EMPTY(lc_blot) AND EMPTY(lc_elot)
          lc_head2 = lc_head2 + "Beginning Lot = " + TRIM(lc_blot)
        CASE EMPTY(lc_blot) AND NOT EMPTY(lc_elot)
          lc_head2 = lc_head2 + "Ending Lot = " + TRIM(lc_elot)
        CASE lc_blot = lc_elot
          lc_head2 = lc_head2 + "Lot = " + TRIM(lc_blot)
        OTHERWISE
          lc_head2 = lc_head2 + "Lot " + TRIM(lc_blot) + " to " + TRIM(lc_elot)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change to lc_head3
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head3 = lc_head3 + "Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head3 = lc_head3 + "Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head3 = lc_head3 + "Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "F07"
      *-- Location File

      DO CASE
        CASE lc_loctype = "Production"
          lc_head1 = "Production Type " + PROPER(gc_loct) + "s"

        CASE lc_loctype = "Receiving"
          lc_head1 = "Receiving Type " + PROPER(gc_loct) + "s"

        CASE lc_loctype = "Shipping"
          lc_head1 = "Shipping Type " + PROPER(gc_loct) + "s"

        CASE lc_loctype = "Warehouse"
          lc_head1 = "Warehouse Type " + PROPER(gc_loct) + "s"
*\ [Begin] PTR # 81862 - SSHA Added new location types
        CASE lc_loctype = "Repair"
          lc_head1 = "Repair Type " + PROPER(gc_loct) + "s"
        CASE lc_loctype = "Scrap"
          lc_head1 = "Scrap Type " + PROPER(gc_loct) + "s"
*\ [End] PTR # 81862 - SSHA Added new location types
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change

        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head2 = lc_head2 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)

        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

    CASE lc_rept = "F08"
      *-- Product Line File

      DO CASE
        CASE EMPTY(lc_bpline) AND EMPTY(lc_epline)
          *-- No change
        CASE NOT EMPTY(lc_bpline) AND EMPTY(lc_epline)
          lc_head2 = lc_head2 + "Beginning Product Line = " + TRIM(lc_bpline)
        CASE EMPTY(lc_bpline) AND NOT EMPTY(lc_epline)
          lc_head2 = lc_head2 + "Ending Product Line = " + TRIM(lc_epline)
        CASE lc_bpline = lc_epline
          lc_head2 = lc_head2 + "Product Line = " + TRIM(lc_bpline)
        OTHERWISE
          lc_head2 = lc_head2 + "Product Line " + TRIM(lc_bpline) + " to " + ;
                     TRIM(lc_epline)
      ENDCASE

    CASE lc_rept = "F09"
      *-- Units of Measure File

      DO CASE
        CASE EMPTY(lc_bunms) AND EMPTY(lc_eunms)
          *-- No change
        CASE NOT EMPTY(lc_bunms) AND EMPTY(lc_eunms)
          lc_head2 = lc_head2 + "Beginning Conversion Factor = " + ;
                     TRIM(lc_bunms)
        CASE EMPTY(lc_bunms) AND NOT EMPTY(lc_eunms)
          lc_head2 = lc_head2 + "Ending Conversion Factor = " + TRIM(lc_eunms)
        CASE lc_bpline = lc_eunms
          lc_head2 = lc_head2 + "Conversion Factor = " + TRIM(lc_bunms)
        OTHERWISE
          lc_head2 = lc_head2 + "Conversion Factor " + TRIM(lc_bunms) + ;
                     " to " + ;
                     TRIM(lc_eunms)

      ENDCASE

    CASE lc_rept = "F10"
      *-- Item Price List

      DO CASE
        CASE TRIM(lc_type) = "N"
          lc_head1 = lc_head1 + " Non-Stock Items"
        CASE TRIM(lc_type) = "S"
          lc_head1 = lc_head1 + " Stock Items"
        OTHERWISE
          lc_head1 = lc_head1 + " All Items"
      ENDCASE

      IF lc_zero = "Yes"
        lc_head1 = lc_head1 + " (including zero price items)"
      ELSE
        lc_head1 = lc_head1 + " (excluding zero price items)"
      ENDIF

      IF NOT EMPTY(lc_item)
        lc_head2 = lc_head2 + "  Item = " + TRIM(lc_item)
      ENDIF

      IF NOT EMPTY(lc_class)
         lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_code)
        lc_head2 = lc_head2 + "  Code = " + TRIM(lc_code)
      ENDIF

      IF NOT EMPTY(lc_psched)
        lc_head2 = lc_head2 + "  Price Code = " + TRIM(lc_psched)
      ENDIF

      IF lc_popt <> "All"
        lc_head2 = lc_head2 + "  Pricing Type = " + TRIM(lc_popt)
      ENDIF

      IF NOT EMPTY(lc_scust)
        lc_head2 = lc_head2 + "  Customer = " + TRIM(lc_scust)
      ENDIF

      IF LEFT(lc_reptyp, 1) <> "B"
        lc_head3 = IIF(LEFT(lc_reptyp, 1) = "L", "List prices", "Price codes")

        IF EMPTY(lc_loctid)
          lc_head3 = lc_head3 + ", All Locations"
        ELSE
          lc_head3 = lc_head3 + ", Location = " + ALLTRIM(lc_loctid)
        ENDIF

      ELSE

        IF EMPTY(lc_loctid)
          lc_head3 = "All Locations"
        ELSE
          lc_head3 = "Location = " + ALLTRIM(lc_loctid)
        ENDIF

      ENDIF

    CASE lc_rept = "F11"
      *-- Set report headers

      DO CASE
        CASE EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_head1 = "All Groups"
        CASE NOT EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_head1 = lc_head1 + "  Beginning Price Group = " + ;
                     ALLTRIM(lc_frpgrp)
        CASE EMPTY(lc_frpgrp) AND NOT EMPTY(lc_topgrp)
          lc_head1 = lc_head1 + "  Ending Price Group = " + ;
                     ALLTRIM(lc_topgrp)
        CASE lc_frpgrp = lc_topgrp
          lc_head1 = lc_head1 + "  Price Group = " + ALLTRIM(lc_frpgrp)
        OTHERWISE
          lc_head1 = lc_head1 + "  Price Group " + ALLTRIM(lc_frpgrp) + ;
                     " to " + ALLTRIM(lc_topgrp)
      ENDCASE

    CASE lc_rept = "F12"

      *-- Set report headers
      DO CASE
        CASE EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_head3 = "All Price Groups"
        CASE NOT EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_head3 = lc_head3 + "  Beginning Price Group = " + ;
                     ALLTRIM(lc_frpgrp)
        CASE EMPTY(lc_frpgrp) AND NOT EMPTY(lc_topgrp)
          lc_head3 = lc_head3 + "  Ending Price Group = " + ;
                     ALLTRIM(lc_topgrp)
        CASE lc_frpgrp = lc_topgrp
          lc_head3 = lc_head3 + "  Price Group = " + ALLTRIM(lc_frpgrp)
        OTHERWISE
          lc_head3 = lc_head3 + "  Price Group " + ALLTRIM(lc_frpgrp) + ;
                     " to " + ALLTRIM(lc_topgrp)
      ENDCASE

    CASE lc_rept = "S01"
      *-- Aggregate Summary

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      DO CASE
        CASE LEFT(lc_onhand,1) = "O" AND lc_type <> "All"
          lc_head1 = lc_head1 + " With Onhand Greater Than Zero"
        CASE LEFT(lc_onhand,1) = "O" AND lc_type = "All"
          lc_head1 = "All Item Types With Onhand Greater Than Zero"
      ENDCASE

      DO CASE
        CASE gc_cstmeth = "W"
          lc_head1 = lc_head1 + "  Weighted Average Cost"
        CASE gc_cstmeth = "S"
          lc_head1 = lc_head1 + "  Standard Cost"
        CASE gc_cstmeth = "L"
          lc_head1 = lc_head1 + "  LIFO"
        CASE gc_cstmeth = "F"
          lc_head1 = lc_head1 + "  FIFO"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + ;
                     TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head3 = lc_head3 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head3 = lc_head3 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head3 = lc_head3 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bvprtno) AND EMPTY(lc_evprtno)
          *-- No change
        CASE NOT EMPTY(lc_bvprtno) AND EMPTY(lc_evprtno)
          lc_head3 = lc_head3 + "  Beginning Part Number = " + TRIM(lc_bvprtno)
        CASE EMPTY(lc_bvprtno) AND NOT EMPTY(lc_evprtno)
          lc_head3 = lc_head3 + "  Ending Part Number = " + TRIM(lc_evprtno)
        CASE lc_bvprtno = lc_evprtno
          lc_head3 = lc_head3 + "  Part Number = " + TRIM(lc_bvprtno)
        OTHERWISE
          lc_head3 = lc_head3 + "  Part Numbers " + TRIM(lc_bvprtno) + ;
                     " to " + ;
                     TRIM(lc_evprtno)

      ENDCASE

    CASE lc_rept = "S02"
      *-- Inventory On Hand

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      *-- Build header strings
      IF NOT EMPTY(ld_asofdt)
        lc_head1 = lc_head1 + " As of " + DTOC(ld_asofdt)
      ENDIF

      DO CASE
        CASE LEFT(lc_onhand,1) = "O" AND lc_type <> "All"
          lc_head1 = lc_head1 + " With Onhand Greater Than Zero"
        CASE LEFT(lc_onhand,1) = "O" AND lc_type = "All"
          lc_head1 = "All Item Types With Onhand Greater Than Zero"
        CASE LEFT(lc_onhand,1) = "S" AND lc_type <> "All"
          lc_head1 = lc_head1 + " With Shortages"
        CASE LEFT(lc_onhand,1) = "S" AND lc_type = "All"
          lc_head1 = "All Item Types With Shortages"
        CASE LEFT(lc_onhand,1) = "N" AND lc_type <> "All"
          lc_head1 = lc_head1 + " With Onhand Not Zero"
        CASE LEFT(lc_onhand,1) = "N" AND lc_type = "All"
          lc_head1 = "All Item Types With Onhand Not Zero"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + lc_bitem
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "S03"  OR lc_rept = "S11"
      *-- Usage By Location and inventory analysis

      DO CASE
        CASE lc_rept = "S11"
          *-- Inventory Analysis Report
          lc_head1 = lc_head1 + TRIM(lc_sort) + " for Previous " + lc_per + ;
                     " months"

        CASE TRIM(lc_sort) = "Sales Qty"
          lc_head1 = "Ordered by YTD Sales Quantity"
        CASE TRIM(lc_sort) = "Sales Val"
          lc_head1 = "Ordered by YTD Sales Value"
        CASE TRIM(lc_sort) = "Usage Qty"
          lc_head1 = "Ordered by YTD Usage Quantity"
        CASE TRIM(lc_sort) = "Usage Val"
          lc_head1 = "Ordered by YTD Usage Value"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + ;
                     TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "S04"
      *-- Location Detail
      lc_title   = PROPER(gc_loct) + " Detail "

      IF TRIM(lc_group) = gc_loct
        lc_title = lc_title + "by " + gc_loct
      ELSE
        lc_title = lc_title + "by item"
      ENDIF

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bstore) AND EMPTY(lc_estore)
          *-- No change
        CASE NOT EMPTY(lc_bstore) AND EMPTY(lc_estore)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_store) +  " = " + ;
                     TRIM(lc_bstore)

        CASE EMPTY(lc_bstore) AND NOT EMPTY(lc_estore)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_store) +  " = " + ;
                     TRIM(lc_estore)

        CASE lc_bstore = lc_estore
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_store) + TRIM(lc_bstore)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_store) + SPACE(1) + ;
                     TRIM(lc_bstore) + " to " + TRIM(lc_estore)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bbin) AND EMPTY(lc_ebin)
          *-- No change
        CASE NOT EMPTY(lc_bbin) AND EMPTY(lc_ebin)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_bin) + " = " + ;
                     TRIM(lc_bbin)

        CASE EMPTY(lc_bbin) AND NOT EMPTY(lc_ebin)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_bin) + " = "  + ;
                     TRIM(lc_ebin)

        CASE lc_bbin = lc_ebin
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_bin) + " = " + ;
                     TRIM(lc_bbin)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_bin) + SPACE(1) + ;
                     TRIM(lc_bbin) + " to " + TRIM(lc_ebin)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
         lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
           lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
         lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "S06"
      *-- Recommended Reorders

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      IF LEFT(lc_incld,1) = "B"
        lc_head1 =  lc_head1 + " Below Reorder Point"
      ENDIF

      IF lc_order = gc_loct
        lc_head1 = lc_head1 + " Grouped By " + PROPER(gc_loct)
      ELSE
        lc_head1 = lc_head1 + " Grouped By Supplier"
      ENDIF

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bvendno) AND EMPTY(lc_evendno)
          *-- No change
        CASE NOT EMPTY(lc_bvendno) AND EMPTY(lc_evendno)
          lc_head2 = lc_head2 + "  Beginning Vendor = " + TRIM(lc_bvendno)

        CASE EMPTY(lc_bvendno) AND NOT EMPTY(lc_evendno)
          lc_head2 = lc_head2 + "  Ending Vendor = " + TRIM(lc_evendno)
        CASE lc_bvendno = lc_evendno
          lc_head3 = lc_head3 + "  Vendor = " + TRIM(lc_bvendno)
        OTHERWISE
          lc_head2 = lc_head2 + "  Vendors " + TRIM(lc_bvendno) + " to " + ;
                     TRIM(lc_evendno)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                      TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + ;
                     TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + ;
                     " to " + TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "S07"
      *-- Slow Moving Items

      IF lc_type = "Turnover"
        lc_head1 = "Based on Sales Turnover of Less Than 1"
      ELSE
        lc_head1 = "Based on Usage Threshold of " + LTRIM(STR(ln_units,11)) + ;
                   " Units Sold Over " + lc_per + " Periods"

      ENDIF

      IF lc_resell = "R"
        lc_head2 = lc_head2 + "  Resellable stock items only "
      ENDIF

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
         lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
           lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + ;
                     " to " + TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + ;
                     TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + ;
                     " to " + TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "S08"
      *-- Alternate Items

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
           lc_head2 = lc_head2 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head2 = lc_head2 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head2 = lc_head2 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + ;
                     " to " + TRIM(lc_emcode)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head3 = lc_head3 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head3 = lc_head3 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head3 = lc_head3 + "  Items " + TRIM(lc_bitem) + ;
                     " to " + TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "S13"
      *-- Costing Tiers

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head1 = lc_head1 + "Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head1 = lc_head1 + "Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head1 = lc_head1 + "Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head1 = lc_head1 + "Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

      IF gl_locts AND NOT EMPTY(lc_loctid)
        lc_head1 = PROPER(gc_loct) + " = " + TRIM(lc_loctid) + ;
                   IIF(EMPTY(lc_head1), SPACE(0), ", " + lc_head1)

      ENDIF

    CASE lc_rept = "S14"
      *-- ABC Exception

      lc_head1 = "Based on Cumulative " + lc_type

      lc_head2 = ["A-B" Breakpoint ] + TRANSFORM(ln_abpct, "@B ##.#%, ") + ;
                 ["B-C" Breakpoint ] + TRANSFORM(ln_bcpct, "@B ##.#%")

    CASE lc_rept = "S15"
      *-- Serial/Lot Stock Status

      DO CASE
        CASE LEFT(lc_order,1) = "I"
          lc_head1 = lc_head1 + " Ordered By Item"
        CASE LEFT(lc_order,1) = "L"
          lc_head1 = lc_head1 + " Ordered By " + PROPER(gc_loct)
      ENDCASE

      IF LEFT(lc_incld,1) = "O"
        lc_head2 = lc_head2 + "  Overshipments Only"
      ENDIF

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_blot) AND EMPTY(lc_elot)
          *-- No change
        CASE NOT EMPTY(lc_blot) AND EMPTY(lc_elot)
          lc_head2 = lc_head2 + "  Beginning Lot = " + TRIM(lc_blot)
        CASE EMPTY(lc_blot) AND NOT EMPTY(lc_elot)
          lc_head2 = lc_head2 + "  Ending Lot = " + TRIM(lc_elot)
        CASE lc_blot = lc_elot
          lc_head2 = lc_head2 + "  Lot = " + TRIM(lc_blot)
        OTHERWISE
          lc_head2 = lc_head2 + "  Lot " + TRIM(lc_blot) + " to " + ;
                     TRIM(lc_elot)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bserial) AND EMPTY(lc_eserial)
          *-- No change
        CASE NOT EMPTY(lc_bserial) AND EMPTY(lc_eserial)
          lc_head2 = lc_head2 + "  Beginning Serial # = " + TRIM(lc_bserial)
        CASE EMPTY(lc_bserial) AND NOT EMPTY(lc_eserial)
          lc_head2 = lc_head2 + "  Ending Serial # = " + TRIM(lc_eserial)
        CASE lc_bserial = lc_eserial
          lc_head3 = lc_head3 + "  Serial # = " + TRIM(lc_bserial)
        OTHERWISE
          lc_head2 = lc_head2 + "  Serial # " + TRIM(lc_bserial) + " to " + ;
                     TRIM(lc_eserial)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "T02"
      *-- Inventory Issues

      DO CASE
        CASE lc_applid = "AR"
          lc_head1 = "Invoiced Through Accounts Receivable"
        CASE lc_applid = "IC"
          lc_head1 = "Issued Through Inventory Control"
        CASE lc_applid = "PO"
          lc_head1 = "Returns Through Purchase Orders"
        CASE lc_applid = "SO"
          lc_head1 = "Shipments Through Orders"
        CASE lc_applid = "BP"
          lc_head1 = "BOM explosions"
*\ [2 Lines] PTR# 83376 06/27/07 TINA Set lc_head1 for application RM
        CASE lc_applid = "RM"
          lc_head1 = "Issued Through RMA Replacement"

        OTHERWISE
          lc_head1 = "All Inventory Issues"
      ENDCASE

      DO CASE
        CASE LEFT(lc_order,1) = "D"
          lc_head1 = lc_head1 + " Ordered By Transaction Date"
        CASE LEFT(lc_order,1) = "I"
          lc_head1 = lc_head1 + " Ordered By Item"
        CASE LEFT(lc_order,1) = "S"
          lc_head1 = lc_head1 + " Ordered By Source Application"
        CASE LEFT(lc_order,1) = "T"
          lc_head1 = lc_head1 + " Ordered By Transaction Number"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
           lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
           lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + ;
                     TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + ;
                     " to " + TRIM(lc_emcode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "T03"
      *-- Inventory Receipts

      DO CASE
        CASE lc_applid = "AR"
          lc_head1 = "Credit Memos Through Accounts Receivable"
        CASE lc_applid = "IC"
          lc_head1 = "Receipts Through Inventory Control"
        CASE lc_applid = "PO"
          lc_head1 = "Receipts Through Purchase Orders"
        CASE lc_applid = "SO"
          lc_head1 = "Returns Through Orders"
        CASE lc_applid = "BP"
          lc_head1 = "BOM explosions"
*\ [2 Lines] PTR# 83376 06/27/07 TINA Set lc_head1 for application RM
        CASE lc_applid = "RM"
          lc_head1 = "Receipts Through RMA Replacement"
          
        OTHERWISE
          lc_head1 = "All Inventory Receipts"
      ENDCASE

      DO CASE
        CASE LEFT(lc_order,1) = "A"
          lc_head1 = lc_head1 + " Ordered By Account"
        CASE LEFT(lc_order,1) = "D"
          lc_head1 = lc_head1 + " Ordered By Transaction Date"
        CASE LEFT(lc_order,1) = "S"
          lc_head1 = lc_head1 + " Ordered By Source Application"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
         lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + ;
                     " to " + TRIM(lc_emcode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

*\ [Begin] PTR 83058 07/10/06 TIRS Setup header info for unposted intercomp reciepts
    CASE lc_rept = "T11"
      lc_head1 = "All Unposted Inter-company Receipts"

      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_BComp) AND EMPTY(lc_EComp)
          *-- No change
        CASE NOT EMPTY(lc_BComp) AND EMPTY(lc_EComp)
          lc_head2 = lc_head2 + "  Beginning Company = " + TRIM(lc_BComp)
        CASE EMPTY(lc_BComp) AND NOT EMPTY(lc_EComp)
          lc_head2 = lc_head2 + "  Ending Company = " + TRIM(lc_EComp)
        CASE lc_BComp = lc_EComp
          lc_head3 = lc_head3 + "  Company = " + TRIM(lc_BComp)
        OTHERWISE
          lc_head2 = lc_head2 + "  Companies " + TRIM(lc_BComp) + " to " + ;
                     TRIM(lc_EComp)
      ENDCASE
*\ [End] PTR 83058 07/10/06 TIRS Setup header info for unposted intercomp reciepts

    CASE lc_rept = "T04"
      *-- Inventory Adjustments

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      IF lc_adjtype <> "All"
        lc_head1 = lc_head1 + " Adjustments Due To " + lc_adjtype
      ENDIF

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(CTOD(lc_bdate)) AND EMPTY(CTOD(lc_edate))
          *-- No change
        CASE NOT EMPTY(CTOD(lc_bdate)) AND EMPTY(CTOD(lc_edate))
          lc_head2 = lc_head2 + "  From " + lc_bdate
        CASE EMPTY(CTOD(lc_bdate)) AND NOT EMPTY(CTOD(lc_edate))
          lc_head2 = lc_head2 + "  To " + lc_edate
        CASE lc_bdate = lc_edate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head3 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + ;
                     " to " + TRIM(lc_emcode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "T05"
      *-- Stock Transfers

      DO CASE
        CASE lc_type = "Issue"
          lc_head1 = "Stock Issues"
        CASE lc_type = "Receipt"
          lc_head1 = "Stock Receipts"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bstore) AND EMPTY(lc_estore)
          *-- No change
        CASE NOT EMPTY(lc_bstore) AND EMPTY(lc_estore)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_store) + " = " + ;
                     TRIM(lc_bstore)

        CASE EMPTY(lc_bstore) AND NOT EMPTY(lc_estore)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_store) + " = " + ;
                     TRIM(lc_estore)

        CASE lc_bstore = lc_estore
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_store) + " = " + ;
                     TRIM(lc_bstore)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_store) + SPACE(1) + ;
                     TRIM(lc_bstore) + " to " + TRIM(lc_estore)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bbin) AND EMPTY(lc_ebin)
          *-- No change
        CASE NOT EMPTY(lc_bbin) AND EMPTY(lc_ebin)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_bin) + " = " + ;
                     TRIM(lc_bbin)

        CASE EMPTY(lc_bbin) AND NOT EMPTY(lc_ebin)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_bin) + " = " + ;
                     TRIM(lc_ebin)

        CASE lc_bbin = lc_ebin
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_bin) + " = " + ;
                     TRIM(lc_bbin)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_bin) + SPACE(1) + ;
                     TRIM(lc_bbin) + " to " + TRIM(lc_ebin)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "T06"
      *-- Inventory Journal Report

      IF lc_detail = "S"
        lc_head1 = "Summary Report by "
      ELSE
        lc_head1 = "Detail Report by "
      ENDIF

      DO CASE
        CASE LEFT(lc_order,1) = "A"
          lc_head1 = lc_head1 + "Account"
        CASE LEFT(lc_order,1) = "D"
          lc_head1 = lc_head1 + "Date"
        CASE UPPER(LEFT(lc_order,2)) = "SE"
          lc_head1 = lc_head1 + "Session Number"
        CASE LEFT(lc_order,1) = "S"
          lc_head1 = lc_head1 + "Source Application"
        CASE LEFT(lc_order,1) = "B"
          lc_head1 = lc_head1 + "Batch Number"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + ", Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + ", History File"
        OTHERWISE
          lc_head1 = lc_head1 + ", Current and History Files"
      ENDCASE

      lc_head2 = lc_head2 + IIF(lc_applid <> "All","  Application: " + ;
                 lc_applid, SPACE(0))

      lc_bsess = IIF(VAL(lc_bsess) = 0, "000000", ;
                 TRANSFORM(VAL(lc_bsess), "@L 999999"))

      lc_esess = IIF(VAL(lc_esess) = 0, lc_hsess, ;
                 TRANSFORM(VAL(lc_esess), "@L 999999"))

      IF lc_bsess > lc_hsess
        lc_bsess = lc_hsess
      ENDIF

      IF lc_esess > lc_hsess
        lc_esess = lc_hsess
      ENDIF

      IF lc_nrange = "Session"

        *-- Session numbers
        IF lc_bsess = lc_esess
          lc_head2 = lc_head2 + "  Session " + lc_bsess
        ELSE
          lc_head2 = lc_head2 + "  Sessions " + lc_bsess + " to " + lc_esess
        ENDIF

        DO g_retact WITH 5, lc_bsess, lc_esess, ln_rptcol

      ELSE

        *-- Batch numbers
        DO CASE
          CASE lc_bbatch = "000000" AND lc_ebatch = "999999"
            lc_head2 = lc_head2 + "  All Batches"
          CASE lc_bbatch = lc_ebatch
            lc_head2 = lc_head2 + "  Batch " + lc_bbatch
          OTHERWISE
            lc_head2 = lc_head2 + "  Batches " + lc_bbatch + " to " + lc_ebatch
        ENDCASE

      ENDIF

      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head2 = lc_head2 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE lc_baccnt = lc_0accnt AND lc_eaccnt = lc_9accnt
          lc_head3 = "All Accounts"
        CASE lc_baccnt = TRANSFORM(REPLICATE(SPACE(1), LEN(gc_acctpic)), ;
             gc_acctpic) AND lc_eaccnt = ;
             TRANSFORM(REPLICATE(SPACE(1), LEN(gc_acctpic)), ;
             gc_acctpic)

          lc_head3 = "All Accounts"
        CASE lc_baccnt = lc_eaccnt
          lc_head3 = "Account " + lc_baccnt
        OTHERWISE
          lc_head3 = "Account " + lc_baccnt + " to " + lc_eaccnt
      ENDCASE

    CASE lc_rept = "T07"
      *-- Sales History

      DO CASE
        CASE lc_applid = "AR"
          lc_head1 = lc_head1 + "Accounts Receivable Transactions"
        CASE lc_applid = "SO"
          lc_head1 = lc_head1 + "Order Entry Transactions"
        CASE lc_applid = "All"
          lc_head1 = lc_head1 + "Accounts Receivable & Orders"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

*\ [Begin] PTR# 78641 06/16/05 TISJ Display selected date in report heading
      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE
*\ [End] PTR# 78641 06/16/05 TISJ Display selected date in report heading

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + ;
                     TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "T08"
      *-- Serial/Lot Issue History

      DO CASE
        CASE lc_applid = "AR"
          lc_head1 = "Invoiced Through Accounts Receivable"
        CASE lc_applid = "IC"
          lc_head1 = "Issued Through Inventory Control"
        CASE lc_applid = "PO"
          lc_head1 = "Returns Through Purchase Orders"
        CASE lc_applid = "SO"
          lc_head1 = "Shipments Through Orders"
        CASE lc_applid = "BP"
          lc_head1 = "BOM explosions"
*\ [2 Lines] PTR# 83376 06/27/07 TINA Set lc_head1 for application RM
        CASE lc_applid = "RM"
          lc_head1 = "Issued Through RMA Replacement"
          
        OTHERWISE
          lc_head1 = "All Inventory Issues"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          *-- No change

        CASE NOT EMPTY(ld_hbdate) AND EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  From " + lc_bdate

        CASE EMPTY(ld_hbdate) AND NOT EMPTY(ld_hedate)
          lc_head2 = lc_head2 + "  To " + lc_edate

        CASE ld_hbdate = ld_hedate
          lc_head3 = lc_head3 + "  Date = " + lc_bdate
        OTHERWISE
          lc_head2 = lc_head2 + "  From " + lc_bdate + " To " + lc_edate
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "Ending " + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_eloc)
        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + PROPER(gc_loct) + " = " + TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + PROPER(gc_loct) + SPACE(1) + TRIM(lc_bloc) + ;
                     " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bserial) AND EMPTY(lc_eserial)
          *-- No change
        CASE NOT EMPTY(lc_bserial) AND EMPTY(lc_eserial)
          lc_head2 = lc_head2 + "  Beginning Serial # = " + TRIM(lc_bserial)
        CASE EMPTY(lc_bserial) AND NOT EMPTY(TRIM(lc_eserial))
          lc_head2 = lc_head2 + "  Ending Serial # = " + lc_eserial
        CASE lc_bserial = lc_eserial
          lc_head3 = lc_head3 + "  Serial # = " + TRIM(lc_bserial)
        OTHERWISE
          lc_head2 = lc_head2 + "  Serial # " + TRIM(lc_bserial) + ;
                     " to " + TRIM(lc_eserial)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_blot) AND EMPTY(lc_elot)
          *-- No change
        CASE NOT EMPTY(lc_blot) AND EMPTY(lc_elot)
          lc_head2 = lc_head2 + "  Beginning Lot = " + TRIM(lc_blot)
        CASE EMPTY(lc_blot) AND NOT EMPTY(lc_elot)
          lc_head2 = lc_head2 + "  Ending Lot = " + TRIM(lc_elot)
        CASE lc_blot = lc_elot
          lc_head2 = lc_head2 + "  Lot = " + TRIM(lc_blot)
        OTHERWISE
          lc_head2 = lc_head2 + "  Lot " + TRIM(lc_blot) + " to " + ;
                     TRIM(lc_elot)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bcustno) AND EMPTY(lc_ecustno)
          *-- No change
        CASE NOT EMPTY(lc_bcustno) AND EMPTY(lc_ecustno)
          lc_head2 = lc_head2 + "  Beginning Customer = " + TRIM(lc_bcustno)
        CASE EMPTY(lc_bcustno) AND NOT EMPTY(lc_ecustno)
          lc_head2 = lc_head2 + "  Ending Customer = " + TRIM(lc_ecustno)
        CASE lc_bcustno = lc_ecustno
          lc_head2 = lc_head2 + "  Customer = " + TRIM(lc_bcustno)
        OTHERWISE
          lc_head2 = lc_head2 + "  Customer " + TRIM(lc_bcustno) + ;
                     " to " + TRIM(lc_ecustno)

      ENDCASE

    CASE lc_rept = "T10"

      *-- Serial Number History
      lc_head1 = lc_head1 + "  Item = " + TRIM(lc_bitem)

      DO CASE
        CASE EMPTY(lc_bserial) AND EMPTY(lc_eserial)
          *-- No change
        CASE NOT EMPTY(lc_bserial) AND EMPTY(lc_eserial)
          lc_head2 = lc_head2 + "  Beginning Serial # = " + ALLTRIM(lc_bserial)
        CASE EMPTY(lc_bserial) AND NOT EMPTY(lc_eserial)
          lc_head2 = lc_head2 + "  Ending Serial # = " + ALLTRIM(lc_eserial)
        CASE lc_bserial = lc_eserial
          lc_head3 = lc_head3 + "  Serial # = " + ALLTRIM(lc_bserial)
        OTHERWISE
          lc_head2 = lc_head2 + "  Serial # " + ALLTRIM(lc_bserial) + ;
                     " to " + ALLTRIM(lc_eserial)

      ENDCASE

    CASE lc_rept = "CCW"
      *-- Cycle Count Worksheet
      lc_head1 = "Cycle Count Worksheet"

      IF NOT EMPTY(lc_abccode)
        lc_head2 = lc_head2 + "  ABC Code = " + lc_abccode
      ENDIF

      IF NOT EMPTY(lc_cntcode)
        lc_head2 = lc_head2 + "  Count Code = " + TRIM(lc_cntcode)
      ENDIF

      IF NOT EMPTY(lc_loctid)
        lc_head2 = lc_head2 + "  Loc = " + TRIM(lc_loctid)
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_head2 = lc_head2 + "  Class = " + TRIM(lc_class)
      ENDIF

      IF NOT EMPTY(lc_plinid)
        lc_head2 = lc_head2 + "  Product Line = " + TRIM(lc_plinid)
      ENDIF

      IF NOT EMPTY(lc_lpcnt)
        lc_head1 = lc_head1 + ", Due to be Counted By " + lc_lpcnt
      ENDIF
      IF lc_zero = "Yes"
        lc_head1 = lc_head1 + " (including zero Quantity items)"
      ELSE
        lc_head1 = lc_head1 + " (excluding zero Quantity items)"
      ENDIF

      *-- Transaction Reports
    CASE lc_rept = "T01"
      *-- Consolidated Transactions

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      DO CASE
        CASE LEFT(lc_order,1) = "D"
          lc_head1 = lc_head1 + " Ordered By Transaction Date"
        CASE LEFT(lc_order,1) = "S"
          lc_head1 = lc_head1 + " Ordered By Source Application"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)

        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)

        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)

        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                    TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

    CASE lc_rept = "T09"
      *-- Cost Variances

      DO CASE
        CASE lc_type = "Asset"
          lc_head1 = "Asset Type Items"
        CASE lc_type = "Expense"
          lc_head1 = "Expense Type Items"
        CASE lc_type = "Service"
          lc_head1 = "Service Type Items"
        CASE lc_type = "Inventory"
          lc_head1 = "Inventory Type Items"
      ENDCASE

      DO CASE
        CASE LEFT(lc_file,1) = "C"
          lc_head1 = lc_head1 + " Current File"
        CASE LEFT(lc_file,1) = "H"
          lc_head1 = lc_head1 + " History File"
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          *-- No change
        CASE NOT EMPTY(lc_bloc) AND EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Beginning " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_bloc)

        CASE EMPTY(lc_bloc) AND NOT EMPTY(lc_eloc)
          lc_head2 = lc_head2 + "  Ending " + PROPER(gc_loct) + ;
                     " = " + TRIM(lc_eloc)

        CASE lc_bloc = lc_eloc
          lc_head3 = lc_head3 + SPACE(2) + PROPER(gc_loct) + " = " + ;
                     TRIM(lc_bloc)
        OTHERWISE
          lc_head2 = lc_head2 + SPACE(2) + PROPER(gc_loct) + SPACE(1) + ;
                     TRIM(lc_bloc) + " to " + TRIM(lc_eloc)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          *-- No change
        CASE NOT EMPTY(lc_bclass) AND EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Beginning Class = " + TRIM(lc_bclass)
        CASE EMPTY(lc_bclass) AND NOT EMPTY(lc_eclass)
          lc_head2 = lc_head2 + "  Ending Class = " + TRIM(lc_eclass)
        CASE lc_bclass = lc_eclass
          lc_head3 = lc_head3 + "  Class = " + TRIM(lc_bclass)
        OTHERWISE
          lc_head2 = lc_head2 + "  Class " + TRIM(lc_bclass) + " to " + ;
                     TRIM(lc_eclass)
      ENDCASE

      DO CASE
        CASE EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          *-- No change
        CASE NOT EMPTY(lc_bccode) AND EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Beginning Commodity Code = " + ;
                     TRIM(lc_bccode)
        CASE EMPTY(lc_bccode) AND NOT EMPTY(lc_eccode)
          lc_head2 = lc_head2 + "  Ending Commodity Code = " + TRIM(lc_eccode)
        CASE lc_bccode = lc_eccode
          lc_head3 = lc_head3 + "  Commodity Code = " + TRIM(lc_bccode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Commodity Code " + TRIM(lc_bccode) + ;
                     " to " + ;
                     TRIM(lc_eccode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          *-- No change
        CASE NOT EMPTY(lc_bmcode) AND EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Beginning Misc. Code = " + TRIM(lc_bmcode)
        CASE EMPTY(lc_bmcode) AND NOT EMPTY(lc_emcode)
          lc_head2 = lc_head2 + "  Ending Misc. Code = " + TRIM(lc_emcode)
        CASE lc_bmcode = lc_emcode
          lc_head3 = lc_head3 + "  Misc. Code = " + TRIM(lc_bmcode)
        OTHERWISE
          lc_head2 = lc_head2 + "  Misc. Code " + TRIM(lc_bmcode) + " to " + ;
                     TRIM(lc_emcode)

      ENDCASE

      DO CASE
        CASE EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          *-- No change
        CASE NOT EMPTY(lc_bitem) AND EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Beginning Item = " + TRIM(lc_bitem)
        CASE EMPTY(lc_bitem) AND NOT EMPTY(lc_eitem)
          lc_head2 = lc_head2 + "  Ending Item = " + TRIM(lc_eitem)
        CASE lc_bitem = lc_eitem
          lc_head3 = lc_head3 + "  Item = " + TRIM(lc_bitem)
        OTHERWISE
          lc_head2 = lc_head2 + "  Items " + TRIM(lc_bitem) + " to " + ;
                     TRIM(lc_eitem)
      ENDCASE

  ENDCASE

  *-- Remove leading and trailing blanks from report headings
  lc_head1 = ALLTRIM(lc_head1)
  lc_head2 = ALLTRIM(lc_head2)
  lc_head3 = ALLTRIM(lc_head3)
RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_sethd
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT
*------------------------------------------------------------------------------
*- Description: Reports 1/2/3/4/5/6/7/8/9/V
*------------------------------------------------------------------------------
*- Synopsis...: (1) Inventory Summary   (F1)  Inventory Master
*-              (2) Inventory On Hand   (F2)  Inventory By Location
*-              (3) Inventory Transfers (F3)  Distribution By Value
*-              (6) Recommended Reorder (F5)  Suppliers File
*-              (7) Physical Inventory  (F6)  Lot File
*-                                      (F7)  Location File
*-                                      (F8)  Product Line File
*-                                      (F9)  Units of Measure File
*------------------------------------------------------------------------------
*- Calls......: SYVALR
*------------------------------------------------------------------------------
*- Passed:
*- Variables: LEFT(lc_file,1)      = "C" for current period file
*-                           "H" for history file
*-                           "B" for both files
*-            TRIM(lc_type)      = type of report (B, D, and F3):
*-                           "A" for all items
*-                           "S" for stock items only
*-                           "N" for nonstock items only
*-                           type of report (C only):
*-                           "Y" for all transfers
*-                           "I" for inventory issues only
*-                           "R" for inventory receipts only
*-                           "C" for inventory cost changes only
*-                           "P" for physical inventory only
*-                           "A" for cost adjustment entries only
*-                         type of report (F1, F2)
*-                           "A" = Asset
*-                           "E" = Expense
*-                           "I" = Inventory
*-                           "S" = Service
*-            ln_days      = number of days before/since last sale
*-            LEFT(lc_range,1)     = " " for All Sales
*-                         "B" for Sales before number of days
*-                         "S" for Sales since number of days
*-            LEFT(lc_incld,1)     = "A" for All
*-                         "B" for below reorder point
*-            lc_bdate     = beginning date
*-            lc_edate     = ending date
*-            LEFT(lc_order,1)     = "I" to order report by item (D,F,F1,F3)
*-                         "D" to order report by description (D,F,F1.F3)
*-                         "1" to show 1st price (E)
*-                         "2" to show 2nd price (E)
*-                         "3" to show 3rd price (E)
*-            mcustno    = customer number or portion to match
*-            lc_bitem     = beginning item
*-            lc_eitem     = ending item
*-            lc_bvprtno  = beginning vendor P/N
*-            lc_evprtno  = ending vendor P/N
*-            lc_bclass    = beginning inventory class
*-            lc_eclass    = ending inventory class
*-            mcode      = customer/inventory code or portion to match
*-            lc_dbvtype = "C" = Customer
*-                         "I" = Inventory
*-                         "V" = Vendor
*-            ln_minamt  = activity below this amount is excluded
*-            lc_0accnt  = lower account range limit
*-            lc_9accnt  = upper account range limit
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_icrept

  PRIVATE ln_recno, ;
          ll_opnglac, ;
          ll_empty, ;
          ln_days

*\ [1 Lines] PTR# 77227 05/24/06 TIVK Declared variable ln_QtyReord
  PRIVATE ld_fbdate, ;
          ld_fedate, ;
          ln_QtyReord

*\ [2 Lines] PTR 82954 05/30/06 SGOU History file changes
  PRIVATE la_Periods
  DIMENSION la_Periods[1]

  LOCAL lc_Where, ;
        lc_CuttOffPeriod
  
  lc_Where = ""
  lc_CuttOffPeriod = ""

  ld_fbdate = g_retdt(lc_bdate)
  ld_fedate = g_retdt(lc_edate)

  ll_empty = .f.
  ln_days  = 0

  *-- Display processing message
  DO g_dspst WITH "Gathering information for " + ALLTRIM(lc_title1) + ;
                  " report...", .t., gn_msgline, SPACE(0), ;
                  SPACE(0), SPACE(0)

  DO CASE
    CASE lc_rept = "F01"
      *-- Inventory File Listing
      DO l_icrept_f01

    CASE lc_rept = "F02"
      *-- Inventory by Location
      DO l_icrept_f02

    CASE lc_rept = "F03"
      *-- Distribution by Value Report
      DO l_icrept_f03

    CASE lc_rept = "F05"
      *-- Suppliers File
      DO l_icrept_f05

    CASE lc_rept = "F06"
      *-- Lot File
      DO l_icrept_f06

    CASE lc_rept = "F07"
      *-- Location File
      DO l_icrept_f07

    CASE lc_rept = "F08"
      *-- Product Line File
      DO l_icrept_f08

    CASE lc_rept = "F09"
      *-- Units of Measure File
      DO l_icrept_f09

    CASE lc_rept = "F10"
      *-- Item Price List
      DO l_icrept_f10

    CASE lc_rept = "F11"
      DO l_icrept_f11

    CASE lc_rept = "F12"
      DO l_icrept_f12

    CASE lc_rept = "S01"
      *-- Aggregate Summary

      *-- Initialize inventory values
	  STORE 0.00 TO tcost,  ;
	   			    tret,   ;
	   			    taloc,  ;
	   			    tcurr,  ;
	   			    tover30,;
	   			    tover60,;
	   			    tover90,;
	   			    tover120

      *-- Set stock items only condition
      lc_filt = lc_filt + [a_icitem->stkcode = 'Y' AND ]

      *-- Set onhand condition
      IF LEFT(lc_onhand,1) <> "A"
        lc_filt = lc_filt + [a_iciloc->lonhand > 0 AND ]
      ENDIF

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = LEFT(??lc_type,1) AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_iciloc->loctid >= TRIM(??lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_iciloc->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_iciloc->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_iciloc->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set vendor part number condition
      IF NOT EMPTY(lc_bvprtno)
        lc_filt = lc_filt + [a_icsupl->vpartno >= ??TRIM(lc_bvprtno) AND ]
      ENDIF

      IF NOT EMPTY(lc_evprtno)
        lc_filt = lc_filt + [a_icsupl->vpartno <= TRIM(??lc_evprtno) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set to ignore deleted records
      lc_filt = lc_filt + [ 1=1 ]

      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Open Inventory Suppliers' file
      ln_opnsupl = g_opnfl(gf_icsuplf, "a_icsupl", .f., .f., "item1")

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory by Location file
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item1")

      *-- Have selected columns of ICILOC and ICITEM required for this report
      *-- into a temporary VFP table
      go_SQL.m_SQLSelect("a_iciloc->item, " + ;
             "a_iciloc->loctid, " + ;
             "a_iciloc->lonhand, " + ;
             "a_iciloc->lsoaloc, " + ;
             "a_iciloc->lsale, " + ;
             "a_iciloc->lstdcst, " + ;
             "a_iciloc->lavgcst, " + ;
             "a_icitem->price AS price, " + ;
             "a_icitem->ionhand AS ionhand, " + ;
             "a_icitem->type AS type, " + ;
             "a_icitem->stkcode AS stkcode, " + ;
             "a_icitem->stdcost AS stdcost, " + ;
             "a_icitem->avgcost AS avgcost " + ;
             " FROM " + go_SQL.cmpa_iciloc.sc_tableNameFull + " a_iciloc " + ;
             "LEFT OUTER JOIN " + go_SQL.cmpa_icitem.sc_tableNameFull + " a_icitem " + ;
             " ON a_icitem->item = a_iciloc->item " + ;
             "LEFT OUTER JOIN " + go_SQL.cmpa_icsupl.sc_tableNameFull + " a_icsupl " + ;
             " ON a_icsupl->item = a_iciloc->item " + ;
             " WHERE " + ;
             lc_filt1 + lc_filt2 + lc_filt3 + lc_filt4 + ;
             " GROUP BY a_iciloc->item , a_iciloc->loctid " + ;
             " ORDER BY a_iciloc->item , a_iciloc->loctid", "TABLE", ;
             go_SQL.m_getTempTableName(1, "F"))

      go_SQL.so_currentAlias.m_closeTable()

      *-- Close the original tables before opening the temporary table
      go_SQL.cmpA_iciloc.m_closeTable()
      go_SQL.cmpA_icitem.m_closeTable()

      *-- Open the temporary VFP table using the alias a_iciloc
      = g_opnfl(go_SQL.m_getTempTableName(1, "F"), "A_iciloc", .t., .f., "", .f., "F")
      go_SQL.cmpA_iciloc.m_createIndex("item1", "item+loctid", "", .t., .f.)

      *-- Have one more instance of the temporary VFP table opened as a_icitem
      = g_opnfl(go_SQL.m_getTempTableName(1, "F"), "A_icitem", .t., .t., "", .f., "F")
      go_SQL.cmpA_icitem.m_createIndex("item1", "item+loctid", "", .t., .f.)

      go_SQL.m_TableChangeCurrent("a_iciloc")

      *-- Set relation to different alias of the same table
      go_SQL.so_CurrentAlias.m_SetRelation("item+loctid", "a_icitem", .f.)

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      *-- If matching records found
      IF NOT go_SQL.so_CurrentAlias.m_IsEof()
        ln_recno = go_SQL.so_CurrentAlias.m_GetRecno()

        *-- Display processing message
        DO g_dspst WITH "Calculating Inventory Values, Age, and " + ;
                        "Gross Margin...", .t., gn_msgline, ;
                        SPACE(0), SPACE(0), SPACE(0)

        *-- If LIFO/FIFO open cost tiers file
        ln_opncost = IIF(NOT gc_cstmeth $ "LF", go_SQL.m_IsUsed("a_iccost"), g_opnfl(gf_iccostf, "a_iccost", .f., .f.))

        *-- Reselect items at locations file
        go_SQL.m_TableChangeCurrent("a_iciloc")

        *-- Calculate inventory values
        SCAN

          *-- Retrieve value at current location
          *-- The aliases a_iciloc and a_icitem referred in g_clcohv will now point to
          *-- the temporary VFP table created above
          ln_loccst = g_clcohv("VALUE", .t.)

          *-- Add value at current location
          tcost = tcost + ln_loccst
          tret  = tret  + (a_iciloc->lonhand * a_icitem->price)
          taloc = taloc + ;
                  (a_iciloc->lsoaloc * ;
                  g_extnd(2, ln_loccst, 1/a_iciloc->lonhand, 0))

          ll_empty = g_emptdt(a_iciloc->lsale)
          ln_days  = IIF(TYPE("gd_sdate") ="T", TTOD(gd_sdate), gd_sdate) - ;
                       IIF(TYPE("a_iciloc->lsale") ="T",TTOD(a_iciloc->lsale),a_iciloc->lsale)

          DO CASE
            CASE NOT ll_empty AND ln_days > 120
              tover120 = ln_loccst + tover120
            CASE NOT ll_empty AND ln_days > 90
              tover90  = ln_loccst + tover90
            CASE NOT ll_empty AND ln_days > 60
              tover60  = ln_loccst + tover60
            CASE NOT ll_empty AND ln_days > 30
              tover30  = ln_loccst + tover30
            OTHERWISE
              tcurr    = ln_loccst + tcurr
          ENDCASE

          go_SQL.m_TableChangeCurrent("a_iciloc")
        ENDSCAN

        IF go_SQL.m_IsUsed("a_iccost") AND ln_opncost = 2
          go_SQL.cmpA_Iccost.m_CloseTable()
        ENDIF

        go_SQL.so_CurrentAlias.m_MoveToRecno(ln_recno)

      ENDIF

      *-- Set report title
      lc_title = "Inventory Aggregate Report"

      *-- Set report form name
      *# DOCCODE REPORT FORM icstat
      lc_frx = gc_icprgdv + "icstat"

    CASE lc_rept = "S02"
      *-- Inventory On Hand

      ld_asofdt = g_retdt(lc_asofdt)

      *-- Set stock items only condition
      lc_filt = lc_filt + [a_icitem->stkcode = 'Y' AND ]

      *-- Change the filter condition based on as of date
      *-- Set onhand condition in location file
      IF EMPTY(ld_asofdt) AND lc_gtasof = "No "

        DO CASE
          CASE LEFT(lc_onhand,1) = "O"
            lc_filt = lc_filt + [a_iciloc->lonhand > 0 AND ]
          CASE LEFT(lc_onhand,1) = "S"
            lc_filt = lc_filt + [a_iciloc->lonhand <= 0 AND ]
          CASE LEFT(lc_onhand,1) = "L"
            lc_filt = lc_filt + [a_iciloc->lonhand < 0 AND ]
          CASE LEFT(lc_onhand,1) = "N"
            lc_filt = lc_filt + [a_iciloc->lonhand <> 0 AND ]
        ENDCASE

      ELSE

        *-- Set the condition in temporary file
        DO CASE
          CASE LEFT(lc_onhand,1) = "O"
            lc_filter = lc_filter + [a_tmpf1->lonhand > 0 ]

          CASE LEFT(lc_onhand,1) = "S"
            lc_filter = lc_filter + [a_tmpf1->lonhand <= 0 ]

          CASE LEFT(lc_onhand,1) = "L"

            lc_filter = lc_filter + [a_tmpf1->lonhand < 0 ]
          CASE LEFT(lc_onhand,1) = "N"

            lc_filter = lc_filter + [a_tmpf1->lonhand <> 0 ]
        ENDCASE

      ENDIF


      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_iciloc.loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_iciloc.loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_iciloc.item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_iciloc.item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set to ignore deleted records
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Cost Tiers File
      IF gc_cstmeth $ "LF"
        ln_opncost = g_opnfl(gf_iccostf, "a_iccost")
      ENDIF

      *-- Open locations file
      ln_opnloct = g_opnfl(gf_icloctf, "a_icloct", .f., .f., "loctid")

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory by Location file
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f.)
      go_SQL.cmpA_Iciloc.m_SetOrder(0)


      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      IF gl_locts
        *-- Used standard and average costs from location file
        go_SQL.m_SQLSelect("a_icitem->item, " + ;
             "a_icitem->itmdesc, " + ;
             "a_icitem->itmclss, " + ;
             "a_iciloc->lstdcst, " + ;
             "a_iciloc->lavgcst, " + ;
             "a_icitem->price, " + ;
             "a_icitem->ionhand, " + ;
             "a_icitem->stkumid, " + ;
             "a_icitem->sumfact, " + ;
             "a_icitem->pumfact, " + ;
             "a_icitem->comcode, " + ;
             "a_iciloc->loctid, " + ;
             "a_iciloc->lonhand, " + ;
             "a_iciloc->lsale, " + ;
             "a_iciloc->icacct, " + ;
             "999999999.99999 AS OHVITEM, " + ;
             "999999999.99999 AS WAVGCST " + ;
             " FROM " + go_SQL.cmpa_icitem.sc_tableNameFull + " a_icitem, " + ;
             go_SQL.cmpa_iciloc.sc_tableNameFull + " a_iciloc  WHERE a_icitem->item =  a_iciloc->item AND " + ;
             lc_filt1 + lc_filt2 + lc_filt3 + lc_filt4 + " ORDER BY a_icitem->item", "SQL TABLE", ;
             go_SQL.m_getTempTableName(1) )
      ELSE
        go_SQL.m_SQLSelect("a_icitem->item, " + ;
             "a_icitem->itmdesc, " + ;
             "a_icitem->itmclss, " + ;
             "a_icitem->stdcost, " + ;
             "a_icitem->avgcost, " + ;
             "a_icitem->price, " + ;
             "a_icitem->ionhand, " + ;
             "a_icitem->stkumid, " + ;
             "a_icitem->sumfact, " + ;
             "a_icitem->pumfact, " + ;
             "a_icitem->comcode, " + ;
             "a_iciloc->loctid, " + ;
             "a_iciloc->lonhand, " + ;
             "a_iciloc->lsale, " + ;
             "a_iciloc->icacct, " + ;
             "999999999.99999 AS OHVITEM, " + ;
             "999999999.99999 AS WAVGCST " + ;
             " FROM " + go_SQL.cmpa_icitem.sc_tableNameFull + " a_icitem, " + ;
             go_SQL.cmpa_iciloc.sc_tableNameFull + " a_iciloc  WHERE a_icitem->item =  a_iciloc->item AND " + ;
             lc_filt1 + lc_filt2 + lc_filt3 + lc_filt4 + " ORDER BY a_icitem->item", "SQL TABLE", ;
             go_SQL.m_getTempTableName(1) )
      ENDIF
      go_SQL.so_currentAlias.m_closeTable()

      ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f., "", .f.)

      go_SQL.cmpA_tmpf1.m_ReplaceBulk("OHVITEM WITH 0, WAVGCST WITH 0", ;
                                      "A", "", .t.)

      go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)

      SET TALK OFF

      *-- select the report cursor to be processed
      go_SQL.m_TableChangeCurrent("a_tmpf1")

      *-- If matching records found
      IF NOT go_SQL.cmpA_tmpf1.m_IsEof()


        go_SQL.cmpA_Iciloc.m_SetOrder("loctid1")
        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
        go_SQL.cmpA_tmpf1.m_SetRelation("loctid + item", "a_iciloc", .t.)
        go_SQL.cmpA_tmpf1.m_SetRelation("loctid", "a_icloct", .t.)

        DO CASE
          CASE lc_detail = "S" AND gc_cstmeth $ "LF"
            *- summary report for LIFO/FIFO costing methong

            go_SQL.cmpA_tmpf1.m_ReplaceBulk("ohvitem WITH IIF(a_icitem->type = 'I' AND a_icitem->stkcode<>'N', " + ;
                        "g_clcohv('VALUE', .t.), 0)", ;
                        "A", "")

          CASE lc_detail = "S"
            *- summary report for Standard and Weighted Average costing methong

            go_SQL.cmpA_tmpf1.m_ReplaceBulk("ohvitem WITH g_clcohv('VALUE', .t.)", ;
                         "A", "")

          OTHERWISE
            *- detail report for all costing method
            *-Procedure split due to insufficient memory to hold big procedure by VFP
		    DO l_AsOfUpdate

        ENDCASE

        IF NOT EMPTY(ld_asofdt)
          DO l_dueasof
        ENDIF

        go_SQL.m_TableChangeCurrent("a_tmpf1")

        *-- Set the filter if as of date is given
        IF NOT EMPTY(ld_asofdt)
          go_SQL.cmpA_tmpf1.m_SetFilter(lc_filter)
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

        *-- Create temporary index
        DO CASE
          CASE lc_detail = "S" AND TRIM(lc_group) = "Class"

            *-- Display processing message
            DO g_dspst WITH "Indexing on Item within Class", ;
                            .t., gn_msgline, SPACE(0), SPACE(0), SPACE(0)

              go_SQL.cmpA_tmpf1.m_createIndex("tagitmclss", "itmclss + item", "", .t., .f.)
          CASE lc_detail = "S" AND TRIM(lc_group) = "Comm. Code"

            *-- Display processing message
            DO g_dspst WITH "Indexing on Item within Commodity code", ;
                            .t., gn_msgline, SPACE(0), SPACE(0), SPACE(0)

            go_SQL.cmpA_tmpf1.m_createIndex("tagcomcode", "comcode + item", "", .t., .f.)
          CASE lc_detail = "S" AND TRIM(lc_group) = "None"

            *-- Display processing message
            DO g_dspst WITH "Indexing on Item", ;
                            .t., gn_msgline, SPACE(0), SPACE(0), SPACE(0)

            go_SQL.cmpA_tmpf1.m_createIndex("tagitem", "item", "", .t., .f.)

          CASE TRIM(lc_sort) = "Account"

            *-- Display processing message
            IF TRIM(lc_group) = gc_loct
              DO g_dspst WITH "Indexing by Acct, " + gc_loct + "and Item...", ;
                              .t., gn_msgline, SPACE(0), SPACE(0), ;
                              SPACE(0)

              go_SQL.cmpA_tmpf1.m_createIndex("tagicacct", "icacct + loctid + item", "", .t., .f.)
            ELSE
              DO g_dspst WITH "Indexing by Acct, Item, and " + gc_loct, ;
                              .t., gn_msgline, SPACE(0), SPACE(0), ;
                              SPACE(0)

              go_SQL.cmpA_tmpf1.m_createIndex("tagicacct", "icacct + item + loctid", "", .t., .f.)
            ENDIF

          CASE TRIM(lc_group) = "Class"

            *-- Display processing message
            IF TRIM(lc_sort) = gc_loct
              DO g_dspst WITH "Indexing on " + PROPER(gc_loct) + ;
                              " and Item within Class", .t., gn_msgline, ;
                              SPACE(0), SPACE(0), SPACE(0)
            ELSE
              DO g_dspst WITH "Indexing on Item and " + PROPER(gc_loct) + ;
                              " within Class...", .t., gn_msgline, ;
                              SPACE(0), SPACE(0), SPACE(0)
            ENDIF

              go_SQL.cmpA_tmpf1.m_createIndex("tagitmclss", ;
                  "itmclss + " + IIF(TRIM(lc_sort) = "Item", 'item + loctid', 'loctid + item'), ;
                  "", .t., .f.)
          CASE TRIM(lc_group) = "Comm. Code"

            *-- Display processing message
            IF TRIM(lc_sort) = gc_loct
              DO g_dspst WITH "Indexing on " + PROPER(gc_loct) + ;
                              " and Item within Commodity code", .t., ;
                              gn_msgline, SPACE(0), SPACE(0), SPACE(0)
            ELSE
              DO g_dspst WITH "Indexing on Item and " + PROPER(gc_loct) + ;
                              " within Commodity code...", .t., ;
                              gn_msgline, SPACE(0), SPACE(0), SPACE(0)
            ENDIF

            go_SQL.cmpA_tmpf1.m_createIndex("tagcomcode", ;
                  "comcode +" + IIF(TRIM(lc_sort) = "Item", 'item + loctid', 'loctid + item'), ;
                  "", .t., .f.)
          CASE TRIM(lc_group) = "None"

            *-- Display processing message
            IF TRIM(lc_sort) = gc_loct
              DO g_dspst WITH "Indexing on " + PROPER(gc_loct) + " and Item", ;
                              .t., gn_msgline, SPACE(0), SPACE(0), ;
                              SPACE(0)
            ELSE
              DO g_dspst WITH "Indexing on Item and " + PROPER(gc_loct), ;
                              .t., gn_msgline, SPACE(0), SPACE(0), ;
                              SPACE(0)
            ENDIF

            go_SQL.cmpA_tmpf1.m_createIndex("tagitem", ;
                  IIF(TRIM(lc_sort) = "Item", "item + loctid", "loctid + item") , ;
                  "", .t., .f.)

        ENDCASE

      ENDIF

      go_SQL.cmpA_Iciloc.m_SetOrder("loctid1")
      go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.cmpA_tmpf1.m_SetRelation("loctid + item", "a_iciloc", .t.)
      go_SQL.cmpA_tmpf1.m_SetRelation("loctid", "a_icloct", .t.)

      DO CASE
        CASE lc_detail = "S"
          *-- Set report title
          lc_title = "Summary Inventory On Hand Report"
        CASE TRIM(lc_sort) = "Item"
          *-- Set report title
          lc_title = "Detailed Inventory On Hand Report by Item"
        CASE TRIM(lc_sort) = gc_loct
          *-- Set report title
          lc_title = "Detailed Inventory On Hand Report by Location"
        OTHERWISE
          lc_title = "Detailed Inventory On Hand Report by Account"
      ENDCASE

      IF TRIM(lc_sort) = "A"
        lc_desc    = [IIF(TRIM(lc_group)="Item", a_icloct->locdesc, itmdesc)]
        lc_sortkey = [IIF(TRIM(lc_group)=gc_loct, loctid, item)]
        lc_sortdes = [IIF(TRIM(lc_group)="Item", "Item", TRIM(PROPER(gc_loct)))]
      ELSE
        lc_desc    = [IIF(TRIM(lc_sort)="Item", a_icloct->locdesc, itmdesc)]
        lc_sortkey = [IIF(TRIM(lc_sort)=gc_loct, loctid, item)]
        lc_sortdes = [IIF(TRIM(lc_sort)="Item", "Item", TRIM(PROPER(gc_loct)))]
      ENDIF

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      IF NOT EMPTY(ld_asofdt)

        *-- Set report form name
        DO CASE
          CASE lc_detail = "S" AND gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinao
            lc_frx = gc_idrvprg + "syinao"
          CASE lc_detail = "S"
            *# DOCCODE REPORT FORM syinas
            lc_frx = gc_idrvprg + "syinas"
          CASE TRIM(lc_sort) = "Account" AND gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinaa
            lc_frx = gc_idrvprg + "syinaa"
          CASE TRIM(lc_sort) = "Account" AND NOT gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinai
            lc_frx = gc_idrvprg + "syinai"
          CASE TRIM(lc_group) <> "Account" AND gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinal
            lc_frx = gc_idrvprg + "syinal"
          CASE TRIM(lc_group) <> "Account" AND NOT gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinan
            lc_frx = gc_idrvprg + "syinan"
        ENDCASE

      ELSE

        *-- Set report form name
        DO CASE
          CASE lc_detail = "S" AND gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinvo
            lc_frx = gc_idrvprg + "syinvo"
          CASE lc_detail = "S"
            *# DOCCODE REPORT FORM syinvs
            lc_frx = gc_idrvprg + "syinvs"
          CASE TRIM(lc_sort) = "Account" AND gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinva
            lc_frx = gc_idrvprg + "syinva"
          CASE TRIM(lc_sort) = "Account" AND NOT gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinvi
            lc_frx = gc_idrvprg + "syinvi"
          CASE TRIM(lc_group) <> "Account" AND gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinvl
            lc_frx = gc_idrvprg + "syinvl"
          CASE TRIM(lc_group) <> "Account" AND NOT gc_cstmeth $ "LF"
            *# DOCCODE REPORT FORM syinvn
            lc_frx = gc_idrvprg + "syinvn"
        ENDCASE

      ENDIF

    CASE lc_rept = "S03" OR lc_rept = "S11"
      *-- Usage By Location

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_iciloc->loctid  >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_iciloc->loctid  <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set usage condition
      DO CASE
        CASE LEFT(lc_inczero,1) <> "N"
          *-- No YTD usage filter if not selected
        CASE lc_rept <> "S11" OR TRIM(lc_sort) = "Usage Qty"
          lc_filt = lc_filt + [a_iciloc->ytdusqt > 0 AND ]

        CASE TRIM(lc_sort) = "Usage Val"
          lc_filt = lc_filt + [a_iciloc->ytdusvl > 0 AND ]

        CASE TRIM(lc_sort) = "Sales Val"
          lc_filt = lc_filt + [a_iciloc->ytdslvl > 0 AND ]

        CASE TRIM(lc_sort) = "Sales Qty"
          lc_filt = lc_filt + [a_iciloc->ytdslqt > 0 AND ]
      ENDCASE

      *-- Set to ignore deleted records
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., SPACE(0))

      *-- Open Inventory by Location file
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., SPACE(0))

      IF lc_rept = "S03"

        *-- Set sort key field
        DO CASE
          CASE TRIM(lc_sort) = "Sales Qty"
            lc_skey = "YTDSLQT"
          CASE TRIM(lc_sort) = "Sales Val"
            lc_skey = "YTDSLVL"
          CASE TRIM(lc_sort) = "Usage Qty"
            lc_skey = "YTDUSQT"
          CASE TRIM(lc_sort) = "Usage Val"
            lc_skey = "YTDUSVL"
        ENDCASE

        go_SQL.cmpA_Icitem.m_SetOrder("item")
        go_SQL.cmpA_iciloc.m_SetRelation("item", "a_icitem", .f.)

        *-- Set Fitler
        DO l_setflt

        IF NOT EMPTY(go_SQL.cmpA_iciloc.m_getFilter())
          lc_where = " WHERE a_iciloc->item = a_icitem->item AND " + go_SQL.cmpA_iciloc.m_getFilter()
        ELSE
          lc_where = " WHERE a_iciloc->item = a_icitem->item "
        ENDIF

        go_Sql.m_SqlSelect("a_iciloc->loctid, a_iciloc->item, a_iciloc->ytdslqt, a_iciloc->ytdslvl, a_iciloc->ytdusqt, " + ;
        " a_iciloc->ytdusvl, a_icitem->itmdesc FROM " + go_SQL.cmpA_iciloc.sc_tablenamefull + " a_iciloc, " + ;
        go_SQL.cmpA_icitem.sc_tablenamefull + " a_icitem " + ;
        lc_where + " order by loctid, " + lc_skey + " DESC, a_iciloc->item", "SQL TABLE", go_SQL.m_getTempTableName(1))
        go_SQL.so_CurrentAlias.m_CloseTable()

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)

        *-- Set report title
        lc_title = "Usage By " + PROPER(gc_loct) + " Report"

        *-- Set report form name
        *# DOCCODE REPORT FORM iculoc
        lc_frx = gc_icprgdv + "iculoc"
      ELSE
*\ [Begin] PTR 82954 05/30/06 SGOU History file changes
        *-- Open Inventory History file
        ln_opnfl = g_opnfl(gf_icisumf, "a_icisum", .f., .f., SPACE(0))
        g_opnfl(gc_idrvdbf + "sycdfis" + gc_extdbf, "a_sycdfi", .f., .f., "")
    
        *-- Get the periods from the fiscal calendar, because the history files will have
        *-- records only if there are transactions
        go_Sql.m_SqlSelect("TOP " + lc_per + " yearprd, edate FROM " + ;
                  go_Sql.cmpA_sycdfi.sc_TableNameFull + ;
                  " WHERE yearprd < '" + ;
                  gc_fcyr +  gc_fcprd + "' AND compid = '" + gc_CompId + "' " + ;
                  "ORDER BY yearprd DESC", "ARRAY", "la_Periods")

        lc_CuttOffPeriod = la_Periods[go_sql.sn_tally, 1]

        ln_max = go_sql.sn_tally

        *-- Initialize period end dates
        lc_dcl = "DECLARE la_clsdte[" + ALLTRIM(lc_per) + "]"
        &lc_dcl.
        la_clsdte = "N/A"

        *-- Set date array
        FOR lc_dcl = 1 TO ln_max
          la_clsdte[lc_dcl] = la_Periods[lc_dcl, 2]
        NEXT

        DO CASE
          CASE TRIM(lc_sort) = "Sales Qty"
            lc_field1 = "SALESQTY"
            lc_field2 = "A_ICILOC->YTDSLQT"
          CASE TRIM(lc_sort) = "Sales Val"
            lc_field1 = "SALESVAL"
            lc_field2 = "A_ICILOC->YTDSLVL"
          CASE TRIM(lc_sort) = "Usage Qty"
            lc_field1 = "USAGEQTY"
            lc_field2 = "A_ICILOC->YTDUSQT"
          CASE TRIM(lc_sort) = "Usage Val"
            lc_field1 = "USAGEVAL"
            lc_field2 = "A_ICILOC->YTDUSVL"
        ENDCASE

        *-- Break filter expression into macroable (<256 character) pieces
        DECLARE la_filt[3]
        la_filt = SPACE(0)
        = l_retflt(lc_filt, @la_filt)

        *-- Store to local variables for expansion
        lc_filt1 = la_filt[1]
        lc_filt2 = la_filt[2]
        lc_filt3 = la_filt[3]

        IF go_Sql.sc_SqlTypeMain = "F"
          lc_Where = " a_icitem->item = a_iciloc->item AND " + ;
               " a_iciloc->item + a_iciloc->loctid = a_icisum->item + a_icisum->loctid AND " + ;
               " a_icisum->item + a_icisum->loctid <> '" + SPACE(LEN(a_icisum->item)) + "' AND " + ;
               " a_icisum->item + a_icisum->loctid <> '" + PADR('MISC', LEN(a_icisum->item)) + "' AND "
        ELSE
          lc_Where = " a_icitem->item = a_iciloc->item AND " + ;
               " a_iciloc->item = a_icisum->item AND a_iciloc->loctid =  a_icisum->loctid AND " + ;
               " a_icisum->item <> '" + SPACE(LEN(a_icisum->item)) + "' AND " + ;
               " a_icisum->item <> '" + PADR('MISC', LEN(a_icisum->item)) + "' AND "
        ENDIF

        *-- Sum up the history values for the range of periods selected
        go_Sql.m_SqlSelect("a_icisum.item, a_icisum->loctid, SUM(a_icisum->" + lc_field1 + ") AS uqty1 " + ;
                    "FROM " + go_Sql.cmpA_icisum.sc_TableNameFull + " a_icisum " + ;
                    "WHERE a_icisum->yearprd > '" + lc_CuttOffPeriod + ;
                    "' GROUP BY item, loctid", "SQL TABLE",  go_SQL.m_getTempTableName(10))

        go_SQL.so_CurrentAlias.m_CloseTable()

        *-- One SELECT calculates, filters, sorts, creates temp file
        go_SQL.m_SQLSelect("a_icisum->item, a_icisum->loctid, a_icitem->itmdesc, " +;
           "a_icisum->uqty1, 00 AS prd FROM " + ;
           go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem,  " + ;
           go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc," + ;
           go_SQL.m_getTempTableName(10) + " a_icisum WHERE  " + lc_Where + ;
            lc_filt1 + lc_filt2 + lc_filt3 + " ORDER BY a_icisum->loctid, " + lc_field2 + ;
            " DESC, a_icisum->item", "SQL TABLE", go_SQL.m_getTempTableName(1))

        *-- Close temporary file created by SQL-SELECT
        go_SQL.so_CurrentAlias.m_CloseTable()

        go_SQL.m_DropTable(go_SQL.m_getTempTableName(10))
*\ [End] PTR 82954 05/30/06 SGOU History file changes

        *-- Open History Inventory Transaction Detail file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)
        go_SQL.cmpA_Icytrn.m_SetOrder("item1")

        *-- Open Temporary file
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icytrn", .t.)

        go_SQL.m_TableChangeCurrent("a_tmpf1")
 
*\ [4 Lines] PTR 73877 10/27/04 TIMI Filter records based on the total sales
        *-- Filter records based on the total sales
        IF lc_rept = "S11" AND LEFT(lc_inctotzero,1) <> "Y"
          go_SQL.so_CurrentAlias.m_SetFilter("uqty1 > 0")
        ENDIF

        *-- Process to calculate correct period to divide for monthly supply
        go_SQL.cmpA_tmpf1.m_ScanBegin("F", "")
        DO WHILE go_SQL.cmpA_tmpf1.m_ScanBulk()

          IF a_icytrn->item = item
            ld_trndt = a_icytrn->tdate
          ELSE
            ld_trndt = a_ictran->tdate
          ENDIF

          IF ld_trndt <= la_clsdte[ln_max]
            ln_num = ln_max
          ELSE

            FOR lc_dcl = INT(ln_max) TO 1 STEP -1

              IF lc_dcl = 1

                IF ld_trndt > la_clsdte[lc_dcl]
                  ln_num =  1
                ENDIF

              ELSE

                IF ld_trndt > la_clsdte[lc_dcl] AND ;
                   ld_trndt <= la_clsdte[lc_dcl - 1]
                  ln_num =  lc_dcl
                ENDIF

              ENDIF

            NEXT

          ENDIF

          go_SQL.cmpA_tmpf1.m_Replace("prd", ln_num)

        ENDDO
        go_SQL.cmpA_tmpf1.m_ScanEnd()

        *-- Set relation into Inventory Master file
        go_SQL.cmpA_Icitem.m_SetOrder("item")
        go_SQL.cmpA_Iciloc.m_SetOrder("item1")

        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
*\ [1 Line] PTR 82954 05/30/06 SGOU Removed the relation to item hist file which is not used in report
        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icytrn", .t.)
        go_SQL.cmpA_tmpf1.m_SetRelation("item + loctid", "a_iciloc", .t.)

        *-- Display processing message
        DO g_dspst WITH "Calculating Usage Totals...", .t., gn_msgline, ;
                        SPACE(0), SPACE(0), SPACE(0)

        *-- Calculate grand total
        go_SQL.cmpA_tmpf1.m_sum("uqty1", "ln_grdtot","")
        go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)

        *-- Set report title
        lc_title = "Inventory Analysis Report"

        *-- Set report form name
        *# DOCCODE REPORT FORM icianl
        lc_frx = gc_icprgdv + "icianl"
      ENDIF

    CASE lc_rept = "S04"
      *-- Location Detail

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= TRIM(??lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set store condition
      IF NOT EMPTY(lc_bstore)
        lc_filt = lc_filt + [a_iciqty->qstore >= TRIM(??lc_bstore) AND ]
      ENDIF

      IF NOT EMPTY(lc_estore)
        lc_filt = lc_filt + [a_iciqty->qstore <= TRIM(??lc_estore) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set bin condition
      IF NOT EMPTY(lc_bbin)
        lc_filt = lc_filt + [a_iciqty->qbin >= TRIM(??lc_bbin) AND ]
      ENDIF

      IF NOT EMPTY(lc_ebin)
        lc_filt = lc_filt + [a_iciqty->qbin <= TRIM(??lc_ebin) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= TRIM(??lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= TRIM(??lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= TRIM(??lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= TRIM(??lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [qonhand <> 0 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Quantities at Location file
      ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f., "item1")

      go_SQL.cmpA_iciqty.m_SetRelation("item", "a_icitem", .f.)

      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Copy file to acheive optimization
      go_SQL.cmpA_iciqty.m_CopyTo(go_SQL.m_getTempTableName(1),;
             "FOR " + lc_filt1+lc_filt2+lc_filt3+lc_filt4 )

	  go_SQL.cmpA_iciqty.m_SetRelation()
	  go_SQL.cmpA_iciqty.m_SetFilter("")

      ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f., "", .f.)

      go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)

      go_SQL.cmpA_tmpf1.m_SetRelation("OFF", "a_icitem", .f.)

      *-- If grouping by location, create index on all location specs
      IF TRIM(lc_group) = gc_loct
        DO g_dspst WITH "Indexing on " + PROPER(gc_loct) + ;
                        " and Item", ;
                        .t., gn_msgline, SPACE(0), SPACE(0), SPACE(0)

        go_SQL.cmpA_tmpf1.m_createIndex("taglocid","loctid + item + qstore + qbin", "", .t., .f.)
      ELSE
        go_SQL.cmpA_tmpf1.m_createIndex("taglocid","item + loctid + qstore + qbin", "", .t., .f.)
      ENDIF

      *-- If grouping by location
      IF TRIM(lc_group) = gc_loct
        ln_opnloct = g_opnfl(gf_icloctf, "a_icloct", .f., .f., "loctid")
        go_SQL.m_TableChangeCurrent("a_tmpf1")

        *-- Relate to locations file for location description
        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
        go_SQL.cmpA_tmpf1.m_SetRelation("loctid", "a_icloct", .t.)
      ELSE
        go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
      ENDIF

      go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)

      *--                          for non-serialized or lotted items
      go_SQL.cmpA_Iciloc.m_SetOrder("loctid1")
      go_SQL.cmpA_tmpf1.m_SetRelation("a_tmpf1->loctid + a_tmpf1->item", "a_iciloc", .t.)

      *-- Set report form name
      *# DOCCODE REPORT FORM icdloc
      lc_frx = gc_icprgdv + "icdloc"

    CASE lc_rept = "S06"
      *-- Recommended Reorders

      *-- Set stock items only condition
      lc_filt = lc_filt + [a_icitem->stkcode = 'Y' AND ]

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set order point condition
      IF LEFT(lc_inczero,1) = "N"
        lc_filt = lc_filt + [a_iciloc->orderpt > 0 AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_iciloc->loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_iciloc->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set supplier condition
      IF NOT EMPTY(lc_bvendno)
        lc_filt = lc_filt + [a_iciloc->lsupplr >= ??TRIM(lc_bvendno) AND ]
      ENDIF

      IF NOT EMPTY(lc_evendno)
        lc_filt = lc_filt + [a_iciloc->lsupplr <= TRIM(??lc_evendno) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_iciloc->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_iciloc->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set onhand below order point condition
      IF LEFT(lc_incld,1) = "B"
        lc_filt = lc_filt + [(a_iciloc->lonhand +0+ ] + ;
                  [(a_iciloc->lonordr +0+ a_iciloc->lonwkor) - ] + ;
                  [(a_iciloc->lsoaloc +0+ a_iciloc->lwoaloc)) < ] + ;
                  [a_iciloc->orderpt AND ]
      ENDIF

      *-- Set to ignore deleted records
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Unit OF Measure File
      ln_opniloc = g_opnfl(gf_icunmsf, "a_icunms", .f., .f.,"umsconv")

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      go_SQL.cmpA_icitem.m_SetRelation("stkumid", "a_icunms", .f.)

      *-- Open Inventory Suppliers' file
      ln_opnsupl = g_opnfl(gf_icsuplf, "a_icsupl", .f., .f., "item1")

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory by Location file
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f.)

      go_SQL.cmpA_iciloc.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.cmpA_iciloc.m_SetRelation("item + IIF(EMPTY(lsupplr), '" +  Cc_NullStr + "', lsupplr)", "a_icsupl", .t.)

      *-- Set Filter
      DO l_setflt

      *-- Copy to temporary file
      go_SQL.cmpA_iciloc.m_CopyTo(go_SQL.m_getTempTableName(1), "")

      go_SQL.cmpA_iciloc.m_SetRelation("OFF", "a_icsupl", .f.)
      go_SQL.cmpa_iciloc.m_SetRelation("OFF", "a_icitem", .f.)

      *-- Open temporary file
      = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f., "", .f.)
      
      *-- Create temporary index
      IF lc_order = gc_loct
        go_SQL.cmpA_tmpf1.m_createIndex("tagtmp1","loctid + item", "", .t., .f.)
      ELSE
        go_SQL.cmpA_tmpf1.m_createIndex("tagtmp1","lsupplr + item", "", .t., .f.)
      ENDIF

  	  go_SQL.cmpA_tmpf1.m_setOrder("tagtmp1")

*\ [Begin] PTR# 77227 05/24/06 TIVK Include a new column to hold the required qty
      go_SQL.m_AlterTable(ALIAS(), "ADD COLUMN qtyord N(15, 5)")

*\ [2 Lines] PTR 85162 01/19/07 TIRS Set the relation after adding the column.
      *-- Adding a column in VFP removes the relations set with other tables
      *-- Hence moved the relation statement after the Column is added.
      go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.cmpA_tmpf1.m_SetRelation("item + IIF(EMPTY(lsupplr), '" + Cc_NullStr + "', lsupplr)", "a_icsupl", .t.)

      *-- Process to calculate correct period to divide for monthly supply
      go_SQL.cmpA_tmpf1.m_ScanBegin("F", "")

      DO WHILE go_SQL.cmpA_tmpf1.m_ScanBulk()
        ln_QtyReord = l_QtyReord()
        go_SQL.cmpA_tmpf1.m_Replace("qtyord", ln_QtyReord)
      ENDDO

      go_SQl.cmpA_tmpf1.m_ScanEnd()
*\ [End] PTR# 77227 05/24/06 TIVK Include a new column to hold the required qty

      *-- Set report title
      lc_title = "Recommended Reorder Report"

      *-- Set report form name
      *# DOCCODE REPORT FORM icreor
      lc_frx = gc_icprgdv + "icreor"

    CASE lc_rept = "S07"
      *-- Slow Moving Items

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_icisum1->loctid >= TRIM(??lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_icisum1->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set resellable codition
      IF lc_resell = "R"
        lc_filt = lc_filt + [a_icitem->resell= ??gx_True AND ] + ;
                  [a_icitem->stkcode = 'Y' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= TRIM(??lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= TRIM(??lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= TRIM(??lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set usage threshold condition
      IF lc_type = "Turnover"
*\ [Begin] PTR 82954 05/30/06 SGOU History file changes
        lc_filt = lc_filt + "IIF(a_iciloc->lonhand = 0, 0 < 1, a_icisum1->sales12 / " + ;
                                  "a_iciloc->lonhand < 1) AND "
        lc_sum = " SUM(a_icisum.salesval) AS sales12 "
      ELSE

        lc_sum  = " SUM(a_icisum.usageqty) AS usageqty "

        IF ln_units > 0
          lc_filt = lc_filt + " a_icisum1->usageqty < " + ALLTRIM(STR(ln_units)) + " AND "
        ENDIF

      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ NOT (a_icitem->type $ 'AE' )]

      *-- Open Inventory Transaction Detail file
      ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "loctid1")

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory by Location file
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item1")

      *-- Open Inventory History file
      ln_opnhist = g_opnfl(gf_icisumf, "a_icisum", .f., .f.)

      g_opnfl(gc_idrvdbf + "sycdfis" + gc_extdbf, "a_sycdfi", .f., .f., "")

      *-- Get the periods from the fiscal calendar, because the history files will have
      *-- records only if there are transactions
      go_Sql.m_SqlSelect("TOP " + IIF(lc_type = "Turnover", "12", lc_per) + " yearprd, edate FROM " + ;
                go_Sql.cmpA_sycdfi.sc_TableNameFull + ;
                " WHERE yearprd < '" + ;
                gc_fcyr +  gc_fcprd + "' AND compid = '" + gc_CompId + "' " + ;
                "ORDER BY yearprd DESC", "ARRAY", "la_Periods")

      lc_CuttOffPeriod = la_Periods[go_sql.sn_tally, 1]

      go_Sql.m_SqlSelect("a_icisum.item, a_icisum->loctid, " + lc_sum + ;
                  "FROM " + go_Sql.cmpA_icisum.sc_TableNameFull + " a_icisum " + ;
                  "WHERE a_icisum->yearprd > '" + lc_CuttOffPeriod + ;
                  "' GROUP BY item, loctid", "SQL TABLE",  go_SQL.m_getTempTableName(10))

      go_SQL.so_CurrentAlias.m_CloseTable()
      g_opnfl(go_SQL.m_getTempTableName(10), "a_icisum1", .t., .f.)

      go_SQL.cmpA_icisum1.m_MoveRecord(Cn_TopRec)

      go_SQL.cmpA_icisum1.m_SetRelation("item + loctid", "a_iciloc", .f.)
      go_SQL.cmpA_icisum1.m_SetRelation("item", "a_icitem", .t.)

      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      go_SQL.cmpA_icisum1.m_CopyTo(go_SQL.m_getTempTableName(1), "FOR " + lc_filt1+ lc_filt2+lc_filt3+lc_filt4)

      go_SQL.cmpA_icisum1.m_SetRelation("OFF", "a_icitem", .f.)
      go_SQL.cmpA_icisum1.m_SetRelation("OFF", "a_iciloc", .f.)

      go_SQL.cmpA_icisum1.m_CloseTable()

      go_SQL.m_DropTable(go_SQL.m_getTempTableName(10))
*\ [End] PTR 82954 05/30/06 SGOU History file changes

      go_SQL.m_TableChangeCurrent("a_iciloc")
      go_SQL.cmpA_Iciloc.m_SetOrder("item1")

      ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)
      go_SQL.cmpA_tmpf1.m_createIndex("tagitem","item + loctid", "", .t., .f.)
      go_SQL.cmpA_tmpf1.m_SetRelation("item + loctid", "a_iciloc", .f.)
      go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .t.)

      *-- Filter out the record coming from history file header
      go_SQL.cmpA_tmpf1.m_SetFilter("NOT EMPTY(a_tmpf1->item)")

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Slow Moving Items Report"

      *# DOCCODE REPORT FORM icslow
      lc_frx = gc_icprgdv + "icslow"

    CASE lc_rept = "S08"
      *-- Alternate Items

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Set Filter
      DO l_setflt

      go_SQL.cmpA_icitem.m_CopyTo(go_SQL.m_getTempTableName(1), "FIELDS a_icitem->item, a_icitem->itmdesc")

      go_SQL.cmpA_icitem.m_SetFilter("")

      *-- Open temporary file
      ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

      go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Alternate Items Report"

      *# DOCCODE REPORT FORM icalti
      lc_frx = gc_icprgdv + "icalti"

    CASE lc_rept = "S13"
      *-- Cost Tiers

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      IF NOT EMPTY(lc_loctid)
        lc_filt = lc_filt + [a_iccost->loctid = ??TRIM(lc_loctid) AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Cost tiers file
      ln_opncost = g_opnfl(gf_iccostf, "a_iccost")

      *-- Create temporary index
      IF gl_locts
*\ [1 Line] PTR# 80228 09/22/05 TISJ Modified the tag name
        go_SQL.cmpA_iccost.m_createIndex("tagitem", "item + loctid + tier", "", .t., .t.)
      ELSE
*\ [1 Line] PTR# 80228 09/22/05 TISJ Modified the tag name
        go_SQL.cmpA_iccost.m_createIndex("tagitem", "item + tier", "", .t., .t.)
      ENDIF

      go_SQL.cmpA_iccost.m_SetRelation("item", "a_icitem", .f.)

      *-- Set Filter
      DO l_setflt

      go_SQL.cmpA_iccost.m_MoveRecord(Cn_TopRec)

      *-- Set report title
      lc_title = "Costing Tiers Report"

      *-- Set report form name
      IF gl_locts
        *# DOCCODE REPORT FORM ictie2
        lc_frx = gc_icprgdv + "ictie2"
      ELSE
        *# DOCCODE REPORT FORM ictier
        lc_frx = gc_icprgdv + "ictier"
      ENDIF

    CASE lc_rept = "S14"
      *-- ABC Exception

      *-- Reset the processing variables
      ln_accum  = 0.000
	  STORE 0 TO ln_abamt, ln_bcamt, ln_totval

      *-- Convert percentages to hundredths
      ln_abpct = ln_abpct / 100.0
      ln_bcpct = ln_bcpct / 100.0

      *-- Open Locations file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., SPACE(0))

      *-- Create abridged temp file
      go_sql.m_SQLSelect("item, iyusvl, iyslvl, ionhand, abccode, iyslqt as itmiyslqt, " + ;
        "iyslvl as itmiyslvl, iyusqt as itmiyusqt, iyusvl as itmiyusvl, abccode as itmabccode, " + ;
        "00000000000.00000 as lclcohv  FROM " + ;
        go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem  WHERE a_icitem->stkcode = 'Y' AND a_icitem->type = 'I'", ;
        "TABLE", go_SQL.m_getTempTableName(1, "F"))
      go_SQL.so_CurrentAlias.m_CloseTable()

      *-- Open temp file exclusively
      ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1, "F"), ;
                   "a_tmpf1", .t., .f., "", .f., "F")

      go_SQL.cmpA_Icitem.m_SetOrder("item")

      *-- Used VFP scan here since its VFP table
      SCAN
        *-- Replace onhand quantity with on hand value
        *-- Used onhand value from location file for multiple locations
        go_SQL.cmpA_tmpf1.m_Replace("ionhand", IIF(gl_locts, l_clcohv(), g_clcohv('VALUE', .f.)))
      ENDSCAN

      *-- Index temp file to order on usage or value
      IF LEFT(lc_type, 1) = "U"
        *-- Order file on accum. annual usage value ($)
        go_SQL.cmpA_tmpf1.m_createIndex("tagiyusvl","0.00000 - iyusvl", "", .t., .f.)
      ELSE
        *-- Use the iohnand udpated above to create index
        go_SQL.cmpA_tmpf1.m_createIndex("tagonhand","0.00000 - ionhand", "", .t., .f.)
      ENDIF

      *-- Use a_tmpf1->iyslvl as scratch field
      *--   (containing accum. annual usage/onhand value ($))
      *-- This needs to be done after indexing
      SCAN
        ln_accum = ln_accum + IIF(TRIM(lc_type) = "U", a_tmpf1->iyusvl, ;
                   a_tmpf1->ionhand)

        go_SQL.cmpA_tmpf1.m_Replace("iyslvl", ln_accum)
      ENDSCAN

      *-- Get total inventory value
      go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_BottRec)
      ln_totval = a_tmpf1->iyslvl

      *-- Calculate break points (convert from % to $)
      ln_abamt = ln_abpct * ln_totval
      ln_bcamt = (1 - ln_bcpct) * ln_totval

      *-- Remove records with correct code in item master file
      *-- Remaining records get marked with suggested code

      go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)

      go_SQL.cmpA_tmpf1.m_ScanBegin("", "")
      DO WHILE go_SQL.cmpA_tmpf1.m_Scan()

        DO CASE
          CASE iyslvl <= ln_abamt

            IF a_tmpf1->itmabccode = "A"
              go_SQL.cmpA_tmpf1.m_Delete()
            ELSE
              go_SQL.cmpA_tmpf1.m_Replace("abccode", 'A')
            ENDIF

          CASE iyslvl <= ln_bcamt

            IF a_tmpf1->itmabccode = "B"
              go_SQL.cmpA_tmpf1.m_Delete()
            ELSE
              go_SQL.cmpA_tmpf1.m_Replace("abccode", 'B')
            ENDIF

          CASE iyslvl > ln_bcamt

            IF a_tmpf1->itmabccode = "C"
              go_SQL.cmpA_tmpf1.m_Delete()
            ELSE
              go_SQL.cmpA_tmpf1.m_Replace("abccode", 'C')
            ENDIF

        ENDCASE

      ENDDO
      go_SQL.cmpA_tmpf1.m_ScanEnd()


      *-- Set report title
      lc_title = "ABC Exception Report"

      *-- Set report form name
      *# DOCCODE REPORT FORM icabcs
      lc_frx = gc_icprgdv + "icabcs"

    CASE lc_rept = "S15"
      *-- Serial/Lot Stock Status
      DO l_icrept_s15

    CASE lc_rept = "T01"
      *-- Consolidated Transactions

      gl_landscp = .t.

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>= '] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate)<= '] + DTOS(ld_fedate) + [' AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "tdate1")
        ln_reccnt = go_SQL.cmpA_ictran.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        *-- Retrieve records from history file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "tdate1")
        ln_reccnt = ln_reccnt + go_SQL.cmpA_icytrn.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_ictran")

        go_SQL.cmpA_ictran.m_SetRelation("item", "a_icitem", .f.)
        *-- Added new fields trcost, tftcost
        go_SQL.m_SQLSelect("a_ictran->tdate, " + ;
               "a_ictran->ttranno, " + ;
               "a_ictran->trantyp, " + ;
               "a_ictran->docno, " + ;
               "a_ictran->item, " + ;
               "a_ictran->udref, " + ;
               "a_ictran->loctid, " + ;
               "a_ictran->lotno, " + ;
               "a_ictran->serial, " + ;
               "a_ictran->sqty, " + ;
               "a_ictran->tcost, " + ;
               "a_ictran->applid, " + ;
               "a_icitem->itmclss, " + ;
               "a_icitem->stkumid, " + ;
               "a_ictran->umeasur, " + ;
               "a_ictran->tqty, " + ;
               "a_ictran->taxrate, " + ;
               "a_ictran->currid, " + ;
               "a_ictran->ftcost, " + ;
               "a_ictran->trcost, " + ;
               "a_ictran->tftcost FROM " + go_SQL.cmpa_ictran.sc_tableNameFull + " a_ictran, " + ;
               go_SQL.cmpa_icitem.sc_tableNameFull + " a_icitem WHERE " + ;
               "a_icitem->item = a_ictran.item AND " + ;
               lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(1) )
        go_SQL.so_currentAlias.m_closeTable()

        go_SQL.cmpa_ictran.m_SetRelation("OFF", "a_icitem", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        *-- Get records from history
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.cmpA_icytrn.m_SetRelation("item", "a_icitem", .f.)
        *-- Added new fields trcost, tftcost
        go_SQL.m_SQLSelect("a_icytrn->tdate, " + ;
               "a_icytrn->ttranno, " + ;
               "a_icytrn->trantyp, " + ;
               "a_icytrn->docno, " + ;
               "a_icytrn->item, " + ;
               "a_icytrn->udref, " + ;
               "a_icytrn->loctid, " + ;
               "a_icytrn->lotno, " + ;
               "a_icytrn->serial, " + ;
               "a_icytrn->sqty, " + ;
               "a_icytrn->tcost, " + ;
               "a_icytrn->applid, " + ;
               "a_icitem->itmclss, " + ;
               "a_icitem->stkumid, " + ;
               "a_icytrn->umeasur, " + ;
               "a_icytrn->tqty, " + ;
               "a_icytrn->taxrate, " + ;
               "a_icytrn->currid, " + ;
               "a_icytrn->ftcost, " + ;
               "a_icytrn->trcost, " + ;
               "a_icytrn->tftcost FROM " + go_SQL.cmpa_icytrn.sc_tableNameFull + " a_icytrn, " + ;
               go_SQL.cmpa_icitem.sc_tableNameFull + " a_icitem WHERE " + ;
               "a_icitem->item = a_icytrn.item AND " + ;
               lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(2))
        go_SQL.so_currentAlias.m_closeTable()

        go_SQL.cmpa_icytrn.m_SetRelation("OFF", "a_icitem", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.,"", .f.)

        *-- Append from history records table only for 'Both' option
        IF go_sql.m_isTableFound(go_SQL.m_getTempTableName(2)) AND LEFT(lc_file,1) = "B"
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")

          go_sql.m_dropTable(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

      ELSE

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

      IF gl_po

        *-- Scan the temp file and include tax in cost of PO transactions
        *-- Use m_ReplaceBulk with SQLUpdate parameter instead of m_ScanBulk
        go_SQL.so_CurrentAlias.m_ReplaceBulk("tcost WITH g_extnd(5, tcost, 1, -taxrate), " + ;
                                             "ftcost WITH g_extnd(5, ftcost, 1, -taxrate), " + ;
                                             "trcost WITH g_extnd(5, trcost, 1, -taxrate), " + ;
                                             "tftcost WITH g_extnd(5, tftcost, 1, -taxrate)", ;
                                             "F", "applid = 'PO' AND taxrate > 0", .t.)

        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
      ENDIF

      *-- Index temporary file
      DO CASE
        CASE LEFT(lc_order,1) = "D"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid","loctid + itmclss + DTOS(tdate) + item + ttranno", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss","itmclss + DTOS(tdate) + item + ttranno", "", .t., .f.)
          ENDIF

        CASE LEFT(lc_order,1) = "S"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid", "loctid + itmclss + applid + item + ttranno", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss","itmclss + applid + item+ ttranno", "", .t., .f.)
          ENDIF

      ENDCASE

      *-- Set relation to Item file
      go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Consolidated Transactions Report"

      DO CASE
        CASE gl_lots AND gl_serial

          IF gl_locts
            *# DOCCODE REPORT FORM icctlb
            lc_frx = gc_icprgdv + "icctlb"
          ELSE
            *# DOCCODE REPORT FORM icctrb
            lc_frx = gc_icprgdv + "icctrb"
          ENDIF

        CASE gl_lots

          IF gl_locts
            *# DOCCODE REPORT FORM icctll
            lc_frx = gc_icprgdv + "icctll"
          ELSE
            *# DOCCODE REPORT FORM icctrl
            lc_frx = gc_icprgdv + "icctrl"
          ENDIF

        CASE gl_serial

          IF gl_locts
            *# DOCCODE REPORT FORM icctls
            lc_frx = gc_icprgdv + "icctls"
          ELSE
            *# DOCCODE REPORT FORM icctrs
            lc_frx = gc_icprgdv + "icctrs"
          ENDIF

        OTHERWISE

          IF gl_locts
            *# DOCCODE REPORT FORM icctln
            lc_frx = gc_icprgdv + "icctln"
          ELSE
            *# DOCCODE REPORT FORM icctrn
            lc_frx = gc_icprgdv + "icctrn"
          ENDIF

      ENDCASE

    CASE lc_rept = "T02"
      *-- Inventory Issues

      *-- Set transaction type condition
      IF go_Sql.sc_SqlTypeMain = "F"

        IF lc_applid = "BP"
          lc_filt   = lc_filt + [trantyp+a_icitem->item+ttranno%=%'EI%/%' AND ]
          lc_applid = "SO"
        ELSE
          lc_filt = lc_filt + [(trantyp+a_icitem->item+ttranno %=%' I%/%' OR ] + ;
                    [trantyp+a_icitem->item+ttranno%=%'RI%/%' OR ] + ;
                    [trantyp+a_icitem->item+ttranno%=%'EI%/%') AND ]
        ENDIF

      ELSE

        IF lc_applid = "BP"
          lc_filt   = lc_filt + [trantyp = 'EI' AND ]
          lc_applid = "SO"
        ELSE
          lc_filt = lc_filt + [(trantyp = ' I' OR trantyp = 'RI' OR trantyp = 'EI') AND ]
        ENDIF

      ENDIF

*\ [1 Line] PTR 82565 04/28/06 TIRS Included condition lc_Applid <> "InterCompany"
      *-- Set originating application condition
      IF (lc_applid <> "All" AND lc_Applid <> "InterCompany")
        lc_filt = lc_filt + [applid='] + lc_applid + [' AND ]
      ENDIF

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(ld_fedate) + [' AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

*\ [Begin] PTR 82565 04/28/06 TIRS Implementation of Inter Company transfer
      IF NOT INLIST(lc_Applid, "All", "InterCompany")
        *-- For the individual application look for records not marked as
        *-- ICICTS in ICTRAN
        lc_Filt = lc_Filt + [icicts = .f. AND ]
      ELSE

        IF lc_Applid = "InterCompany"
          *-- Look for records marked as ICICTS only for Intercomp transfer
          lc_Filt = lc_Filt + [icicts = .t. AND ]
        ENDIF

      ENDIF

      IF INLIST(lc_Applid, "InterCompany", "All")
        lc_IctFilt  = ""
        *-- Set Company condition
        IF NOT EMPTY(lc_BComp)
          lc_Ictfilt = lc_Ictfilt + [compid >= ??TRIM(lc_Bcomp) AND ]
        ENDIF

        IF NOT EMPTY(lc_EComp)
          lc_Ictfilt = lc_Ictfilt + [compid < TRIM(??lc_EComp) OR compid %=% TRIM(??lc_EComp) + '%/%']
        ENDIF
      ENDIF

      *-- Open ICICTS File and look if any company specifc record is thre
      ln_opnicts = g_opnfl(gf_Icictsf, "a_icicts", .f., .f., "ttranno")

      IF INLIST(lc_Applid, "All", "InterCompany")
        go_SQL.cmpA_Icicts.m_SetFilter(lc_IctFilt)

        IF go_SQL.cmpA_Icicts.m_Count("") = 0
          lc_Filt = lc_Filt + [icicts = .f. AND ]
        ENDIF
      ENDIF
*\ [End] PTR 82565 04/28/06 TIRS

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)
        go_SQL.cmpA_Ictran.m_SetOrder(0)
        ln_reccnt = go_SQL.cmpA_Ictran.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        *-- Retrieve records from history file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)
        go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ln_reccnt = ln_reccnt + go_SQL.cmpA_Icytrn.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_ictran")

        go_SQL.cmpA_Ictran.m_SetRelation("item", "a_icitem", .f.)

*\ [1 Line] PTR 82565 04/28/06 TIRS Included icicts field
        *-- Added new fields trcost, tftcost
        go_SQL.m_SQLSelect("a_ictran->ttranno, " + ;
               "a_ictran->tdate, " + ;
               "a_ictran->docno, " + ;
               "a_ictran->tranlineno, " + ;
               "a_ictran->item, " + ;
               "a_ictran->udref, " + ;
               "a_ictran->loctid, " + ;
               "a_ictran->sqty, " + ;
               "a_ictran->tqty, " + ;
               "a_ictran->umeasur, " + ;
               "a_ictran->tcost, " + ;
               "a_ictran->applid, " + ;
               "a_icitem->itmclss, " + ;
               "a_icitem->stkumid, " + ;
               "a_ictran->taxrate, " + ;
               "a_ictran->trcost, " + ;
               "a_ictran->tftcost, a_ictran->icicts FROM " + go_SQL.cmpa_ictran.sc_tableNameFull + " a_ictran left join " + ;
               go_sql.cmpA_icitem.sc_tableNameFull + " as a_icitem on a_ictran.item=a_icitem.item WHERE " + ;
               lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(1))

        go_SQL.so_currentAlias.m_closeTable()

        go_SQL.cmpa_ictran.m_SetRelation("OFF", "a_icitem", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.cmpA_icytrn.m_SetRelation("item", "a_icitem", .f.)

*\ [1 Line] PTR 82565 04/28/06 TIRS Included icicts field
        *-- Added new fields trcost, tftcost
        go_SQL.m_SQLSelect("a_icytrn->ttranno, " + ;
               "a_icytrn->tdate, " + ;
               "a_icytrn->docno, " + ;
               "a_icytrn->tranlineno, " + ;
               "a_icytrn->item, " + ;
               "a_icytrn->udref, " + ;
               "a_icytrn->loctid, " + ;
               "a_icytrn->sqty, " + ;
               "a_icytrn->tqty, " + ;
               "a_icytrn->umeasur, " + ;
               "a_icytrn->tcost, " + ;
               "a_icytrn->applid, " + ;
               "a_icitem->itmclss, " + ;
               "a_icitem->stkumid, " + ;
               "a_icytrn->taxrate, " + ;
               "a_icytrn->trcost, " + ;
               "a_icytrn->tftcost, a_icytrn->icicts FROM " + go_SQL.cmpa_icytrn.sc_tableNameFull + " a_icytrn left join " + ;
               go_SQL.cmpa_icitem.sc_tableNameFull + " as a_icitem on a_icytrn.item=a_icitem.item WHERE " + ;
               lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(2))

        go_SQL.so_currentAlias.m_closeTable()

        go_SQL.cmpa_icytrn.m_SetRelation("OFF", "a_icitem", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")

          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

      ELSE
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

*\ [Begin] PTR 82565 04/28/06 TIRS Set relation to ttranno of ICICTS
      lc_TempAlias = ALIAS()
      *-- Add new column to hold compid
      go_SQL.m_AlterTable(lc_TempAlias, "ADD COLUMN compid C(10)")

      go_SQL.so_CurrentAlias.m_CreateIndex("ttranno", "ttranno", .f., .f.)
      go_SQL.so_CurrentAlias.m_SetRelation("ttranno", "a_Icicts", .t.)

      IF INLIST(lc_Applid, "All", "InterCompany")
        *-- Replace Compid with the compid in ICICTS
        go_SQL.so_CurrentAlias.m_ReplaceBulk("compid WITH a_icicts->compid", "F", ;
                                             "&lc_TempAlias.->ttranno = a_icicts->ttranno")

        IF NOT EMPTY(lc_IctFilt)
          *-- For company filter delete records with Blank company ID
          go_SQL.so_CurrentAlias.m_DeleteBulk("F", "EMPTY(compid) AND icicts = .t.", .t.) 
        ENDIF

      ENDIF
*\ [End] PTR 82565 04/28/06 TIRS Set relation to ttranno of ICICTS

      IF gl_po AND (lc_applid = "All" OR lc_applid = "PO")

        *-- Scan the temp file and include tax in cost of PO returns
        *-- include tax in cost of PO returns
        *-- Replaced new field trcost
        go_SQL.so_CurrentAlias.m_ReplaceBulk("tcost WITH g_extnd(5, tcost, 1, -taxrate), " + ;
           "trcost WITH g_extnd(5, trcost, 1, -taxrate)", ;
           "F", "applid = 'PO' AND taxrate > 0", .t.)

        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
      ENDIF

*\ [Begin] PTR 82565 04/28/06 TIRS Index on compid field
      *-- Index temporary file
      DO CASE
        CASE LEFT(lc_order,1) = "D"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid", ;
                  "loctid + compid + itmclss + DTOS(tdate) + item", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss", ;
                  "compid + itmclss + DTOS(tdate) + item", "", .t., .f.)
          ENDIF

        CASE LEFT(lc_order,1) = "I"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid", ;
                  "loctid + compid + itmclss + item + applid + docno", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss", ;
                  "compid + itmclss + item + applid + docno", "", .t., .f.)
          ENDIF

        CASE LEFT(lc_order,1) = "S"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid", ;
                  "loctid + compid + itmclss + applid + item", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss", ;
                  "compid + itmclss + applid + item", "", .t., .f.)
          ENDIF

        CASE LEFT(lc_order,1) = "T"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid", ;
                  "loctid + compid + itmclss + ttranno", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss", ;
                  "compid + itmclss + ttranno", "", .t., .f.)
         ENDIF

      ENDCASE
*\ [End] PTR 82565 04/28/06 TIRS Index on compid field

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Inventory Issues Report"

      DO CASE
        CASE LEFT(lc_order,1) $ "DS" AND lc_applid $ "AR|PO|SO"

          IF gl_locts
            *# DOCCODE REPORT FORM icisu1
            lc_frx = gc_icprgdv + "icisu1"
          ELSE
            *# DOCCODE REPORT FORM icisu2
            lc_frx = gc_icprgdv + "icisu2"
          ENDIF

        CASE LEFT(lc_order,1) $ "DS" AND NOT lc_applid $ "AR|PO|SO"

          IF gl_locts
            *# DOCCODE REPORT FORM icisu3
            lc_frx = gc_icprgdv + "icisu3"
          ELSE
            *# DOCCODE REPORT FORM icisu4
            lc_frx = gc_icprgdv + "icisu4"
          ENDIF

        CASE LEFT(lc_order,1) $ "IT" AND lc_applid $ "AR|PO|SO"

          IF gl_locts
            *# DOCCODE REPORT FORM icisu5
            lc_frx = gc_icprgdv + "icisu5"
          ELSE
            *# DOCCODE REPORT FORM icisu6
            lc_frx = gc_icprgdv + "icisu6"
          ENDIF

        CASE LEFT(lc_order,1) $ "IT" AND NOT lc_applid $ "AR|PO|SO"

          IF gl_locts
            *# DOCCODE REPORT FORM icisu7
            lc_frx = gc_icprgdv + "icisu7"
          ELSE
            *# DOCCODE REPORT FORM icisu8
            lc_frx = gc_icprgdv + "icisu8"
          ENDIF

      ENDCASE

*\ [Begin] PTR 83058 07/10/06 TIRS Fetch records from ICICTS and passed it on the 
    CASE lc_Rept = "T11"
      *-- Unposted Inter-company Receipts

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(ld_fedate) + [' AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= TRIM(??lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [item >= TRIM(??lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set Company condition
      IF NOT EMPTY(lc_BComp)
        lc_filt = lc_filt + [compid >= ??TRIM(lc_Bcomp) AND ]
      ENDIF

      IF NOT EMPTY(lc_EComp)
        lc_filt = lc_filt + [compid < TRIM(??lc_EComp) OR compid %=% TRIM(??lc_EComp) + '%/%' AND ]
      ENDIF

      lc_filt = lc_filt + "ictstatus = ' '"

      go_SQL.m_SQLSelect(" * FROM " + gf_icictsf + " a_icicts " + ;
                         "WHERE " + lc_Filt, ;
                         "TABLE", go_SQL.m_GetTempTableName(9, "F"))
      go_SQL.so_CurrentAlias.m_CloseTable()

      = g_opnfl(go_SQL.m_GetTempTableName(9, "F"), "a_tmpf9", .f., .f., "", , "F")

      go_SQL.cmpA_Tmpf9.m_CreateIndex("compid", "compid + item", "", .t., .f.)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Unposted Inter-Company Receipts Report"

      *# DOCCODE REPORT FORM icuprc
      lc_frx = gc_icprgdv + "icuprc"
*\ [End] PTR 83058 07/10/06 TIRS Fetch records from ICICTS and passed it on the 

    CASE lc_rept = "T03"
      *-- Inventory Receipts

      *-- Set transaction type condition
      IF lc_applid = "BP"
        lc_filt   = lc_filt + [trantyp+a_icitem.item+ttranno%=%'ER%/%' AND ]
        lc_applid = "SO"
      ELSE
        lc_filt = lc_filt + [(trantyp+a_icitem.item+ttranno%=%' R%/%' OR ] + ;
                  [trantyp+a_icitem.item+ttranno%=%'RR%/%' OR ] + ;
                  [trantyp+a_icitem.item+ttranno%=%'ER%/%') AND ]
      ENDIF

*\ [1 Line] PTR 82565 04/28/06 TIRS Included condition lc_Applid <> "InterCompany"
      *-- Set originating application condition
      IF (lc_applid <> "All" AND lc_Applid <> "InterCompany")
        lc_filt = lc_filt + [applid= '] + lc_applid + [' AND ]
      ENDIF

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(ld_fedate) + [' AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= TRIM(??lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = LEFT(??lc_type,1) AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= TRIM(??lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= TRIM(??lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= TRIM(??lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

*\ [Begin] PTR 82565 04/28/06 TIRS Implementation of Intercompany transfer
      IF INLIST(lc_Applid, "InterCompany", "All")

        lc_IctFilt  = ""

        *-- Set Company condition
        IF NOT EMPTY(lc_BComp)
          lc_Ictfilt = lc_Ictfilt + [compid >= ??TRIM(lc_Bcomp) AND ]
        ENDIF

        IF NOT EMPTY(lc_EComp)
          lc_Ictfilt = lc_Ictfilt + [compid < TRIM(??lc_EComp) OR compid %=% TRIM(??lc_EComp) + '%/%']
        ENDIF
      ENDIF

      IF NOT INLIST(lc_Applid, "All", "InterCompany")
        *-- For the individual application look for records not marked as
        *-- ICICTS in ICTRAN
        lc_Filt = lc_Filt + [icicts = .f. AND ]
      ELSE

        IF lc_Applid = "InterCompany"
          *-- Look for records marked as ICICTS only for Intercomp transfer
          lc_Filt = lc_Filt + [icicts = .t. AND ]
        ENDIF

      ENDIF

      *-- Open ICICTS File and see if any company record exist
      ln_opnicts = g_opnfl(gf_Icictsf, "a_icicts", .f., .f., "ttranno")

      IF INLIST(lc_Applid, "All", "InterCompany")
        go_SQL.cmpA_Icicts.m_SetFilter(lc_IctFilt)

        IF go_SQL.cmpA_Icicts.m_Count("") = 0
          lc_Filt = lc_Filt + [icicts = .f. AND ]
        ENDIF
      ENDIF
*\ [End] PTR 82565 04/28/06 TIRS Implementation of Intercompany transfer

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open current distribution file
        ln_opndist = g_opnfl(gf_icdistf, "a_icdist", .f., .f., "tranno")
        go_SQL.cmpA_icdist.m_SetFilter("dsttype = 'DC'")

        go_SQL.cmpA_icdist.m_CopyTo(go_SQL.m_getTempTableName(9), ;
                                    "", "S" )

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(9), "a_tmpf9", .t., .f., "", .f.)

        go_SQL.cmpA_tmpf9.m_CreateIndex("tranno", "tranno", "", .t., .f.)

        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)

        go_SQL.cmpA_Ictran.m_SetOrder(0)
        ln_reccnt = go_SQL.so_CurrentAlias.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        *-- Retrieve records from history file
        ln_opnydst = g_opnfl(gf_icydstf, "a_icydst", .f., .f., "tranno")
        go_SQL.cmpA_icydst.m_SetFilter("dsttype = 'DC'")

        go_SQL.cmpA_icydst.m_CopyTo(go_SQL.m_getTempTableName(8), ;
                                    "", "S" )

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(8), "a_tmpf8", .t., .f., "", .f.)

        go_SQL.cmpA_tmpf8.m_CreateIndex("tranno", "tranno", "", .t., .f.)

        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)

        go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ln_reccnt = ln_reccnt + go_SQL.cmpA_icydst.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        *-- Added new field trcost, tftcost
        go_SQL.m_TableChangeCurrent("a_ictran")
        go_SQL.so_CurrentAlias.m_SetRelation("ttranno", "a_tmpf9", .f.)
        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .t.)

*\ [1 Line] PTR 82565 04/28/06 TIRS Included ttranno and icicts field also
        go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(1), ;
                                        "FIELDS tdate, " + ;
                                        "docno, " + ;
                                        "a_ictran->item, " + ;
                                        "loctid, " + ;
                                        "sqty, " + ;
                                        "tqty, " + ;
                                        "umeasur, " + ;
                                        "tcost, " + ;
                                        "a_tmpf9->glacnt, " + ;
                                        "applid, " + ;
                                        "a_icitem->itmclss, " + ;
                                        "a_icitem->stkumid, " + ;
                                        "taxrate, " + ;
                                        "currid, " + ;
                                        "ftcost, " + ;
                                        "trcost, " + ;
                                        "tftcost, " + ;
                                        "ttranno, icicts FOR " + ;
                                        lc_filt1+lc_filt2+lc_filt3+lc_filt4 )

        go_SQL.cmpa_ictran.m_SetRelation("OFF", "a_tmpf9", .f.)
        go_SQL.cmpa_ictran.m_SetRelation("OFF", "a_icitem", .f.)

        IF go_SQL.m_IsUsed("a_tmpf9")
          go_SQL.cmpA_Tmpf9.m_CloseTable()
        ENDIF

        go_SQL.m_DropTable(go_SQL.m_GetTempTableName(9))
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.cmpA_icytrn.m_SetRelation("ttranno", "a_tmpf8", .f.)
        go_SQL.cmpA_icytrn.m_SetRelation("item", "a_icitem", .t.)

*\ [1 Line] PTR 82565 04/28/06 TIRS Included ttranno and icicts field
        *-- Added new field trcost, tftcost
        go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(2), ;
                                        "FIELDS tdate, " + ;
                                        "docno, " + ;
                                        "a_icytrn->item, " + ;
                                        "loctid, " + ;
                                        "sqty, " + ;
                                        "tqty, " + ;
                                        "umeasur, " + ;
                                        "tcost, " + ;
                                        "a_tmpf8->glacnt, " + ;
                                        "applid, " + ;
                                        "a_icitem->itmclss, " + ;
                                        "a_icitem->stkumid, " + ;
                                        "taxrate, " + ;
                                        "currid, " + ;
                                        "ftcost, " + ;
                                        "trcost, " + ;
                                        "tftcost, " + ;
                                        "ttranno, icicts FOR " + ;
                                        lc_filt1+lc_filt2+lc_filt3+lc_filt4)

        go_SQL.cmpa_icytrn.m_SetRelation("OFF", "a_icitem", .f.)
        go_SQL.cmpa_icytrn.m_SetRelation("OFF", "a_tmpf8", .f.)

        IF go_SQL.m_IsUsed("a_tmpf8")
          go_SQL.cmpA_Tmpf8.m_CloseTable()
        ENDIF

        go_SQL.m_DropTable(go_SQL.m_GetTempTableName(8))
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.,"", .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))

          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

      ELSE

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f., "", .f.)
      ENDIF

*\ [Begin] PTR 82565 04/28/06 TIRS Set relation to ttranno of ICICTS
      lc_TempAlias = ALIAS()

      *-- Add new column to hold compid
      go_SQL.m_AlterTable(lc_TempAlias, "ADD COLUMN compid C(10)")

      go_SQL.so_CurrentAlias.m_CreateIndex("ttranno", "ttranno", .f., .f.)
      go_SQL.so_CurrentAlias.m_SetRelation("ttranno", "a_Icicts", .t.)

      IF INLIST(lc_Applid, "All", "InterCompany")
        *-- Replace Compid with the compid in ICICTS
        go_SQL.so_CurrentAlias.m_ReplaceBulk("compid WITH a_icicts->compid", "F", ;
                                             "&lc_TempAlias.->ttranno = a_icicts->ttranno")

        IF NOT EMPTY(lc_IctFilt)
          *-- If there is a company filter delete the records with a blank compid
          go_SQL.so_CurrentAlias.m_DeleteBulk("F", "EMPTY(compid) AND icicts = .t.", .t.) 
        ENDIF

      ENDIF
*\ [End] PTR 82565 04/28/06 TIRS Set relation to ttranno of ICICTS

      IF gl_po AND (lc_applid = "All" OR lc_applid = "PO")

        *-- Scan the temp file and include tax in cost of PO receipts
        go_SQL.so_CurrentAlias.m_ReplaceBulk("tcost WITH g_extnd(5, tcost, 1, -taxrate), " + ;
                                             "ftcost WITH g_extnd(5, ftcost, 1, -taxrate), " + ;
                                             "trcost WITH g_extnd(5, trcost, 1, -taxrate), " + ;
                                             "tftcost WITH g_extnd(5, tftcost, 1, -taxrate)", ;
                                             "F", "applid = 'PO' AND taxrate > 0", .t.)

        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
      ENDIF

*\ [Begin] PTR 82565 04/28/06 TIRS Index on compid Field
      *-- Index temporary file
      DO CASE
        CASE LEFT(lc_order,1) = "A"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex("tagloctid","loctid + compid + itmclss + glacnt + item", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex("tagitmclss","compid + itmclss + glacnt + item", "", .t., .f.)
          ENDIF

        CASE LEFT(lc_order,1) = "D"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                   "loctid + compid + itmclss + DTOS(tdate) + item", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "compid + itmclss + DTOS(tdate) + item", "", .t., .f.)
          ENDIF

        CASE LEFT(lc_order,1) = "S"

          IF gl_locts
            go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "loctid + compid + itmclss + applid + item", "", .t., .f.)
          ELSE
            go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "itmclss + compid + applid + item", "", .t., .f.)
          ENDIF

      ENDCASE
*\ [End] PTR 82565 04/28/06 TIRS Index on compid Field

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Inventory Receipts Report"

      gl_landscp = .t.

      IF gl_locts
        *# DOCCODE REPORT FORM icrcpl
        lc_frx = gc_icprgdv + "icrcpl"
      ELSE
        *# DOCCODE REPORT FORM icrcpt
        lc_frx = gc_icprgdv + "icrcpt"
      ENDIF

    CASE lc_rept = "T04"
      *-- Inventory Adjustments

      *-- Set adjustment type condition
      DO CASE
        CASE lc_adjtype = "Physical"
          lc_filt = lc_filt + [LEFT(trantyp,1)='P' AND ]
        CASE lc_adjtype = "Recosting"
          lc_filt = lc_filt + [(trantyp='CI' OR ] + ;
                    [trantyp='CR') AND ]

        CASE lc_adjtype = "Adjusting"
          lc_filt = lc_filt + [trantyp='CA' AND ]
        OTHERWISE
          lc_filt = lc_filt + [(LEFT(trantyp,1)='P' OR ] + ;
                    [LEFT(trantyp,1)='C') AND ]

      ENDCASE

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

*\ [1 Line] PTR# 67009 04/06/05 TINN Removed checking of gl_sbtmod to support date range
      *-- Set transaction date condition
      IF NOT EMPTY(CTOD(lc_bdate))
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(CTOD(lc_bdate)) + [' AND ]
      ENDIF

      IF NOT EMPTY(CTOD(lc_edate))
        lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(CTOD(lc_edate)) + [' AND ]
      ENDIF

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)

        go_SQL.cmpA_Ictran.m_SetOrder(0)
        ln_reccnt = go_SQL.cmpA_Ictran.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)

        go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ln_reccnt = ln_reccnt + go_SQL.cmpA_Icytrn.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_ictran")

        go_SQL.cmpA_Ictran.m_SetRelation("item", "a_icitem", .f.)
        *-- Added new fields trcost, tftcost
        go_SQL.m_sqlSelect("tdate, trantyp, udref, docno, a_ictran->item, a_icitem->itmdesc, loctid, " + ;
          "applid, sqty, tqty, tcost, a_icitem->type, a_icitem->stkumid, a_icitem->itmclss, umeasur, " + ;
          "trcost, tftcost FROM " + go_sql.cmpA_ictran.sc_tableNameFull + " a_ictran left join " + ;
          go_sql.cmpA_icitem.sc_tableNameFull + " as a_icitem on a_ictran.item=a_icitem.item WHERE " + ;
          lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(1))
        go_SQL.so_currentAlias.m_closeTable()

        go_SQL.cmpA_ictran.m_SetRelation("OFF", "a_icitem", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.cmpA_icytrn.m_SetRelation("item", "a_icitem", .f.)
        *-- Added new fields trcost, tftcost
        go_SQL.m_sqlSelect("tdate, trantyp, udref, docno, a_icytrn->item, a_icitem->itmdesc, loctid, applid, sqty, tqty, " + ;
          "tcost, a_icitem->type, a_icitem->stkumid, a_icitem->itmclss, umeasur, " + ;
          "trcost, tftcost FROM " + go_sql.cmpA_icytrn.sc_tableNameFull + " a_icytrn left join " + ;
          go_sql.cmpA_icitem.sc_tableNameFull + " as a_icitem on a_icytrn.item=a_icitem.item WHERE " + ;
          lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(2))
        go_SQL.so_currentAlias.m_closeTable()

        go_SQL.cmpA_icytrn.m_SetRelation("OFF", "a_icitem", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

      ELSE

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

      IF gl_locts
        go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "loctid + item", "", .t., .f.)
      ELSE
        go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "item", "", .t., .f.)
      ENDIF

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Inventory Adjustments Report"

	  gl_landscp = .t.
	  
      IF gl_locts
        *# DOCCODE REPORT FORM icadjl
        lc_frx = gc_icprgdv + "icadjl"
      ELSE
        *# DOCCODE REPORT FORM icadjt
        lc_frx = gc_icprgdv + "icadjt"
      ENDIF

    CASE lc_rept = "T05"
      *-- Stock Transfers

      *-- Set filter for transfer transactions
      DO CASE
        CASE lc_type = "Issue"
          lc_filt = lc_filt + [trantyp='TI' AND ]
        CASE lc_type = "Receipt"
          lc_filt = lc_filt + [trantyp='TR' AND ]

*\ [Begin] PTR 83055 05/31/06 TIRS Code change to fit in Intercompany Issue and Receipt
        CASE lc_type = "Intercompany Issue"
          lc_filt = lc_filt + [trantyp=' I' AND icicts = .t. AND ]

        CASE lc_type = "Intercompany Receipt"
          lc_filt = lc_filt + [trantyp=' R' AND icicts = .t. AND ]
*\ [End] PTR 83055 05/31/06 TIRS Code change to fit in Intercompany Issue and Receipt

        OTHERWISE

*\ [1 Line] PTR# 84912 12/12/06 TIRD Added open and close parentheses and set all in one contidion
*\ [1 Line] PTR 83055 05/31/06 TIRS Code change to fit in Intercompany Issue and Receipt
          lc_filt = lc_filt + [((trantyp='TI' OR trantyp='TR') OR ;
                    ((trantyp=' I' OR trantyp=' R') AND icicts = .t.)) AND ]

      ENDCASE

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(ld_fedate) + [' AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set store condition
      IF NOT EMPTY(lc_bstore)
        lc_filt = lc_filt + [tstore >= ??TRIM(lc_bstore) AND ]
      ENDIF

      IF NOT EMPTY(lc_estore)
        lc_filt = lc_filt + [tstore <= TRIM(??lc_estore) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set bin condition
      IF NOT EMPTY(lc_bbin)
        lc_filt = lc_filt + [tbin >= ??TRIM(lc_bbin) AND ]
      ENDIF

      IF NOT EMPTY(lc_ebin)
        lc_filt = lc_filt + [tbin <= TRIM(??lc_ebin) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem.item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem.item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)

        go_SQL.cmpA_Ictran.m_SetOrder(0)
        ln_reccnt = go_SQL.so_CurrentAlias.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)

        go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ln_reccnt = ln_reccnt + go_SQL.so_CurrentAlias.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_ictran")

        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
        *-- Added new fields trcost, tftcost
        go_SQL.m_sqlSelect("ttranno, tdate, a_ictran->item, a_icitem->itmdesc, udref, loctid, tstore, tbin, sqty, tqty, " + ;
          "tcost, disc, trantyp, orgtype, umeasur, a_icitem->stkumid, trcost, tftcost FROM " +;
          go_sql.cmpA_ictran.sc_tableNameFull + " a_ictran left join " + ;
          go_sql.cmpA_icitem.sc_tableNameFull + " as a_icitem on a_ictran.item = a_icitem.item WHERE " + ;
          lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(1))
        go_sql.so_CurrentAlias.m_closeTable()

        go_SQL.cmpA_ictran.m_SetRelation("OFF", "a_icitem", .f.)
        go_SQL.cmpA_Ictran.m_SetOrder("ttranno")
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
        *-- Added new fields trcost, tftcost
        go_SQL.m_sqlSelect("ttranno, tdate, a_icytrn->item, a_icitem->itmdesc, udref, loctid, tstore, tbin, sqty, tqty, tcost, " + ;
          "disc, trantyp, orgtype, umeasur, a_icitem->stkumid, trcost, tftcost FROM " + ;
          go_sql.cmpA_icytrn.sc_tableNameFull + " a_icytrn left join " + ;
          go_sql.cmpA_icitem.sc_tableNameFull + " as a_icitem on a_icytrn.item = a_icitem.item WHERE " + ;
          lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(2))
       go_sql.so_CurrentAlias.m_closeTable()

        go_SQL.cmpA_icytrn.m_SetRelation("OFF", "a_icitem", .f.)
        go_SQL.cmpA_Icytrn.m_SetOrder("ttranno")

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)

        go_SQL.cmpA_tmpf2.m_ReplaceBulk("orgtype WITH 'X'", "A", "")
        go_SQL.cmpA_tmpf2.m_CloseTable()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

      ELSE

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

        go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "loctid + item", "", .t., .f.)
      IF LEFT(lc_file,1) <> "H"
        go_SQL.so_CurrentAlias.m_SetRelation("IIF(trantyp = 'TI', STR(VAL(ttranno) +1), STR(VAL(ttranno) -1))", "a_ictran", .f.)
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.so_CurrentAlias.m_SetRelation("IIF(trantyp = 'TI', STR(VAL(ttranno) +1), STR(VAL(ttranno) -1))", "a_icytrn", .t.)
      ENDIF

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Stock Transfers Report"

      *# DOCCODE REPORT FORM icstrl
      lc_frx = gc_icprgdv + "icstrl"

    CASE lc_rept = "T06"
      *-- Inventory Journal

      *-- Set account range limits if blanks entered for all accounts
      lc_baccnt = STRTRAN(lc_baccnt, SPACE(1), "0")
      lc_eaccnt = STRTRAN(lc_eaccnt, SPACE(1), "0")
      lc_eaccnt = IIF(lc_eaccnt = lc_0accnt, lc_9accnt, lc_eaccnt)

      *-- Set account conditions
      IF lc_baccnt <> lc_0accnt
        lc_filt = lc_filt + [glacnt >= ??lc_baccnt AND ]
      ENDIF

      IF lc_eaccnt <> lc_9accnt
        lc_filt = lc_filt + [glacnt <= ??lc_eaccnt + '] + CHR(255) + [' AND ]
      ENDIF

      IF lc_nrange = "Session"

        lc_filt = lc_filt + [BETWEEN(icsess, ??lc_bsess, ??lc_esess) AND ]

        lc_sess = g_retact(6)
        IF NOT EMPTY(lc_sess)
          lc_filt = lc_filt +  [NOT icsess $ ??lc_sess AND ]
        ENDIF

      ELSE

        *-- Set batch number range
        IF NOT EMPTY(lc_bbatch)
          lc_filt = lc_filt + [glbatch >= ??lc_bbatch AND ]
        ENDIF

        IF NOT EMPTY(lc_ebatch)
          lc_filt = lc_filt + [glbatch <= ??lc_ebatch + '] + CHR(255) + [' AND ]
        ENDIF

      ENDIF

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [trandte >= ??ld_fbdate AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [trandte <= ??ld_fedate AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt+[a_ictran->loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt+[a_ictran->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Transaction Detail file
      ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "ttranno")

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICDIST", "trandte")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "ttranno")

        *-- Open current distribution file
        ln_opndist = g_opnfl(gf_icdistf, "a_icdist", .f., .f., "glacnt")

        ln_reccnt = go_SQL.cmpA_icdist.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        *-- Open History transaction file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "ttranno")

        *-- Retrieve records from history file
        ln_opnydst = g_opnfl(gf_icydstf, "a_icydst", .f., .f., "trandte")

        ln_reccnt = ln_reccnt + go_SQL.cmpA_icydst.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_icdist")
        go_SQL.cmpA_icdist.m_SetRelation("tranno", "a_ictran", .f.)

        lc_TempFilt = lc_filt1+lc_filt2+lc_filt3+lc_filt4

        *-- Create the table

        go_SQL.m_SqlSelect("a_icdist.tranno, " + ;
                           "a_icdist.glacnt, " + ;
                           "a_icdist.amount, " + ;
                           "a_icdist.glbatch, " + ;
                           "a_icdist.icsess, " + ;
                           "a_icdist.trandte, " + ;
                           "SPACE(" + STR(LEN(gc_ItemPic      )) + ") as item, "    + ;
                           "SPACE(" + STR(LEN(a_ictran.trantyp)) + ") as trantyp, " + ;
						   "SPACE(20) as trandesc, " + ;
                           "SPACE(" + STR(LEN(a_ictran.udref  )) + ") as udref, "  + ;
                           "SPACE(" + STR(LEN(a_ictran.applid )) + ") as applid,"  + ;
                           "SPACE(" + STR(LEN(a_ictran.docno  )) + ") as docno," + ;
                           "a_icdist.isocurr, " + ;
                           "a_icdist.famount " + ;
                           " FROM " + go_Sql.cmpA_icdist.sc_tablenamefull + " a_icdist " +;
                           "WHERE " + lc_TempFilt, ;
                           "SQL TABLE", ;
                           go_SQL.m_getTempTableName(1))

        go_SQl.so_Currentalias.m_CloseTable()

        *-- Ro-Open temporary file, relate into ictran and fill in lookup fields
        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)
        go_SQL.cmpA_tmpf1.m_SetRelation("tranno", "a_ictran", .f.)

        go_SQL.cmpA_tmpf1.m_Replacebulk("item    WITH IIF(ISNULL(a_ictran.item), '', a_ictran.item), " + ;
                                        "trantyp WITH IIF(ISNULL(a_ictran.trantyp), '', a_ictran.trantyp), " + ;
                                        "trandesc WITH IIF(LEFT(a_ictran.trantyp,1) = 'P', 'Physical Inventory', " + ;
                                        "IIF(LEFT(a_ictran.trantyp,1) = 'C', 'Cost Update', " + ;
                                        "IIF(INLIST(a_ictran.trantyp, ' I', 'RI'), 'Inventory Issue', " + ;
                                        "IIF(INLIST(a_ictran.trantyp, ' R', 'RR'), 'Inventory Receipt', " + ;
                                        "IIF(a_ictran.trantyp = 'EI', 'Manf. Issue', " + ;
                                        "IIF(a_ictran.trantyp = 'ER', 'Manf. Receipt', " + ;
                                        "IIF(a_ictran.trantyp = 'TI','Transfer Issue','Transfer Receipt'))))))), " + ;
                                        "udref   WITH IIF(ISNULL(a_ictran.udref), '', a_ictran.udref), " + ;
                                        "applid  WITH IIF(ISNULL(a_ictran.applid), '', a_ictran.applid), " + ;
                                        "docno   WITH IIF(ISNULL(a_ictran.docno), '', a_ictran.docno)", ;
                                        "A", ;
                                        "", ;
                                        .t.)

        IF NOT EMPTY(lc_applid) AND lc_applid <> "All"
           go_SQL.cmpA_tmpf1.m_DeleteBulk("F", "a_tmpf1->applid <> ??lc_Applid", .t.)
        ENDIF

        *-- Clear Relation
         go_SQL.cmpA_tmpf1.m_SetRelation("tranno", "a_ictran", .f.)

      ENDIF &&LEFT(lc_file,1) <> "H"

      IF LEFT(lc_file,1) <> "C"
        *-- Divide filter into acceptable sizes
        DO g_brkstr WITH STRTRAN(lc_filt, "a_ictran", "a_icytrn"), ;
                         lc_filt1, lc_filt2, lc_filt3, lc_filt4

        *-- Open history distribution file
        go_SQL.m_TableChangeCurrent("a_icydst")

        go_SQL.cmpA_Icydst.m_SetOrder("glacnt")
        go_SQL.cmpA_icydst.m_SetRelation("tranno", "a_icytrn", .f.)

        lc_TempFilt = lc_filt1+lc_filt2+lc_filt3+lc_filt4

        *-- Create the table
        go_SQL.m_SqlSelect("a_icydst.tranno, " + ;
                           "a_icydst.glacnt, " + ;
                           "a_icydst.amount, " + ;
                           "a_icydst.glbatch, " + ;
                           "a_icydst.icsess, " + ;
                           "a_icydst.trandte, " + ;
                           "SPACE(" + STR(LEN(gc_ItemPic      )) + ") as Item,"    + ;
                           "SPACE(" + STR(LEN(a_icytrn.trantyp)) + ") as TranTyp," + ;
						   "SPACE(20) as trandesc, " + ;                           
                           "SPACE(" + STR(LEN(a_icytrn.udref  )) + ") as UdRef,"   + ;
                           "SPACE(" + STR(LEN(a_icytrn.applid )) + ") as applid,"  + ;
                           "SPACE(" + STR(LEN(a_icytrn.docno  )) + ") as docno," + ;
                           "a_icydst.isocurr, " + ;
                           "a_icydst.famount " + ;
                           " FROM " + go_Sql.cmpA_icydst.sc_tablenamefull + ;
                           " a_icydst WHERE " + lc_TempFilt, ;
                           "SQL TABLE", ;
                           go_SQL.m_getTempTableName(2))

        go_SQl.so_Currentalias.m_CloseTable()

        *-- Re-Open temporary file, relate into ictran and fill in lookup fields
        = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
        go_SQL.cmpA_Tmpf2.m_SetRelation("tranno", "a_icytrn", .f.)

        go_SQL.cmpA_tmpf2.m_Replacebulk("item    WITH IIF(ISNULL(a_icytrn.item), '', a_icytrn.item), " + ;
                                        "trantyp WITH IIF(ISNULL(a_icytrn.trantyp), '', a_icytrn.trantyp), " + ;
                                        "trandesc WITH IIF(LEFT(a_icytrn.trantyp,1) = 'P', 'Physical Inventory', " + ;
                                        "IIF(LEFT(a_icytrn.trantyp,1) = 'C', 'Cost Update', " + ;
                                        "IIF(INLIST(a_icytrn.trantyp, ' I', 'RI'), 'Inventory Issue', " + ;
                                        "IIF(INLIST(a_icytrn.trantyp, ' R', 'RR'), 'Inventory Receipt', " + ;
                                        "IIF(a_icytrn.trantyp = 'EI', 'Manf. Issue', " + ;
                                        "IIF(a_icytrn.trantyp = 'ER', 'Manf. Receipt', " + ;
                                        "IIF(a_icytrn.trantyp = 'TI','Transfer Issue','Transfer Receipt'))))))), " + ;
                                        "udref   WITH IIF(ISNULL(a_icytrn.udref), '', a_icytrn.udref), " + ;
                                        "applid  WITH IIF(ISNULL(a_icytrn.applid), '', a_icytrn.applid), " + ;
                                        "docno   WITH IIF(ISNULL(a_icytrn.docno), '', a_icytrn.docno)", ;
                                        "A", ;
                                        "", ;
                                        .t.)

        IF NOT EMPTY(lc_applid) AND lc_applid <> "All"
           go_SQL.cmpA_tmpf2.m_DeleteBulk("F", "a_tmpf2->applid <> ??lc_Applid", .t.)
        ENDIF

        *-- Clear Relation
         go_SQL.cmpa_tmpf2.m_SetRelation("tranno", "a_icytrn", .f.)

      ENDIF &&LEFT(lc_file,1) <> "C"

      IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_sql.cmpA_tmpf1.m_SqlAppendFrom(go_SQL.m_getTempTableName(2), "")

          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
        ENDIF

      ELSE
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

      *-- Index temporary file
      DO CASE
        CASE LEFT(lc_order,1) = "A"
          go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "glacnt + isocurr", "", .t., .f.)
        CASE UPPER(LEFT(lc_order,2)) = "SE"
          go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "icsess + glacnt + isocurr", "", .t., .f.)

        CASE LEFT(lc_order,1) = "D"
          go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "DTOS(trandte) + glacnt + isocurr", "", .t., .f.)
        CASE LEFT(lc_order,1) = "S"
          go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "applid + glacnt + isocurr", "", .t., .f.)
        CASE LEFT(lc_order,1) = "B"
          go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "glbatch + glacnt + isocurr", "", .t., .f.)
       ENDCASE

      *-- If summary report total on account number
      IF lc_detail = "S"

        lc_flds =  "tranno, glacnt, SUM(amount) as AMOUNT, glbatch, icsess, trandte, " + ;
                   "item, trantyp, udref, applid, docno, isocurr, SUM(famount) as FAMOUNT"

        DO CASE
          CASE LEFT(lc_order,1) = "A"
            lc_groupby = "glacnt, isocurr"

          CASE UPPER(LEFT(lc_order,2)) = "SE"
            lc_groupby = "icsess, glacnt, isocurr"

          CASE LEFT(lc_order,1) = "D"
            lc_groupby = "trandte, glacnt, isocurr"

          CASE LEFT(lc_order,1) = "S"
            lc_groupby = "applid, glacnt, isocurr"

          CASE LEFT(lc_order,1) = "B"
            lc_groupby = "glbatch, glacnt, isocurr"

        ENDCASE

        go_SQL.m_SqlSelect(lc_flds + ;
                           " FROM " + go_Sql.so_CurrentAlias.sc_tablenamefull + ;
                           " GROUP BY " + lc_groupby + " ORDER BY " + lc_groupby, ;
                           "SQL TABLE", ;
                           go_SQL.m_getTempTableName(3))

        go_SQl.so_Currentalias.m_CloseTable()

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f.)

        *-- Index temporary file
        DO CASE
          CASE (UPPER(LEFT(lc_order,2)) = "SE") ;
               AND lc_detail  = "S"
            go_SQL.so_CurrentAlias.m_createIndex("tag3", "icsess", "", .t., .f.)
          CASE LEFT(lc_order,1) = "D" AND lc_detail  = "S"
            go_SQL.so_CurrentAlias.m_createIndex("tag3", "trandte", "", .t., .f.)
          CASE LEFT(lc_order,1) = "S" AND lc_detail = "S"
            go_SQL.so_CurrentAlias.m_createIndex("tag3", "applid", "", .t., .f.)
          CASE LEFT(lc_order,1) = "B" AND lc_detail  = "S"
            go_SQL.so_CurrentAlias.m_createIndex("tag3", "glbatch", "", .t., .f.)
        ENDCASE

      ENDIF

      go_SQL.so_CurrentAlias.m_SetRelation("TRIM(glacnt)", "a_glacnt", .f.)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Inventory Journal"

      IF lc_detail = "D"

        DO CASE
          CASE LEFT(lc_order,1) = "A"
            *# DOCCODE REPORT FORM icjrla
            lc_frx = gc_icprgdv + "icjrla"
          CASE UPPER(LEFT(lc_order,2)) = "SE"
            *# DOCCODE REPORT FORM icjrlb
            lc_frx = gc_icprgdv + "icjrlb"
          CASE LEFT(lc_order,1) = "D"
            *# DOCCODE REPORT FORM icjrld
            lc_frx = gc_icprgdv + "icjrld"
          CASE LEFT(lc_order,1) = "S"
            *# DOCCODE REPORT FORM icjrls
            lc_frx = gc_icprgdv + "icjrls"
          CASE LEFT(lc_order,1) = "B"
            *# DOCCODE REPORT FORM icjrlh
            lc_frx = gc_icprgdv + "icjrlh"
        ENDCASE

      ELSE

        DO CASE
          CASE LEFT(lc_order,1) = "A"
            *# DOCCODE REPORT FORM icjrsa
            lc_frx = gc_icprgdv + "icjrsa"
          CASE UPPER(LEFT(lc_order,2)) = "SE"
            *# DOCCODE REPORT FORM icjrsb
            lc_frx = gc_icprgdv + "icjrsb"
          CASE LEFT(lc_order,1) = "D"
            *# DOCCODE REPORT FORM icjrsd
            lc_frx = gc_icprgdv + "icjrsd"
          CASE LEFT(lc_order,1) = "S"
            *# DOCCODE REPORT FORM icjrss
            lc_frx = gc_icprgdv + "icjrss"
          CASE LEFT(lc_order,1) = "B"
            *# DOCCODE REPORT FORM icjrsh
            lc_frx = gc_icprgdv + "icjrsh"
        ENDCASE

      ENDIF

    CASE lc_rept = "T07"
      *-- Sales History

      *-- Set program condition
      IF lc_applid= "All"
        lc_filt = lc_filt + [(applid='AR' OR applid='SO') AND ]
      ELSE
        lc_filt = lc_filt + [applid= '] + lc_applid + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

*\ [Begin] PTR# 78641 06/16/05 TISJ Set date condition
      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(ld_fedate) + [' AND ]
      ENDIF
*\ [End] PTR# 78641 06/16/05 TISJ Set date condition

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)

        go_SQL.cmpA_Ictran.m_SetOrder(0)
        ln_reccnt = go_SQL.cmpA_Ictran.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        *-- Open History transaction file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)

        go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ln_reccnt = ln_reccnt + go_SQL.cmpA_Icytrn.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_ictran")

        go_SQL.cmpA_Ictran.m_SetRelation("item", "a_icitem", .f.)

        *-- Copy to temporary file
        go_SQL.cmpA_Ictran.m_CopyTo(go_SQL.m_getTempTableName(1), "FOR " + lc_filt1+lc_filt2+lc_filt3+lc_filt4)

      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.cmpA_Icytrn.m_SetRelation("item", "a_icitem", .f.)

        *-- Copy to temporary file
        go_SQL.cmpA_Icytrn.m_CopyTo(go_SQL.m_getTempTableName(2), "FOR " + lc_filt1+lc_filt2+lc_filt3+lc_filt4)
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

      ELSE
        = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Sales History"

      *# DOCCODE REPORT FORM icshst
      lc_frx = gc_icprgdv + "icshst"

    CASE lc_rept = "T08"
      *-- Serial/Lot Issue History
      *-- Set transaction type condition
      lc_filt = lc_filt + [(trantyp=' I' OR trantyp='RI' OR trantyp = 'EI') AND ]

      *-- Set originating application condition
      IF lc_applid <> "All"
        lc_filt = lc_filt + [applid = '] + lc_applid + [' AND ]
      ENDIF

      *-- Set transaction date condition
      IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate) >= '] + DTOS(ld_fbdate) + [' AND ]
      ENDIF

      IF NOT EMPTY(ld_fedate)
        lc_filt = lc_filt + [DTOS(tdate) <= '] + DTOS(ld_fedate) + [' AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [loctid >= TRIM(??lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set lot condition
      IF NOT EMPTY(lc_blot)
        lc_filt = lc_filt + [lotno >= TRIM(??lc_blot) AND ]
      ENDIF

      IF NOT EMPTY(lc_elot)
        lc_filt = lc_filt + [lotno <= TRIM(??lc_elot) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set serial number condition
      IF NOT EMPTY(lc_bserial)
        lc_filt = lc_filt + [serial >= TRIM(??lc_bserial) AND ]
      ENDIF

      IF NOT EMPTY(lc_eserial)
        lc_filt = lc_filt + [serial <= TRIM(??lc_eserial) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set customer number condition
      IF NOT EMPTY(lc_bcustno)
        lc_filt = lc_filt + [orgno >= TRIM(??lc_bcustno) AND ]
      ENDIF

      IF NOT EMPTY(lc_ecustno)
        lc_filt = lc_filt + [orgno <= TRIM(??lc_ecustno) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= TRIM(??lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [(a_icitem->useserl $ 'OS' OR ] + ;
                [a_icitem->uselots $ 'OS')]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory Lot file
      ln_opnlotf = g_opnfl(gf_icilotf, "a_icilot", .f., .f., "item1")

      *-- Divide filter into acceptable sizes
      DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

      *-- Setup variable for status display
      ln_reccnt = 0

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
      lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

      IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)

        go_SQL.cmpA_Ictran.m_SetOrder(0)
        ln_reccnt = go_SQL.cmpA_Ictran.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) $ "HB"
        *-- Open History transaction file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)

        go_SQL.cmpA_Icytrn.m_SetOrder(0)
        ln_reccnt = ln_reccnt + go_SQL.cmpA_Icytrn.m_Reccount()
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        go_SQL.m_TableChangeCurrent("a_ictran")

        go_SQL.cmpA_Ictran.m_SetRelation("item", "a_icitem", .f.)

        *-- Copy to temporary file
        go_SQL.cmpA_Ictran.m_CopyTo(go_SQL.m_getTempTableName(1), "FOR " + lc_filt1+lc_filt2+lc_filt3+lc_filt4)
      ENDIF

      IF LEFT(lc_file,1) <> "C"
        go_SQL.m_TableChangeCurrent("a_icytrn")

        go_SQL.cmpA_Icytrn.m_SetRelation("item", "a_icitem", .f.)

        *-- Copy to temporary file
        go_SQL.cmpA_Icytrn.m_CopyTo(go_SQL.m_getTempTableName(2), "FOR " + lc_filt1+lc_filt2+lc_filt3+lc_filt4)
      ENDIF

      IF LEFT(lc_file,1) <> "H"
        = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")

          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
          go_SQL.m_dropTAble(go_SQL.m_getTempTableName(2))
        ENDIF

      ELSE
        = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
      ENDIF

      go_SQL.so_CurrentAlias.m_createIndex("tagitem", "item + applid + DTOS(tdate)", "", .t., .f.)
      go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.so_CurrentAlias.m_SetRelation("item + lotno", "a_icilot", .t.)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Serial/Lot Issue History"

      *# DOCCODE REPORT FORM icslih
      lc_frx = gc_icprgdv + "icslih"

    CASE lc_rept = "T09"
      *-- Cost Variances
      DO l_icrept_t09

    CASE lc_rept = "T10"
      *-- Serial Number History
      DO l_icrept_t10

    CASE lc_rept = "CCW"
      *-- Cycle Count Worksheet

      *-- Open necessary files
      ln_opncyct = g_opnfl(gf_iccyctf, "a_iccyct", .f., .f., "")
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "")
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "")
      ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f., "")

      *-- Allow for empty option grid values
      lc_eitem   = IIF(EMPTY(lc_eitem), ;
                   REPLICATE(SPACE(0), LEN(gc_ItemPic)), lc_eitem)
      lc_abccode = IIF(EMPTY(lc_abccode), SPACE(0), lc_abccode)

      lc_cntcode = IIF(EMPTY(lc_cntcode), SPACE(0), ALLTRIM(lc_cntcode))

      *-- Locate record in sysdata
      ln_icsyst = g_setsys(gc_applid, gc_compid, .f.)

      *-- Get company information from system file
      mchars  = LEFT(a_sysdat->printer, 2)
      mname   = a_sysdat->company
      mcadd1  = LEFT(a_sysdat->address, 35)
      mcadd2  = SUBSTR(a_sysdat->address, 36,  35)
      mcadd3  = SUBSTR(a_sysdat->address, 71,  35)
      mcphone = SUBSTR(a_sysdat->address, 106, 12)


      *-- Set century value of count date
      ld_lpcnt = g_retdt(lc_lpcnt)
 *\ [1 line] PTR# 82394 BAUG 08/04/06 Do not reprint worksheet if it is already printed.
      *-- When you print cycle count, if lock inventory option is not selected then update       
      *-- cntflag field with "C". We need this new flag because when we reprint the worksheet
      *-- we need to filter out the already printed records.
      lc_filt5 = [ a_icitem->stkcode =  'Y' AND ] + ;
                       [ LEFT(a_icitem->item,] + ;
                       ALLTRIM(STR(LEN(TRIM(lc_bitem)),6,0)) + ;
                       [) >= ??TRIM(lc_bitem) AND ] + ;
                       [ LEFT(a_icitem->item,] + ;
                       ALLTRIM(STR(LEN(TRIM(lc_eitem)),6,0)) + ;
                       [) <= ??TRIM(lc_eitem) AND ] + ;
                       [ LEFT(a_icitem->abccode,] + ;
                       ALLTRIM(STR(LEN(lc_abccode),6,0)) + ;
                       [) = ??lc_abccode  AND ] + ;
                       [ LEFT(a_icitem->cntcode,] + ;
                       ALLTRIM(STR(LEN(lc_cntcode),6,0))+ ;
                       [) = ??lc_cntcode AND ] + ;
                       [ LEFT(a_icitem->plinid,] + ;
                       ALLTRIM(STR(LEN(RTRIM(lc_plinid)),6,0)) + ;
                       [) = ??RTRIM(lc_plinid) AND ] + ;
                       [ LEFT(a_icitem->itmclss,] + ;
                       ALLTRIM(STR(LEN(RTRIM(lc_class)),6,0)) + ;
                       [) = ??RTRIM(lc_class) AND ] + ;
                       [ LEFT(a_iciloc->loctid + a_iciloc->item,] + ;
                       ALLTRIM(STR(LEN(RTRIM(lc_loctid)),6,0)) + [) = ] + ;
                       [??RTRIM(lc_loctid) AND ] + ;
                       [ NOT a_iciloc->cntflag $ 'CL' AND ] + ;
                       [ a_iciloc->itemstat = 'A' ]


      IF lc_zero = "Yes"
        *-- Include zero price items (exclude lotted items not in iciqty)
        lc_filt5 = lc_filt5 + [ AND ((a_icitem->uselots <> 'N' AND ] + ;
                   [(NOT EMPTY(a_iciqty->item) AND a_iciqty->item <> '.NULL.')) ] + ;
                   [OR (a_icitem->uselots = 'N'))]
      ELSE
        *-- Exclude zero price items
        lc_filt5 = lc_filt5 + [ AND a_iciqty->qonhand > 0.00 ]
      ENDIF

      *-- Get data
      go_SQL.m_SQLSelect("a_iciloc->loctid, " + ;
                         "a_icitem->item, " + ;
                         "a_iciqty->qstore, " + ;
                         "IIF(EMPTY(a_iciqty->qbin) = .t., '" + SPACE(LEN(a_iciqty->qbin)) + "', a_iciqty->qbin) AS qbin, " + ;
                         "a_icitem->itmdesc, " + ;
                         "a_iciqty->lotno, " + ;
                         "a_icitem->stkumid, " + ;
                         "a_iciloc->lpcnt, " + ;
                         "a_icitem->cntcode, " + ;
                         "a_iciqty->qserial, " + ;
                         "a_iciqty->qonhand, " + ;
                         "a_icitem->barcode " + ;
                         " FROM " + go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc " + ;
                         " LEFT OUTER JOIN " + go_SQL.cmpA_iciqty.sc_tableNameFull + " a_iciqty " + ;
                         " ON a_iciloc->loctid + a_iciloc->item = a_iciqty->loctid + a_iciqty->item " + ;
                         " INNER JOIN " + go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem " + ;
                         " ON a_iciloc->item = a_icitem->item " + ;
                         " WHERE " + lc_filt5 + ;
                         " ORDER BY 1,2,3,4", ;
                         "SQL TABLE", go_SQL.m_getTempTableName(1) )

      go_SQL.so_currentAlias.m_closeTable()

      go_SQL.m_SQLSelect("a_iciloc->loctid, " + ;
                         "a_icitem->item, " + ;
                         "a_iciqty->qstore, " + ;
                         "IIF(EMPTY(a_iciqty->qbin) = .t., '" + SPACE(LEN(a_iciqty->qbin)) + "', a_iciqty->qbin) AS qbin, " + ;
                         "a_icitem->itmdesc, " + ;
                         "a_iciqty->lotno, " + ;
                         "a_icitem->stkumid, " + ;
                         "a_iciloc->lpcnt, " + ;
                         "a_icitem->cntcode, " + ;
                         "a_iciqty->qserial, " + ;
                         "a_iciqty->qonhand, " + ;
                         "a_icitem->barcode " + ;                         
                         "FROM " + go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc " + ;
                         "LEFT OUTER JOIN " + go_SQL.cmpA_iciqty.sc_tableNameFull + " a_iciqty " + ;
                         "ON a_iciloc->loctid + a_iciloc->item = a_iciqty->loctid + a_iciqty->item " + ;
                         "INNER JOIN " + go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem " + ;
                         "ON a_iciloc->item = a_icitem->item " + ;
                         "WHERE a_icitem->cntcode = '" + SPACE(LEN(a_icitem->cntcode)) + "' AND " + ;
                         lc_filt5 + ;
                         " ORDER BY 1,2,3,4", ;
                         "SQL TABLE", go_SQL.m_getTempTableName(2) )

      go_SQL.so_currentAlias.m_closeTable()

      *-- Open temporary file Tmpf1
      = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f., "", .f.)

      *-- Replace null value into blank
      go_SQL.cmpA_tmpf1.m_ReplaceBulk("qbin    WITH IIF(ISNULL(qbin), ' ', qbin)," + ;
                                      "qstore  WITH IIF(ISNULL(qstore), ' ', qstore)," + ;
                                      "lotno   WITH IIF(ISNULL(lotno), ' ', lotno)," + ;
                                      "qserial WITH IIF(ISNULL(qserial), ' ', qserial)," + ;
                                      "qonhand WITH IIF(ISNULL(qonhand), 0, qonhand)", "A", "")

      *-- Open temporary file Tmpf2
      = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f., "", .f.)

      *-- Replace null value into blank
      go_SQL.cmpA_tmpf2.m_ReplaceBulk("qbin    WITH IIF(ISNULL(qbin), ' ', qbin)," + ;
                                      "qstore  WITH IIF(ISNULL(qstore), ' ', qstore)," + ;
                                      "lotno   WITH IIF(ISNULL(lotno), ' ', lotno)," + ;
                                      "qserial WITH IIF(ISNULL(qserial), ' ', qserial)," + ;
                                      "qonhand WITH IIF(ISNULL(qonhand), 0, qonhand)", "A", "")

      go_SQL.m_SQLSelect(" * " + ;
                         "FROM " + go_SQL.cmpA_Tmpf2.sc_tableNameFull + " a_Tmpf2 " + ;
                         "LEFT OUTER JOIN " + go_SQL.cmpA_iccyct.sc_tableNameFull + " a_iccyct " + ;
                         "ON a_Tmpf2->cntcode = a_iccyct->cycode " + ;
                         "UNION SELECT " + ;
                         "* " + ;
                         "FROM " + go_SQL.cmpA_Tmpf1.sc_tableNameFull + " a_Tmpf1 " + ;
                         "INNER JOIN " + go_SQL.cmpA_iccyct.sc_tableNameFull + " a_iccyct " + ;
                         "ON a_iccyct->cycode = a_Tmpf1->cntcode " + ;
                         "WHERE a_Tmpf1->lpcnt <= (CTOD(DTOC(??ld_lpcnt)) - " + ;
                         "IIF(EMPTY(CTOD(DTOC(??ld_lpcnt))) OR EMPTY(a_iccyct->cyfreq), " + ;
                         "0, a_iccyct->cyfreq) " + IIF(go_SQL.sc_SQLType="SD","%DAY%","") + ") ", ;
                         "CURSOR", "ac_tmpf2")

      *-- Close the temporary file Tmpf1
      IF go_SQL.m_IsUsed("a_tmpf1")
        go_SQL.cmpA_Tmpf1.m_CloseTable()
      ENDIF

      *-- Erase the temporary file Tmpf1
      go_SQL.m_dropTable(go_SQL.m_getTempTableName(1))

      *-- Close the temporary file Tmpf2
      IF go_SQL.m_IsUsed("a_tmpf2")
        go_SQL.cmpA_Tmpf2.m_CloseTable()
      ENDIF

      *-- Erase the temporary file Tmpf2
      go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))

      IF EMPTY(lc_cntcode)
        lc_cntcode = SPACE(LEN(a_icitem->CNTCODE))
      ENDIF

      IF EMPTY(lc_abccode)
        lc_abccode  = SPACE(LEN(a_icitem->ABCCODE))
      ENDIF

      IF EMPTY(lc_eitem)
        lc_eitem    = SPACE(LEN(gc_ItemPic))
      ENDIF

      *-- Build ac_tmpf1 based on lc_byseria
      IF lc_byseria = "No"
       *-- Close The Temp Table which is opens when the print/preview option
       *-- is selectd first

       IF USED("ac_tmpf1")
          go_SQL.m_TableChangeCurrent("ac_tmpf1")
          go_SQL.m_CloseTable("ac_tmpf1")
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(1, "F"),,"F")
       ENDIF

        go_SQL.m_SQLSelect("loctid, " + ;
                           "item, " + ;
                           "barcode, " + ;
                           "qstore, " + ;
                           "qbin, " + ;
                           "itmdesc, " + ;
                           "lotno, " + ;
                           "stkumid, " + ;
                           "lpcnt, " + ;
                           "SUM(qonhand) AS qonhand " + ;
                           " FROM ac_tmpf2 " + ;
                           " GROUP BY loctid, item, qstore, qbin", ;
                           "TABLE", go_SQL.m_getTempTableName(1,"F"), "F")

        go_SQL.so_CurrentAlias.m_CloseTable()
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1,"F"), "ac_tmpf1", ;
                             Cl_Exclusive, .f., "", .f.,"F")

      ELSE
        go_SQL.m_SQLSelect("* " + ;
                           " FROM ac_tmpf2", ;
                           "TABLE", go_SQL.m_getTempTableName(1,"F"), "F")

        go_SQL.so_CurrentAlias.m_CloseTable()

        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1,"F"), "ac_tmpf1", ;
                             Cl_Exclusive, .f., "", .f.,"F")
        go_SQL.m_TableChangeCurrent("ac_tmpf2")
        go_SQL.cmpAc_tmpf2.m_CloseTable()
      ENDIF


      *-- Place pointer at the top of cursor
      go_SQL.m_TableChangeCurrent("ac_tmpf1")
      go_SQL.cmpAc_tmpf1.m_MoveRecord(Cn_TopRec)

      *-- Set index orders for relations
      go_SQL.cmpA_Iciqty.m_SetOrder("item1")
      go_SQL.cmpA_Iciloc.m_SetOrder("item1")
      go_SQL.cmpA_Icitem.m_SetOrder("item")

      *-- If no matching records found
      IF go_SQL.cmpAc_tmpf1.m_IsEof()
        ll_cont = .f.
        *-- Frx name is assigned to support in printing No Data Found
        lc_frx = gc_icprgdv + "icccin"
      ELSE
        *-- Found matching records

        *-- Display processing message
        DO g_dspst WITH "Indexing File on " + PROPER(gc_loct) + "...", .t., ;
                        gn_msgline, SPACE(0), SPACE(0), SPACE(0)

      ENDIF && EOF()

      IF ll_cont
        *-- Set report title
        lc_title = "Cycle Count Worksheets"

        *-- Initialize page break indicator
        ll_break = gl_locts AND ;
                   (g_getdlg("Page break per " + PROPER(gc_loct) + "? ", ;
                   0, 2, "Yes", "No", "","") = 1)

        *-- Set report form name variable
        *-- (Note that the FRXs have embedded calls to l_lckitm())
        IF ll_break
          *-- Set report form name for page break
          *# DOCCODE REPORT FORM icccbr
          lc_frx = gc_icprgdv + "icccbr"
        ELSE
          *-- No page break
          *# DOCCODE REPORT FORM icccin
          lc_frx = gc_icprgdv + "icccin"
        ENDIF
*\ [3 lines] PTR# 82163 BAUG 06/27/06 Barcode printing
        *-- For worksheet with barcode print a different report.
        IF lo_Globals.gl_EnableBarcode AND lc_barcode = "Yes"
          lc_frx = lc_frx + "2"
        ENDIF

        *-- Make sure report starts at top of cursor
        go_SQL.m_TableChangeCurrent("ac_tmpf1")
        go_SQL.cmpAc_tmpf1.m_MoveRecord(Cn_TopRec)
      ENDIF && ll_cont

  ENDCASE

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_icrept
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_LCKITM
*------------------------------------------------------------------------------
*- Description: Places semaphore lock on item @ location records
*------------------------------------------------------------------------------
*- Synopsis...: Updates a_iciloc->cntflag to indicate Cycle Count underway
*-              for this item/location pair.  This semaphore remains in
*-              place until Cycle Count reconciliation is complete.  While
*-              in place, this semaphore prevents this item from being
*-              included in any transactions.
*------------------------------------------------------------------------------
*- Called By..: ICCCIN.FRX, ICCCBR.FRX
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.: a_iciloc
*------------------------------------------------------------------------------
FUNCTION l_lckitm

  PRIVATE lc_retvl, ;
          ll_rlock, ;
          lc_alias

  lc_alias = ALIAS()

  IF NOT 'A_ICILOC' $ UPPER(lc_alias)
    go_SQL.m_TableChangeCurrent("a_iciloc")
  ENDIF

  lc_retvl = SPACE(0)

  *-- Only place semaphore if printing (not if displaying)
  IF ll_prnt
    ll_rlock = go_SQL.cmpA_Iciloc.m_LockRow(-1, .f.)

    go_SQL.so_CurrentAlias.m_Replace("cntflag", 'L')
    go_SQL.cmpA_Iciloc.m_Unlock()
  ENDIF

  IF NOT 'A_ICILOC' $ UPPER(lc_alias)
    go_SQL.m_TableChangeCurrent(lc_alias)
  ENDIF

RETURN lc_retvl
*------------------------------------------------------------------------------
*- End Function...: l_lckitm()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function ..: L_ALTDES
*------------------------------------------------------------------------------
*- Description: Gets Description for Alternate Item
*------------------------------------------------------------------------------
*- Synopsis...: Retrieves item description for alternate item.
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: lc_field, value to search for
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: lc_desc, alternate item description
*------------------------------------------------------------------------------
FUNCTION l_altdes

PARAMETERS lc_field

  PRIVATE lc_desc, ;
          ln_recno

*  ln_recno = go_SQL.cmpa_tmpf1.m_GetRecno()
*  go_SQL.m_TableChangeCurrent("a_icitem")

  ln_recno = go_SQL.cmpa_tmpf1.m_GetRecno()

  IF NOT EMPTY(lc_field) AND go_SQL.cmpa_icitem.m_Seek(lc_field, "")
    lc_desc = a_icitem.itmdesc
  ELSE
    lc_desc = "None"
  ENDIF

*  go_SQL.m_TableChangeCurrent("a_tmpf1")
*  go_SQL.cmpa_tmpf1.m_MoveToRecno(ln_recno)

   *--Above call to m_Seek() has moved the pointer of a_icitem to what it seeked for.
   *--Synchronize the relation between a_tmpf1 and a_icitem so that
   *--the a_icitem will point to the proper record
   IF go_SQL.sc_SQLTypeMain <> "F"
     go_SQL.cmpa_tmpf1.m_Syncrelation()
   ELSE
     go_SQL.cmpa_tmpf1.m_MoveToRecno(ln_recno)
   ENDIF

RETURN lc_desc
*------------------------------------------------------------------------------
*- End Function...: l_altdes()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function ..: L_ONHAND
*------------------------------------------------------------------------------
*- Description: Calculate onhand qty for item at all locations
*------------------------------------------------------------------------------
*- Synopsis...: Calculate onhand qty.
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: ln_onhand, total qty for item at all locations
*------------------------------------------------------------------------------
FUNCTION l_onhand

  PRIVATE ln_recno, ;
          lc_item, ;
          ln_onhand

  go_SQL.m_TableChangeCurrent("a_iciloc")
  ln_recno = go_SQL.cmpA_iciloc.m_GetRecno()
  lc_item  = item

  go_SQL.cmpA_iciloc.m_sum("lonhand", "ln_onhand", "item = '" + lc_item + "'")
  go_SQL.cmpA_iciloc.m_MoveToRecno(ln_recno)

  go_SQL.m_TableChangeCurrent("a_tmpf1")
RETURN ln_onhand
*------------------------------------------------------------------------------
*- End Function...: l_onhand()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function ..: L_TRNOVR
*------------------------------------------------------------------------------
*- Description: Calculate sales turnover or usage quantity for item
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: ln_trnovr, (If lc_type = "Turnover") sum of last 12 sales
*-                         periods / current onhand
*-
*-                         (If lc_type = "Usage") sum of qty used for
*-                         specified periods up to 36
*------------------------------------------------------------------------------
FUNCTION l_trnovr

  PRIVATE ln_count

  ln_trnovr = 0

  IF lc_type = "Turnover"

*\ [Begin] PTR 82954 05/30/06 SGOU History file changes
    IF a_iciloc->lonhand = 0
      ln_trnovr = 0
    ELSE
      ln_trnovr = (sales12) / ;
                  a_iciloc->lonhand
    ENDIF

  ELSE
   ln_trnovr = usageqty
  ENDIF
*\ [End] PTR 82954 05/30/06 SGOU History file changes

RETURN ln_trnovr
*------------------------------------------------------------------------------
*- End Function...: l_trnovr()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_SETFLT
*------------------------------------------------------------------------------
*- Description: Checks string length against macro maximum & sets filter
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_setflt

  *-- Check string length against macro limit & set filter
  DO CASE
    CASE LEN(lc_filt) > 510
      lc_filt1 = LEFT(lc_filt,255)
      lc_filt2 = SUBSTR(lc_filt,256,255)
      lc_filt3 = SUBSTR(lc_filt,511,LEN(lc_filt))
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt1 + lc_filt2 + lc_filt3)

    CASE LEN(lc_filt) > 255
      lc_filt1 = LEFT(lc_filt,255)
      lc_filt2 = SUBSTR(lc_filt,256,LEN(lc_filt))
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt1 + lc_filt2)

    OTHERWISE
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filt)
  ENDCASE

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_setflt
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_RETFLT
*------------------------------------------------------------------------------
*- Description: Checks string length against macro maximum & sets filter
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: lc_string, string containing the full length filter
*-              la_array,  three element array with null values to use for
*-                         segmented filter string.
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: la_filt, filter strings
*------------------------------------------------------------------------------
*- Example:
*-   = l_retflt(lc_filt, la_filt)
*------------------------------------------------------------------------------
PROCEDURE l_retflt

PARAMETERS lc_string, ;
           la_array

  EXTERNAL ARRAY la_array

  *-- Check string length against macro limit & set filter
  DO CASE
    CASE LEN(lc_string) > 510
      la_array[1] = LEFT(lc_string,255)
      la_array[2] = SUBSTR(lc_string,256,255)
      la_array[3] = SUBSTR(lc_string,512,LEN(lc_string))

    CASE LEN(lc_string) > 255
      la_array[1] = LEFT(lc_string,255)
      la_array[2] = SUBSTR(lc_string,256,LEN(lc_string))

    OTHERWISE
      la_array[1] = lc_string
  ENDCASE

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_retflt
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_CLRTMP
*------------------------------------------------------------------------------
*- Description: Erase temporary files
*------------------------------------------------------------------------------
*- Synopsis...: Checks for existence of temporary data and index
*-              files and erases them.
*------------------------------------------------------------------------------
PROCEDURE l_clrtmp

  IF lc_rept = "F10~F11" AND go_SQL.m_IsUsed("ac_price")
    *-- Remove cursor from memory
    go_SQL.cmpAc_Price.m_CloseTable()
  ENDIF

  *-- Erase temporary files
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(1, "F"),, "F")
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(2, "F"),, "F")
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(3, "F"),, "F")
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(1))
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(3))

*\ [Deleted 2 Lines] PTR# 80228 09/22/05 TISJ Temporary index file no longer used
*!*	  *-- Erase temporary index files
*!*	  go_SQL.m_DropIndex(,,,"F",gc_idrvtmp + gc_tmpf1 + gc_extndx, .t., .t.)

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_clrtmp
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_TRNSFR
*------------------------------------------------------------------------------
*- Description: Builds string with To/From store & bin information
*------------------------------------------------------------------------------
*- Synopsis...: Sets up filter string.
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: lc_trnsfr
*------------------------------------------------------------------------------
FUNCTION l_trnsfr

  PRIVATE lc_trnsfr, ;
          lc_alias

  lc_trnsfr = SPACE(0)

  lc_alias = IIF(orgtype <> "X", "a_ictran->", "a_icytrn->")

  *-- Build From/To information string
  IF trantyp = "TI"
    lc_trnsfr = "From " + TRIM(PROPER(gc_store)) + ": "  + ;
                IIF(NOT EMPTY(tstore), tstore, "None") + ;
                SPACE(2) + TRIM(PROPER(gc_bin))   + ": " + ;
                IIF(NOT EMPTY(tbin), tbin, "None") + ";"
    lc_trnsfr = lc_trnsfr + "  To " + TRIM(PROPER(gc_store)) + ": "  + ;
                IIF(NOT EMPTY(&lc_alias.tstore), &lc_alias.tstore, "None") + ;
                SPACE(2) + TRIM(PROPER(gc_bin))   + ": " + ;
                IIF(NOT EMPTY(&lc_alias.tbin), &lc_alias.tbin, "None")
  ELSE
    lc_trnsfr = "To " + TRIM(PROPER(gc_store)) + ":   "   + ;
                IIF(NOT EMPTY(tstore), tstore, "None") + ;
                SPACE(2) + TRIM(PROPER(gc_bin))   + ": " + ;
                IIF(NOT EMPTY(tbin), tbin, "None") + ";"
    lc_trnsfr = lc_trnsfr + "From " + TRIM(PROPER(gc_store)) + ": " + ;
                IIF(NOT EMPTY(&lc_alias.tstore), &lc_alias.tstore, "None") + ;
                SPACE(2) + TRIM(PROPER(gc_bin)) + ": "+ ;
                IIF(NOT EMPTY(&lc_alias.tbin), &lc_alias.tbin, "None")
  ENDIF

RETURN lc_trnsfr
*------------------------------------------------------------------------------
*- End Function...: l_trnsfr()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_VCUST
*------------------------------------------------------------------------------
*- Description: Select customer
*------------------------------------------------------------------------------
*- Synopsis...: Enter customer number or select from list , lc_rept = "E"
*------------------------------------------------------------------------------
*- Calls......: G_TRYKEY
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: pc_var - name of variable to validate
*-
*- Files Open.: None
*-
*- Assumption.: Assumes ARCUST is open
*------------------------------------------------------------------------------
*- Returns:  .t.
*------------------------------------------------------------------------------
FUNCTION l_vcust

PARAMETERS pc_var

  PRIVATE lc_cust, ;
          ln_trykey, ;
          lc_brwlst, ;
          ln_opncst

  *-- Initialize locals
  lc_cust   = SPACE(0)
  ln_trykey = 0
  lc_brwlst = SPACE(0)
  ln_opncst = 0

  *-- Determine value to validate
  lc_cust   = &pc_var.
  lc_brwlst = [custno  :H = "Customer",] + ;
              [company :H = "Company Name"]

  *-- Attempt to open ARCUST file
  ln_opncst = g_opnfl(gf_arcustf, "a_arcust", .f., .f.)

  *-- If Unable to open arcust, blank out field
  IF ln_opncst = 0
    lc_cust = SPACE(LEN(gc_CVNoPic))
  ENDIF

  *-- Empty value for all customers OK
  IF NOT EMPTY(lc_cust)
    *-- Attempt to validate the customer entered
    WITH g_NewObj("SycTryKey", "SYBROWSE")
      .m_Reset()
      .sc_DataViewID        = "PL_CUST"
      .sc_Key               = lc_cust
      .sl_List              = .t.
      .sl_Add               = .f.
      .sl_ReEnter           = .t.
      .sl_Blank             = .f.
      .sl_Force             = .f.
      .sl_KeyIsName         = .f.
      .sl_QuestionMarkOK    = .f.
      .sl_Quiet             = .f.
      .sc_Alias             = "a_arcust"
      .sc_Order             = "custno"
      .sc_KeyDescription    = "Customer"
      .sc_Filter            = ""
      .sc_FilterDescription = ""
      .sc_ErrMsg            = ""
      .sc_ValueToReturn     = "custno"
      ln_trykey             = .m_Run()
      lc_Cust               = .rx_ReturnValue
    ENDWITH

  ELSE
    ln_trykey = 1
  ENDIF

  *-- Case trykey result
  DO CASE
    CASE ln_trykey > 0
      STORE lc_cust TO (pc_var)
      SHOW GET &pc_var.

    OTHERWISE
      STORE SPACE(10) TO (pc_var)
      SHOW GET &pc_var.
      _CUROBJ = _CUROBJ
  ENDCASE

  *-- If arcust opened here, close it
  IF ln_opncst = 2
    go_SQL.cmpA_Arcust.m_CloseTable()
  ENDIF

RETURN .t.
*------------------------------------------------------------------------------
*- End Function...: l_vcust()
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: l_selact
*------------------------------------------------------------------------------
*- Synopsis...: Validate accounts from option grid
*------------------------------------------------------------------------------
*- Parameters.: rc_account, account to validate - passed by reference
*-              pl_blankok, if .t., allow blank value
*------------------------------------------------------------------------------
*- Returns:
*- Value......: .t. if valid account
*------------------------------------------------------------------------------
FUNCTION l_selact

PARAMETERS rc_account, ;
           pl_blankok

  PRIVATE ll_return, ;
          ln_recno

  *-- Initialize privates
  ll_return = .f.

  IF pl_blankok AND ;
     rc_account = TRANSFORM(SPACE(LEN(gc_acctpic)), gc_acctpic)

    ll_return = .t.
  ELSE

    *-- look for the entered checking acct
    *-- If the user selected one, setup to get values below
    LOCAL ln_trykey

    ln_trykey = 0
    WITH g_NewObj("SycTryKey", "SYBROWSE")

      .m_Reset()
      .sc_DataViewID        = "PL_GLACNT_ACCVLD"

      .sc_Key               = rc_account

      .sl_List              = .t.
      .sl_Add               = .f.
      .sl_ReEnter           = .t.
      .sl_Blank             = .f.
      .sl_Force             = .f.
      .sl_KeyIsName         = .f.
      .sl_QuestionMarkOK    = .f.
      .sl_Quiet             = .f.

      .sc_Alias             = "a_glacnt"
      .sc_Order             = "glacnt"
      .sc_KeyDescription    = "Account"

      .sc_Filter            = ""
      .sc_FilterDescription = ""
      .sc_ErrMsg            = ""

      ln_trykey = .m_Run()

    ENDWITH

    IF (ln_trykey > 0)

      IF NOT gl_confrms OR ;
         (g_getdlg("Is account " + ;
         RTRIM(TRANSFORM(a_glacnt->glacnt, gc_acctpic)) + ", " + ;
         ALLTRIM(a_glacnt->gldesc) + gc_oseol + ;
         "the correct account?", 0, 1, "Yes", "No") = 1)

        ll_return = .t.
        rc_account = TRANSFORM(a_glacnt->glacnt, gc_acctpic)
        SHOW GET rc_account
      ENDIF

    ENDIF

    IF NOT ll_return AND LEFT(rc_account, 1) = "?"
      *-- Clear "?" from field
      KEYBOARD "{CTRL+Y}" PLAIN
    ENDIF

  ENDIF && pl_blankok AND ...

RETURN (ll_return)
*------------------------------------------------------------------------------
*- End Function...: l_selact
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_PHYSINV
*------------------------------------------------------------------------------
*- Description: Physical Inventory Sheets
*------------------------------------------------------------------------------
PROCEDURE l_physinv
  *-- Physical Inventory Sheet

  PRIVATE lc_sqlorder, ;
          lc_qtyfilt

  lc_sqlorder = SPACE(0)

  *-- Check for serialized items and prompt user for list type
  IF gl_serial = .t.
    ln_resp = g_getdlg("List serialized item records in detail?", ;
              0, 2, "Detail", "Summary", "Cancel")

    *-- Process response
    DO CASE
      CASE LASTKEY() = gk_esc OR ln_resp = 3
        *-- Escape or Cancel
        ll_cont = .f.
      CASE ln_resp = 2
        *-- Summary
        ll_sumserl = .t.
      CASE ln_resp = 1
        *-- Detail
        ll_sumserl = .f.
    ENDCASE

  ELSE
    *-- Serial numbers not used
    ll_sumserl = .f.
  ENDIF

  IF ll_cont

    *-- Set location condition
    IF NOT EMPTY(lc_bloc)
      lc_filt = lc_filt + [loctid = ??TRIM(lc_bloc) AND ]
    ENDIF

    IF NOT EMPTY(lc_eloc)
      lc_filt = lc_filt + [loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set store condition
    IF NOT EMPTY(lc_bstore)
      lc_filt = lc_filt + [qstore >= ??TRIM(lc_bstore) AND ]
    ENDIF

    IF NOT EMPTY(lc_estore)
      lc_filt = lc_filt + [qstore <= TRIM(??lc_estore) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set bin condition
    IF NOT EMPTY(lc_bbin)
      lc_filt = lc_filt + [qbin >= ??TRIM(lc_bbin) AND ]
    ENDIF

    IF NOT EMPTY(lc_ebin)
      lc_filt = lc_filt + [qbin <= TRIM(??lc_ebin) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set class condition
    IF NOT EMPTY(lc_bclass)
      lc_filt = lc_filt + [itmclss >= ??TRIM(lc_bclass) AND ]
    ENDIF

    IF NOT EMPTY(lc_eclass)
      lc_filt = lc_filt + [itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set commodity code condition
    IF NOT EMPTY(lc_bccode)
      lc_filt = lc_filt + [comcode >= ??TRIM(lc_bccode) AND ]
    ENDIF

    IF NOT EMPTY(lc_eccode)
      lc_filt = lc_filt + [comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set misc code condition
    IF NOT EMPTY(lc_bmcode)
      lc_filt = lc_filt + [code >= ??TRIM(lc_bmcode) AND ]
    ENDIF

    IF NOT EMPTY(lc_emcode)
      lc_filt = lc_filt + [code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set item condition
    IF NOT EMPTY(lc_bitem)
      lc_filt = lc_filt + [item >= ??TRIM(lc_bitem) AND ]
    ENDIF

    IF NOT EMPTY(lc_eitem)
      lc_filt = lc_filt + [item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
    ENDIF
*\ [6 lines] PTR# 83763 BAUG 07/26/06 Include 0 qty item from iciqty table if 'include 0 qty' option is selected.
    *-- Filter out issued quantity records
    IF ll_sumserl = .f.

      IF  lc_zero = "No"
        lc_filt = lc_filt + [(g_emptdt(issued) ] + ;
                  [ OR (NOT g_emptdt(issued) AND ] + ;
                  [qonhand <> 0)) AND ]
      ELSE
         lc_filt = lc_filt + [(g_emptdt(issued) ] + ;
                  [ OR (NOT g_emptdt(issued) AND ] + ;
                  [qonhand >= 0)) AND ]
      ENDIF                       
    ENDIF    
    
    *-- Set other conditions
    lc_filt = lc_filt + [ 1=1 ]

    *-- Set filter to exclude zero quantity items
    IF lc_zero = "No"
      lc_qtyfilt = [a_iciloc->lonhand <> 0 ]
    ELSE
      lc_qtyfilt = [.t. = .t. ]
    ENDIF

    go_SQL.m_TableChangeCurrent("a_sysdat")
    go_SQL.so_CurrentAlias.m_Locate("FOR UPPER(sysid) = '" + gc_applid + gc_compid + "'")
    mchars  = LEFT(a_sysdat->printer, 2)
    mname   = gc_company
    mcadd1  = LEFT(a_sysdat->address, 35)
    mcadd2  = SUBSTR(a_sysdat->address, 36, 35)
    mcadd3  = SUBSTR(a_sysdat->address, 71, 35)
    mcphone = SUBSTR(a_sysdat->address, 106, 12)

    IF EMPTY(mcadd2)
      mcadd2 = mcadd3
      mcadd3 = SPACE(0)
    ENDIF

    *-- Open Inventory Master file
    ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

    *-- Open Quantities at Location file
    ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f., "item1")

    *-- If setup for locations, stores, or bins, create temporary index
    IF gl_locts OR gl_store OR gl_bin

      IF NOT ll_sumserl
        lc_sqlorder = "a_iciqty.loctid, a_iciqty.qstore, a_iciqty.qbin, a_iciqty.item"
      ENDIF

    ELSE

      *-- Single location and no stores or bins
      IF NOT ll_sumserl
        lc_sqlorder = "a_iciqty.item, a_iciqty.loctid"
      ENDIF

    ENDIF

    IF ll_sumserl

      *-- Exclude zero qty, drop ship, non-stock items
      go_SQL.m_SQLSelect("a_iciloc.loctid, a_iciloc.item, a_iciqty.qserial, " + ;
                         "a_iciqty.lotno, a_iciqty.qtranno, a_iciqty.qsoaloc, " + ;
                         "a_iciqty.qwoaloc, a_iciqty.qonhand, a_iciqty.qonhnd1, " + ;
                         "a_iciqty.qtmaloc, a_iciqty.issued, a_iciqty.qstore, " + ;
                         "a_iciqty.qbin, a_iciqty.tmpstr1, a_iciqty.tmpnum1, " + ;
                         "a_iciqty.closctr, a_iciqty.otranno, a_icitem.useserl, " + ;
                         "a_icitem.uselots, a_icitem.itmdesc, a_icitem.stkumid, " + ;
                         "a_icitem.weight, a_icitem.itmclss, a_icitem.comcode " + ;
                         "FROM " + go_SQL.cmpA_iciqty.sc_tableNameFull + ;
                         " a_iciqty RIGHT OUTER JOIN " + go_SQL.cmpA_iciloc.sc_tableNameFull + ;
                         " a_iciloc ON a_iciqty.loctid + a_iciqty.item = a_iciloc.loctid + a_iciloc.item, " + ;
                         go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem " + ;
                         " WHERE a_icitem->item = a_iciloc.item AND " + lc_qtyfilt + ;
                         " AND a_iciloc.loctid <> ??gc_droploc AND a_icitem.stkcode = 'Y'", "TABLE", ;
                         go_SQL.m_getTempTableName(1, "F"))

      go_SQL.so_CurrentAlias.m_CloseTable()

      *-- Open the temporary file created by COPY TO / SQL
      = g_opnfl(go_SQL.m_getTempTableName(1, "F"), "a_tmpf1", .t., .f., "", .f., "F")

      *-- Replace null value into blank
      go_SQL.cmpA_tmpf1.m_ReplaceBulk("qserial  WITH IIF(ISNULL(qserial), ' ', qserial)," + ;
                                      "lotno    WITH IIF(ISNULL(lotno), ' ', lotno)," + ;
                                      "qtranno  WITH IIF(ISNULL(qtranno), ' ', qtranno)," + ;
                                      "qsoaloc  WITH IIF(ISNULL(qsoaloc), 0, qsoaloc)," + ;
                                      "qwoaloc  WITH IIF(ISNULL(qwoaloc), 0, qwoaloc)," + ;
                                      "qonhand  WITH IIF(ISNULL(qonhand), 0, qonhand)," + ;
                                      "qonhnd1  WITH IIF(ISNULL(qonhnd1), 0, qonhnd1)," + ;
                                      "qtmaloc  WITH IIF(ISNULL(qtmaloc), 0, qtmaloc)," + ;
                                      "issued   WITH IIF(ISNULL(issued), {}, issued)," + ;
                                      "qstore   WITH IIF(ISNULL(qstore), ' ', qstore)," + ;
                                      "qbin     WITH IIF(ISNULL(qbin), ' ', qbin)," + ;
                                      "tmpstr1  WITH IIF(ISNULL(tmpstr1), ' ', tmpstr1)," + ;
                                      "tmpnum1  WITH IIF(ISNULL(tmpnum1), 0, tmpnum1)," + ;
                                      "closctr  WITH IIF(ISNULL(closctr), 0, closctr)," + ;
                                      "otranno  WITH IIF(ISNULL(otranno), ' ', otranno)", "A", "")

    ELSE
      *-- Exclude zero qty, drop ship, non-stock items
      go_SQL.m_SQLSelect("a_iciloc.loctid, a_iciloc.item, a_iciqty.qstore, " + ;
                         "a_iciqty.qbin, a_iciqty.qserial, a_iciqty.lotno, " + ;
                         "a_iciqty.issued, a_iciqty.qonhand,a_icitem.useserl, " + ;
                         "a_icitem.uselots, a_icitem.itmdesc, a_icitem.stkumid, " + ;
                         "a_icitem.weight, a_icitem.itmclss, a_icitem.comcode FROM " + ;
                         go_SQL.cmpA_iciqty.sc_tableNameFull + " a_iciqty RIGHT OUTER JOIN " + ;
                         go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc " + ;
                         "ON a_iciqty.loctid + a_iciqty.item = a_iciloc.loctid + a_iciloc.item, " + ;
                         go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem " + ;
                         " WHERE a_icitem->item = a_iciloc.item AND " + lc_qtyfilt + ;
                         " AND a_iciloc.loctid <> ??gc_droploc AND a_icitem.stkcode = 'Y'" + ;
                         " ORDER BY " + lc_sqlorder, ;
                         "TABLE", go_SQL.m_getTempTableName(1, "F"))

      go_SQL.so_CurrentAlias.m_CloseTable()

      *-- Open the temporary file created by COPY TO / SQL
      = g_opnfl(go_SQL.m_getTempTableName(1, "F"), "a_tmpf1", .t., .f., "", .f., "F")

      *-- Replace null value into blank
      go_SQL.cmpA_tmpf1.m_ReplaceBulk("qstore   WITH IIF(ISNULL(qstore), ' ', qstore)," + ;
                                      "qbin     WITH IIF(ISNULL(qbin), ' ', qbin)," + ;
                                      "qserial  WITH IIF(ISNULL(qserial), ' ', qserial)," + ;
                                      "lotno    WITH IIF(ISNULL(lotno), ' ', lotno)," + ;
                                      "issued   WITH IIF(ISNULL(issued), {}, issued)," + ;
                                      "qonhand  WITH IIF(ISNULL(qonhand), 0, qonhand)", "A", "")

    ENDIF


    IF ll_sumserl

      IF gl_locts OR gl_store OR gl_bin
        go_SQL.so_CurrentAlias.m_createIndex("tag1", "loctid + qstore + qbin + item UNIQUE", "", .t., .f.)

      ELSE
        go_SQL.so_CurrentAlias.m_createIndex("tag1", "item + loctid UNIQUE", "", .t., .f.)

      ENDIF
*\ [6 Lines] PTR# 81046 12/28/05 TINA Added ELSE part for a_tmpf1 Index
    ELSE

      IF gl_locts OR gl_store OR gl_bin
        go_SQL.so_CurrentAlias.m_createIndex("tag1", "loctid + qstore + qbin + item", "", .t., .f.)

      ELSE
        go_SQL.so_CurrentAlias.m_createIndex("tag1", "item + loctid", "", .t., .f.)

      ENDIF

    ENDIF

    *-- Set relation into Inventory Master file
    *-- Set Filter
    DO l_setflt

    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)
    lc_scope = "REST"

    *-- Set report title
    lc_title = "Physical Inventory Worksheets"

    IF lc_zero = "Yes"
      lc_head1 = lc_head1 + " (including zero Quantity items)"
    ELSE
      lc_head1 = lc_head1 + " (excluding zero Quantity items)"
    ENDIF

    *# DOCCODE REPORT FORM icphin
    lc_frmfile = gc_icprgdv + "icphin"

    IF go_SQL.so_CurrentAlias.m_IsEof()

      IF g_getdlg(Cc_NoDataMsg, 2, 2, "Yes ", ;
                  "No ", Cc_NullStr, Cc_NullStr) = 1
        *-- Capture current alias
        lc_OldAlias = ALIAS()

        *-- Chosen to preview/print the report
        ll_NoMatch = .t.

        *-- Launch the report selection dialog if custom reports
        *-- are available
        IF NOT ll_NoSelrpt
           lc_frmfile = g_selrpt(lc_frmfile)
        ENDIF

        *-- Create temporary table and temporary frx file for printing
        *-- no data found
        lc_frmfile = g_pnorec(.t., lc_frmfile)
      ENDIF

    ELSE

      *-- Launch the report selection dialog if custom reports
      *-- are available
      IF NOT ll_NoSelrpt
         lc_frmfile = g_selrpt(lc_frmfile)
      ENDIF

    ENDIF && go_SQL.so_CurrentAlias.m_IsEof()

    *-- Call routine to display/print only when there are records or
    *-- chosen to display/print the message no data found
    IF NOT go_SQL.so_CurrentAlias.m_IsEof() OR ll_NoMatch
      DO g_prnrp WITH .t., .f., .f., .f., .t.
    ENDIF

    IF ll_NoMatch
      = g_pnorec()

      *-- Restore back the previous alias
      go_SQL.m_TableChangeCurrent(lc_OldAlias)
    ENDIF

  ENDIF

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_physinv
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_CLCOHV
*------------------------------------------------------------------------------
*- Synopsis...: Calculate current onhand value of item
*------------------------------------------------------------------------------
*- Calls......: g_clcohv()
*------------------------------------------------------------------------------
*- Called By..: ICREPT.PRG
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.: A_ICILOC
*-              A_TMPF1 - positioned on record for item being processed
*-
*- Assumptions: None
*------------------------------------------------------------------------------
*- Returns:
*- Value......: <expN1>  Onhand value for item at all locations
*------------------------------------------------------------------------------
FUNCTION l_clcohv

  PRIVATE ln_inval, ;
          ln_area, ;
          lc_LoopType

  ln_inval = 0

  *-- Store current alias
  ln_area = SELECT()

  go_SQL.m_TableChangeCurrent("a_iciloc")
  go_SQL.cmpA_Iciloc.m_SetOrder("item1")

  IF go_Sql.sc_SqlTypeMain = "F"
    *-- Ensure record pointer in location file
    go_SQL.cmpA_Iciloc.m_Seek(a_tmpf1->item, "")
    lc_LoopType = "W"
  ELSE
    lc_LoopType = "F"
  ENDIF

  *-- Calculate total value for the item at all locations
  go_SQL.cmpA_Iciloc.m_ScanBegin(lc_LoopType, "item = ??a_tmpf1->item")
  DO WHILE go_SQL.cmpA_Iciloc.m_ScanBulk()
    ln_inval = ln_inval + g_clcohv("VALUE", .t.)

  ENDDO
  go_SQL.cmpA_Iciloc.m_ScanEnd()

  *-- Restore old work area
  go_SQL.m_TableChangeCurrent(ln_area)

RETURN ln_inval
*------------------------------------------------------------------------------
*- End Function...: l_clcohv
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function...: L_RETCXRA
*------------------------------------------------------------------------------
*- Synopsis...: Calculate current exchange rate
*------------------------------------------------------------------------------
*- Calls......: g_retxra()
*------------------------------------------------------------------------------
*- Called By..: ICREPT.PRG
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: None
*-
*- Files Open.: A_ICILOC
*-              A_TMPF1 - positioned on record for item being processed
*-
*- Assumptions: None
*------------------------------------------------------------------------------
*- Returns:
*- Value......: <expN1>  Onhand value for item at all locations
*------------------------------------------------------------------------------
FUNCTION l_retcxra

PARAMETERS pc_currid, ;
           pd_rtdate

  PRIVATE ln_currate, ;
          ld_rtdate

  ln_currate = 1.00
  ld_rtdate = IIF(EMPTY(pd_rtdate), gd_sdate, pd_rtdate)

  = g_retxra(pc_currid, gc_basecur, ld_rtdate, @ln_currate, "B")

RETURN ln_currate
*------------------------------------------------------------------------------
*- End Function...: l_clcohv
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: l_dueasof
*------------------------------------------------------------------------------
*- Synopsis...: Retrieve the transaction for the 'as of date' given
*------------------------------------------------------------------------------
*- Called by..: l_icrept
*------------------------------------------------------------------------------
PROCEDURE l_dueasof

  PRIVATE ld_tdate, ;
          ln_opntrn, ;
          ln_opnytrn, ;
          lc_ordtrn, ;
          lc_ordytrn

  *-- Open Inventory Transaction Detail file
  ln_opntrn = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "loctid1")

  *-- Open Inventory History Transaction Detail file
  ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "loctid1")

  *-- Gather data for current files

  *-- Gather data for SO transaction file, group by select criteria
  *-- Don't calculate price for shipping charges that have been shipped
  *-- Price for shipping charges that have been shipped is gathered below
  *-- from ICTRAN
  *-- go_SQL.m_sqlSelect does not support UNION with GROUP BY in both parts any more (06/2002).
  *-- Seperate the call to two calls and then using m_appendfrom() to combine the results
  go_SQL.m_SQLSelect("a_ictran->ttranno, a_ictran->tdate, a_ictran.trantyp, " + ;
      "a_ictran->loctid, a_ictran->item, a_ictran->tcost AS avgcost, a_ictran->TaxRate AS TaxRate, " + ;
      " SUM(a_ictran->sqty) AS lonhand,  a_ictran->tdate, a_ictran->umeasur, a_ictran->umfact, " + ;
      STR(g_curpic(NTOM(99999999),gn_deccst), 9+gn_deccst, gn_deccst)+ ;
      " AS ohvitem FROM " + go_SQL.cmpA_ictran.sc_tableNameFull + " a_ictran " + ;
      " WHERE DTOS(a_ictran->tdate) + a_ictran->item > '" + DTOS(ld_asofdt) + CHR(255) + "' " + ;
      " GROUP BY a_ictran->loctid, a_ictran->item, a_ictran->tcost, a_ictran->TranTyp " + ;
      " ORDER BY 5, 2 DESC, 3, 1 ", ;
      "SQL TABLE", go_SQL.m_getTempTableName(2))
  go_SQL.so_CurrentAlias.m_CloseTable()

  go_SQL.m_SQLSelect("a_icytrn->ttranno, a_icytrn->tdate, a_icytrn.trantyp, " + ;
      "a_icytrn->loctid, a_icytrn->item, a_icytrn->tcost AS avgcost, a_icytrn->TaxRate AS TaxRate, " + ;
      " SUM(a_icytrn->sqty) AS lonhand,  a_icytrn->tdate, a_icytrn->umeasur, a_icytrn->umfact, " + ;
      STR(g_curpic(NTOM(99999999),gn_deccst), 9+gn_deccst, gn_deccst)+ ;
      " AS ohvitem FROM " + go_SQL.cmpA_icytrn.sc_tableNameFull + " a_icytrn " + ;
      " WHERE DTOS(a_icytrn->tdate) + a_icytrn->item > '" + DTOS(ld_asofdt) + CHR(255) + "' " + ;
      " GROUP BY a_icytrn->loctid, a_icytrn->item, a_icytrn->tcost, a_icytrn->TranTyp " + ;
      " ORDER BY 5, 2 DESC, 3, 1 ", ;
      "SQL TABLE", go_SQL.m_getTempTableName(9))
  go_SQL.so_CurrentAlias.m_CloseTable()

  ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(9), "a_tmpf9", .t., .f.)
  ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)

  go_sql.cmpA_tmpf2.m_SqlAppendFrom(go_SQL.m_getTempTableName(9), "")

  *-- Close file and reopen with alias
  go_SQL.m_TableChangeCurrent("a_tmpf2")

*\ [1 Line] PTR# 83952 08/16/06 TISN Included tax only for receipt and receipt return
  *-- we need to calculate the on hand value for cutoff date
  go_SQL.cmpA_tmpf2.m_ReplaceBulk("ohvitem WITH (g_extnd(" + STR(gn_deccst) + ;
                                  ", avgcost, lonhand, IIF(INLIST(trantyp, ' R', 'RI'), -TaxRate, 0)))", ;
                                    "A", "", .t.)

  go_SQL.m_TableChangeCurrent("a_tmpf1")
  go_SQL.cmpA_tmpf1.m_createIndex("tag1", "loctid + item", "", .t., .f.)

  go_SQL.m_TableChangeCurrent("a_tmpf2")

  *-- Obtain sum of lonhand, ohvitem for subtractions done in subsequent replacebulk,
  *-- as the scan logic in the old code would subtract the value for each record scanned.
  go_SQL.m_SQLSelect("a_tmpf2->loctid, a_tmpf2->item, a_tmpf2->trantyp, " + ;
    " SUM(IIF(trantyp = 'CA', 0, a_tmpf2->lonhand)) AS lonhand, SUM(a_tmpf2->ohvitem) AS ohvitem " + ;
    " FROM " + go_SQL.cmpA_tmpf2.sc_tableNameFull + ;
    " a_tmpf2 GROUP BY a_tmpf2->loctid, a_tmpf2->item ",  ;
    "SQL TABLE", go_SQL.m_getTempTableName(4))

  go_SQL.so_CurrentAlias.m_CloseTable()
  ln_opntmpf4 = g_opnfl(go_SQL.m_getTempTableName(4), "a_tmpf4", .t., .f.)
  go_SQL.cmpA_tmpf4.m_createIndex("tag4", "loctid + item", "", .t., .f.)

  go_SQL.cmpA_tmpf1.m_SetRelation("loctid + item", "a_tmpf4", .t.)

*\ [Begin] PTR# 77171 01/24/05 TISN Updated on hand value of the item only when quantity on
*\                                  hand is greater than zero
  go_SQL.cmpA_tmpf1.m_ReplaceBulk("ionhand WITH a_tmpf1->ionhand - " + ;
                                     "IIF(ISNULL(a_tmpf4->item), 0, a_tmpf4->lonhand), " + ;
                                  "lonhand WITH a_tmpf1->lonhand - " + ;
                                     "IIF(ISNULL(a_tmpf4->item), 0, a_tmpf4->lonhand) ", ;
                                     "A", "", .t.)

*\ [1 Line] PTR# 78522 03/22/05 TIRR Update onhand value when quantity on hand is greater
*\                                   than 0
  *-- When the quantity on hand is zero, set Onhand value to zero
  go_SQL.cmpA_tmpf1.m_ReplaceBulk("ohvitem WITH " + ;
                                  "IIF(ISNULL(a_tmpf4->item), a_tmpf1->ohvitem, IIF(a_tmpf1->lonhand <> 0, a_tmpf1->ohvitem - a_tmpf4->ohvitem, 0))", ;
                                  "A", "", .t.)
*\ [End]   PTR# 77171 01/24/05 TISN Updated on hand value of the item only when quantity on
*\                                  hand is greater than zero

  lc_ordtrn = go_SQL.cmpA_Ictran.m_GetOrder()
  go_SQL.cmpA_Ictran.m_SetOrder("item1")

  lc_ordytrn = go_SQL.cmpA_Icytrn.m_GetOrder()
  go_SQL.cmpA_Icytrn.m_SetOrder("item1")

  go_SQL.m_TableChangeCurrent("a_tmpf1")

  *-- update avg cost when lonhand is 0
  *-- Fetch relevant details from ICYTRN into a temporary table ordered by
  *-- LOCTID+ITEM+DTOS(tdate). This order is significant as the tcost value
  *-- is picked up from the last transaction date less than "As Of" date
  go_SQL.m_SQLSelect("a_tmpf1.item, a_tmpf1.loctid, tcost, tdate, " + ;
                     "DTOS(tdate) AS strdate " + ;
                     "FROM " + ;
                     go_SQL.cmpa_Icytrn.sc_TableNameFull + " a_icytrn " + ;
                     "INNER JOIN " + go_SQL.cmpa_Tmpf1.sc_TableNameFull + ;
                     " a_tmpf1 ON a_tmpf1.loctid + a_tmpf1.item = " + ;
                     "a_icytrn.loctid + a_icytrn.item " + ;
                     "ORDER BY a_tmpf1.loctid, a_tmpf1.item, strdate", "SQL TABLE", ;
                     go_SQL.m_GetTempTableName(8))

  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- Fetch relevant details from ICYTRN into a temporary table ordered by
  *-- LOCTID+ITEM+DTOS(tdate). This order is significant as the tcost value
  *-- is picked up from the last transaction date less than "As Of" date
  go_SQL.m_SQLSelect("a_tmpf1.item, a_tmpf1.loctid, tcost, tdate, " + ;
                     "DTOS(tdate) AS strdate " + ;
                     "FROM " + ;
                     go_SQL.cmpa_Ictran.sc_TableNameFull + " a_ictran " + ;
                     "INNER JOIN " + go_SQL.cmpa_Tmpf1.sc_TableNameFull + ;
                     " a_tmpf1 ON a_tmpf1.loctid + a_tmpf1.item = " + ;
                     "a_ictran.loctid + a_ictran.item " + ;
                     "ORDER BY a_tmpf1.loctid, a_tmpf1.item, strdate", "SQL TABLE", ;
                     go_SQL.m_GetTempTableName(9))

   go_SQL.so_CurrentAlias.m_CloseTable()

   *-- Open the newly created intermediate tables
   = g_opnfl(go_SQL.m_GetTempTableName(8), "a_tmpf8", .f., .f.)
   = g_opnfl(go_SQL.m_GetTempTableName(9), "a_tmpf9", .f., .f.)

   *-- Create index in order to establish a relation between these intermediate
   *-- tables and A_tmpf1
   go_SQL.cmpa_Tmpf8.m_CreateIndex("idx1", "loctid + item", .f., .t., .t.)
   go_SQL.cmpa_Tmpf9.m_CreateIndex("idx2", "loctid + item", .f., .t., .t.)

  go_SQL.cmpa_Tmpf1.m_SetRelation("loctid + item", "a_tmpf8", .t.)
  *-- Update avg cost when lonhand is 0
  go_SQL.cmpa_Tmpf1.m_ReplaceBulk("wavgcst WITH a_tmpf8->tcost", "F", ;
                                  "a_tmpf1->lonhand = 0 AND " + ;
                                  "a_tmpf8->tdate <= ??ld_asofdt", .t.)

  go_SQL.cmpa_Tmpf1.m_SetRelation("loctid + item", "a_tmpf9", .t.)
  *-- Update avg cost when lonhand is 0
  go_SQL.cmpa_Tmpf1.m_ReplaceBulk("wavgcst WITH a_tmpf9->tcost", "F", ;
                                  "a_tmpf1->lonhand = 0 AND " + ;
                                  "a_tmpf9->tdate <= ??ld_asofdt", .t.)

  *-- Remove the relation
  go_SQL.cmpa_Tmpf1.m_SetRelation("OFF", "a_Tmpf8")
  go_SQL.cmpa_Tmpf1.m_SetRelation("OFF", "a_Tmpf9")

  go_SQL.cmpa_Tmpf8.m_DropIndex("idx2", .t., .t.)
  go_SQL.cmpa_Tmpf9.m_DropIndex("idx1", .t., .t.)
  go_SQL.cmpa_Tmpf8.m_CloseTable()
  go_SQL.cmpa_Tmpf9.m_CloseTable()

  go_SQL.m_dropTable(go_SQL.m_getTempTableName(8))
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(9))

  *-- Erase the temp table
  go_SQL.cmpa_Tmpf1.m_SetRelation("OFF", "a_Tmpf4")
  go_SQL.cmpa_Tmpf4.m_DropIndex("tag4", .t., .t.)
  go_SQL.cmpa_Tmpf4.m_CloseTable()
  go_SQL.m_dropTable(go_SQL.m_getTempTableName(4))

  IF NOT EMPTY(lc_ordytrn)
    go_SQL.cmpA_Icytrn.m_SetOrder(lc_ordytrn)
  ENDIF

  IF NOT EMPTY(lc_ordtrn)
    go_SQL.cmpA_Ictran.m_SetOrder(lc_ordtrn)
  ENDIF

  go_SQL.m_TableChangeCurrent("a_tmpf1")

  *-- closes all open index files
  SET INDEX TO

RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_dueasof
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function..: l_valdte
*------------------------------------------------------------------------------
*- Synopsis...: Validates date fields
*------------------------------------------------------------------------------
*- Called by..:
*------------------------------------------------------------------------------
FUNCTION l_valdte

  PRIVATE ln_return

  ln_retval = 1
  ld_asofdt = g_retdt(lc_asofdt)

  IF EMPTY(ld_asofdt)
    = g_dspalt("As of date cannot be blank", 2)

    ln_retval = 0
  ENDIF

  IF (ln_retval = 1)
    ln_retval = g_valdte()
  ENDIF

RETURN ln_retval
*------------------------------------------------------------------------------
*- End Procedure...: l_valdte
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F01
*------------------------------------------------------------------------------
*- Description: Reports 1/2/3/4/5/6/7/8/9/V
*------------------------------------------------------------------------------
*- Synopsis...: (1) Inventory Summary   (F1)  Inventory Master
*-              (2) Inventory On Hand   (F2)  Inventory By Location
*-              (3) Inventory Transfers (F3)  Distribution By Value
*-              (6) Recommended Reorder (F5)  Suppliers File
*-              (7) Physical Inventory  (F6)  Lot File
*-                                      (F7)  Location File
*-                                      (F8)  Product Line File
*-                                      (F9)  Units of Measure File
*------------------------------------------------------------------------------
*- Calls......: SYVALR
*------------------------------------------------------------------------------
*- Passed:
*- Variables: LEFT(lc_file,1)      = "C" for current period file
*-                           "H" for history file
*-                           "B" for both files
*-            TRIM(lc_type)      = type of report (B, D, and F3):
*-                           "A" for all items
*-                           "S" for stock items only
*-                           "N" for nonstock items only
*-                           type of report (C only):
*-                           "Y" for all transfers
*-                           "I" for inventory issues only
*-                           "R" for inventory receipts only
*-                           "C" for inventory cost changes only
*-                           "P" for physical inventory only
*-                           "A" for cost adjustment entries only
*-                         type of report (F1, F2)
*-                           "A" = Asset
*-                           "E" = Expense
*-                           "I" = Inventory
*-                           "S" = Service
*-            ln_days      = number of days before/since last sale
*-            LEFT(lc_range,1)     = " " for All Sales
*-                         "B" for Sales before number of days
*-                         "S" for Sales since number of days
*-            LEFT(lc_incld,1)     = "A" for All
*-                         "B" for below reorder point
*-            lc_bdate     = beginning date
*-            lc_edate     = ending date
*-            LEFT(lc_order,1)     = "I" to order report by item (D,F,F1,F3)
*-                         "D" to order report by description (D,F,F1.F3)
*-                         "1" to show 1st price (E)
*-                         "2" to show 2nd price (E)
*-                         "3" to show 3rd price (E)
*-            mcustno    = customer number or portion to match
*-            lc_bitem     = beginning item
*-            lc_eitem     = ending item
*-            lc_bvprtno  = beginning vendor P/N
*-            lc_evprtno  = ending vendor P/N
*-            lc_bclass    = beginning inventory class
*-            lc_eclass    = ending inventory class
*-            mcode      = customer/inventory code or portion to match
*-            lc_dbvtype = "C" = Customer
*-                         "I" = Inventory
*-                         "V" = Vendor
*-            ln_minamt  = activity below this amount is excluded
*-            lc_0accnt  = lower account range limit
*-            lc_9accnt  = upper account range limit
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f01
      *-- Inventory File Listing

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF
      
      *-- Set item status condition
	  IF lc_status <> "All"
		lc_filt = lc_filt + [a_icitem->itemstat = '] + LEFT(lc_status, 1) + [' AND ]
	  ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Remove relationships in Inventory Master file
      go_SQL.cmpA_icitem.m_SetRelation("", "", .f.)

      *-- Set location and date of last sale conditions
      IF NOT EMPTY(lc_loctid) OR NOT EMPTY(ld_bdate)
        *-- Open Inventory by Location file
        = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item")

        *-- Set filter conditions in Inventory by Location file
        DO CASE
          CASE NOT EMPTY(lc_loctid) AND NOT EMPTY(ld_bdate)
             lc_filt_more = " AND a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%' " + ;
                              "AND a_iciloc->lsale >= ??ld_bdate"
             go_SQL.so_CurrentAlias.m_SetFilter("a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%' AND " + ;
                                                "a_iciloc->lsale >= ??ld_bdate")

          CASE NOT EMPTY(lc_loctid)
            lc_filt_more = " AND a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%' "
            go_SQL.so_CurrentAlias.m_SetFilter("a_iciloc->loctid %=% TRIM(??lc_loctid) + '%/%' ")

          CASE NOT EMPTY(ld_bdate)
            lc_filt_more = " AND a_iciloc->lsale >= ??ld_bdate"
            go_SQL.so_CurrentAlias.m_SetFilter("a_iciloc->lsale >= ??ld_bdate")
        ENDCASE

        *-- Select Inventory Master file
        go_SQL.m_TableChangeCurrent("a_icitem")
        go_SQL.cmpA_icitem.m_SetRelation("item", "a_iciloc", .t.)

        *-- Set location and date of last sale conditions
        lc_filt = lc_filt + [ AND NOT go_SQL.cmpA_Iciloc.m_IsEof()] + lc_filt_more
      ENDIF && .NOT EMPTY(lc_loctid) OR NOT EMPTY(ld_bdate)

      *-- Set part number condition
      IF NOT EMPTY(lc_vpartno)
        *-- Open Inventory by Supplier file
        = g_opnfl(gf_icsuplf, "a_icsupl", .f., .f., "item")

        *-- Set filter conditions in Inventory by Supplier file
        lc_filt_more = " AND a_icsupl->vpartno %=% TRIM(??lc_vpartno) + '%/%'"

        go_SQL.so_CurrentAlias.m_SetFilter("a_icsupl->vpartno %=% TRIM(??lc_vpartno) + '%/%'")

        *-- Select Inventory Master file
        go_SQL.m_TableChangeCurrent("a_icitem")
        go_SQL.cmpA_icitem.m_SetRelation("item", "a_icsupl", .t.)

        *-- Set part number condition
        lc_filt = lc_filt + [ AND NOT go_SQL.cmpA_Icsupl.m_IsEof()] + lc_filt_more
      ENDIF

      *-- Set Filter
      DO l_setflt

      go_SQL.cmpA_icitem.m_CopyTo(go_SQL.m_getTempTableName(1), "")

      *-- Open temporary file
      ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

  	  *-- HOOK BEGIN: <ACS>: add lookup index
  	  *-- Note: hook converted if/else/endif structure to case/endcase
      DO CASE
        CASE gl_acs AND gl_acs_upos AND ;
             lc_order <> "Item" AND lc_order <> "Description"
		  *% upos710 sql
          go_SQL.cmpA_tmpf1.m_createIndex("tagitem", "lookup + UPPER(itmdesc)", "", .t., .f.)
        CASE LEFT(lc_order,1) = "I"
          go_SQL.cmpA_tmpf1.m_createIndex("tagitem", "item", "", .t., .f.)
        OTHERWISE
          go_SQL.cmpA_tmpf1.m_createIndex("tagitem", "itmdesc", "", .t., .f.)
      ENDCASE
  	  *-- HOOK END: <ACS>: add lookup index

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Inventory Master Report"

      *# DOCCODE REPORT FORM syinvt
      lc_frx = gc_idrvprg + "syinvt"

RETURN
*------------------------------------------------------------------------------
*- End Main: L_ICREPT_F01.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F02
*------------------------------------------------------------------------------
*- Description: Reports 1/2/3/4/5/6/7/8/9/V
*------------------------------------------------------------------------------
*- Synopsis...: (1) Inventory Summary   (F1)  Inventory Master
*-              (2) Inventory On Hand   (F2)  Inventory By Location
*-              (3) Inventory Transfers (F3)  Distribution By Value
*-              (6) Recommended Reorder (F5)  Suppliers File
*-              (7) Physical Inventory  (F6)  Lot File
*-                                      (F7)  Location File
*-                                      (F8)  Product Line File
*-                                      (F9)  Units of Measure File
*------------------------------------------------------------------------------
*- Calls......: SYVALR
*------------------------------------------------------------------------------
*- Passed:
*- Variables: LEFT(lc_file,1)      = "C" for current period file
*-                           "H" for history file
*-                           "B" for both files
*-            TRIM(lc_type)      = type of report (B, D, and F3):
*-                           "A" for all items
*-                           "S" for stock items only
*-                           "N" for nonstock items only
*-                           type of report (C only):
*-                           "Y" for all transfers
*-                           "I" for inventory issues only
*-                           "R" for inventory receipts only
*-                           "C" for inventory cost changes only
*-                           "P" for physical inventory only
*-                           "A" for cost adjustment entries only
*-                         type of report (F1, F2)
*-                           "A" = Asset
*-                           "E" = Expense
*-                           "I" = Inventory
*-                           "S" = Service
*-            ln_days      = number of days before/since last sale
*-            LEFT(lc_range,1)     = " " for All Sales
*-                         "B" for Sales before number of days
*-                         "S" for Sales since number of days
*-            LEFT(lc_incld,1)     = "A" for All
*-                         "B" for below reorder point
*-            lc_bdate     = beginning date
*-            lc_edate     = ending date
*-            LEFT(lc_order,1)     = "I" to order report by item (D,F,F1,F3)
*-                         "D" to order report by description (D,F,F1.F3)
*-                         "1" to show 1st price (E)
*-                         "2" to show 2nd price (E)
*-                         "3" to show 3rd price (E)
*-            mcustno    = customer number or portion to match
*-            lc_bitem     = beginning item
*-            lc_eitem     = ending item
*-            lc_bvprtno  = beginning vendor P/N
*-            lc_evprtno  = ending vendor P/N
*-            lc_bclass    = beginning inventory class
*-            lc_eclass    = ending inventory class
*-            mcode      = customer/inventory code or portion to match
*-            lc_dbvtype = "C" = Customer
*-                         "I" = Inventory
*-                         "V" = Vendor
*-            ln_minamt  = activity below this amount is excluded
*-            lc_0accnt  = lower account range limit
*-            lc_9accnt  = upper account range limit
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f02
      *-- Inventory by Location

      *-- Set type condition
      IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type = ??LEFT(lc_type,1) AND ]
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_iciloc->loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_iciloc->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set class condition
      IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
      ENDIF

      IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set commodity code condition
      IF NOT EMPTY(lc_bccode)
        lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
      ENDIF

      IF NOT EMPTY(lc_eccode)
        lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set misc code condition
      IF NOT EMPTY(lc_bmcode)
        lc_filt = lc_filt + [a_icitem->code >= ??TRIM(lc_bmcode) AND ]
      ENDIF

      IF NOT EMPTY(lc_emcode)
        lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item status condition
	  IF lc_status <> "All"
		lc_filt = lc_filt + [a_iciloc->itemstat = '] + LEFT(lc_status, 1) + [' AND ]
	  ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory by Location file
      ln_opniloc = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "loctid1")

      *-- Set Filter
      DO l_setflt

      go_SQL.cmpA_iciloc.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.cmpA_iciloc.m_MoveRecord(Cn_TopRec)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Inventory By " + PROPER(gc_loct)

      *# DOCCODE REPORT FORM syiloc
      lc_frx = gc_idrvprg + "syiloc"


RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F02.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F03
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f03
      *-- Distribution by Value Report

      *-- Set type condition
      DO CASE
        CASE TRIM(lc_type) = "A"
          lc_type = "YN"
        CASE TRIM(lc_type) = "S"
          lc_type = "Y"
        CASE TRIM(lc_type) = "N"
          lc_type = "N"
      ENDCASE

      *-- Set date of last sale condition
      IF EMPTY(mdbdate)
        ld_bdate = Cd_mindate
      ELSE
        ld_bdate = g_retdt(mdbdate)
      ENDIF

      *-- Create and build Distribution by Value Report file
      *# DOCCODE DO syvalr
      DO (gc_idrvprg + "syvalr")

      *-- Set report title
      lc_title = "Inventory Distribution by Value Report"

      *-- Set report form name
      *# DOCCODE REPORT FORM syvali
      lc_frx = gc_idrvprg + "syvali"

      *-- Set scope
      lc_cond = SPACE(0)
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F03.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F05
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f05
      *-- Suppliers File

      *-- Set vendor number condition
      IF NOT EMPTY(lc_bvendno)
        lc_filt = lc_filt + [a_icsupl->vendno >= ??TRIM(lc_bvendno) AND ]
      ENDIF

      IF NOT EMPTY(lc_evendno)
        lc_filt = lc_filt + [a_icsupl->vendno <= TRIM(??lc_evendno) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icsupl->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icsupl->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set vendor part number condition
      IF NOT EMPTY(lc_bvprtno)
        lc_filt = lc_filt + [a_icsupl->vpartno >= ??TRIM(lc_bvprtno) AND ]
      ENDIF

      IF NOT EMPTY(lc_evprtno)
        lc_filt = lc_filt + [a_icsupl->vpartno <= TRIM(??lc_evprtno) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set vendor rating condition
      IF NOT EMPTY(lc_brate)
        lc_filt = lc_filt + [a_icsupl->rating >= ??TRIM(lc_brate) AND ]
      ENDIF

      IF NOT EMPTY(lc_erate)
        lc_filt = lc_filt + [a_icsupl->rating <= TRIM(??lc_erate) + '] + CHR(255) + [' AND ]
      ENDIF
      
      *-- Set item status condition
	  IF lc_status <> "All"
		lc_filt = lc_filt + [a_icsupl->itemstat = '] + LEFT(lc_status, 1) + [' AND ]
	  ENDIF


      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Inventory Master file
      ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      *-- Open Inventory Suppliers' file
      ln_opnsupl = g_opnfl(gf_icsuplf, "a_icsupl", .f., .f., "vendno1")

      *-- Set Filter
      DO l_setflt

      go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Supplier File Report"

      *# DOCCODE REPORT FORM icisup
      lc_frx = gc_icprgdv + "icisup"
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F05.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F06
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f06
      *-- Lot File
      *-- Set lot number condition
      IF NOT EMPTY(lc_blot)
        lc_filt = lc_filt + [a_icilot->lotno >= ??TRIM(lc_blot) AND ]
      ENDIF

      IF NOT EMPTY(lc_elot)
        lc_filt = lc_filt + [a_icilot->lotno <= TRIM(??lc_elot) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set item condition
      IF NOT EMPTY(lc_bitem)
        lc_filt = lc_filt + [a_icilot->item >= ??TRIM(lc_bitem) AND ]
      ENDIF

      IF NOT EMPTY(lc_eitem)
        lc_filt = lc_filt + [a_icilot->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Lot File
      = g_opnfl(gf_icilotf, "a_icilot", .f., .f.,"item1")

      *-- Set Filter
      DO l_setflt

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Lot File Report"

      *# DOCCODE REPORT FORM iclotf
      lc_frx = gc_icprgdv + "iclotf"

RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F06.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F07
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f07

*\ [Begin] PTR # 81862 - SSHA Added new location types
  LOCAL lc_LoctTypeId
  lc_LoctTypeId = ""
  
      *-- Location File
      *-- Set location type condition
      IF lc_loctype <> "All"

        DO CASE 
          CASE lc_loctype = "Warehouse"
            lc_LoctTypeId = "H"
          CASE lc_loctype = "Repair"
            lc_LoctTypeId = "E"
          CASE lc_loctype = "Scrap"
            lc_LoctTypeId = "C"
          OTHERWISE             
            lc_LoctTypeId = LEFT(lc_loctype, 1)
        ENDCASE 

        lc_filt = lc_filt + [a_icloct->loctype = '] + lc_LoctTypeId + [' AND ]
*\ [End] PTR # 81862 - SSHA Added new location types
      ENDIF

      *-- Set location condition
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_icloct->loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_icloct->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF

      *-- Set other conditions
      lc_filt = lc_filt + [ 1=1 ]

      *-- Open Locations File
      ln_opnloct = g_opnfl(gf_icloctf, "a_icloct", .f., .f.)

      *-- Set Filter
      DO l_setflt

      go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = PROPER(gc_loct) + " File Report"

      *# DOCCODE REPORT FORM icloct
      lc_frx = gc_icprgdv + "icloct"

RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F07.PRG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F08
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f08

RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F08.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F08
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f08
  *-- Product Line File
  *-- Set product line id condition
  IF NOT EMPTY(lc_bpline)
    lc_filt = lc_filt + [a_icplin->plinid >= ??TRIM(lc_bpline) AND ]
  ENDIF

  IF NOT EMPTY(lc_epline)
    lc_filt = lc_filt + [a_icplin->plinid <= TRIM(??lc_epline) + '] + CHR(255) + [' AND ]
  ENDIF

  *-- Set other conditions
  lc_filt = lc_filt + [ 1=1 ]

  *-- Open Product Line File
  ln_opnplin = g_opnfl(gf_icplinf, "a_icplin", .f., .f., "plinid")

  *-- Set Filter
  DO l_setflt

  go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

  *-- Set scope
  lc_cond = SPACE(0)

  *-- Set report title
  lc_title = "Product Line File Report"

  *# DOCCODE REPORT FORM icplin
  lc_frx = gc_icprgdv + "icplin"

RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F08.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F09
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f09
    *-- Units of Measure File
    *-- Set conversion factor id condition
    IF NOT EMPTY(lc_bunms)
      lc_filt = lc_filt + [a_icunms->umsconv >= ??TRIM(lc_bunms) AND ]
    ENDIF

    IF NOT EMPTY(lc_eunms)
      lc_filt = lc_filt + [a_icunms->umsconv <= TRIM(??lc_eunms) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set other conditions
    lc_filt = lc_filt + [1=1]

    *-- Open Units of File
    ln_opnunms = g_opnfl(gf_icunmsf, "a_icunms", .f., .f.)

    *-- Set Filter
    DO l_setflt

    go_SQL.so_CurrentAlias.m_MoveRecord(Cn_TopRec)

    *-- Set scope
    lc_cond = SPACE(0)

    *-- Set report title
    lc_title = "Units of Measure File Report"

    *# DOCCODE REPORT FORM icunms
    lc_frx = gc_icprgdv + "icunms"

RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F09.PRG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F10
*------------------------------------------------------------------------------
*- Description: Reports 1/2/3/4/5/6/7/8/9/V
*------------------------------------------------------------------------------
*- Synopsis...: (1) Inventory Summary   (F1)  Inventory Master
*-              (2) Inventory On Hand   (F2)  Inventory By Location
*-              (3) Inventory Transfers (F3)  Distribution By Value
*-              (6) Recommended Reorder (F5)  Suppliers File
*-              (7) Physical Inventory  (F6)  Lot File
*-                                      (F7)  Location File
*-                                      (F8)  Product Line File
*-                                      (F9)  Units of Measure File
*------------------------------------------------------------------------------
*- Calls......: SYVALR
*------------------------------------------------------------------------------
*- Passed:
*- Variables: LEFT(lc_file,1)      = "C" for current period file
*-                           "H" for history file
*-                           "B" for both files
*-            TRIM(lc_type)      = type of report (B, D, and F3):
*-                           "A" for all items
*-                           "S" for stock items only
*-                           "N" for nonstock items only
*-                           type of report (C only):
*-                           "Y" for all transfers
*-                           "I" for inventory issues only
*-                           "R" for inventory receipts only
*-                           "C" for inventory cost changes only
*-                           "P" for physical inventory only
*-                           "A" for cost adjustment entries only
*-                         type of report (F1, F2)
*-                           "A" = Asset
*-                           "E" = Expense
*-                           "I" = Inventory
*-                           "S" = Service
*-            ln_days      = number of days before/since last sale
*-            LEFT(lc_range,1)     = " " for All Sales
*-                         "B" for Sales before number of days
*-                         "S" for Sales since number of days
*-            LEFT(lc_incld,1)     = "A" for All
*-                         "B" for below reorder point
*-            lc_bdate     = beginning date
*-            lc_edate     = ending date
*-            LEFT(lc_order,1)     = "I" to order report by item (D,F,F1,F3)
*-                         "D" to order report by description (D,F,F1.F3)
*-                         "1" to show 1st price (E)
*-                         "2" to show 2nd price (E)
*-                         "3" to show 3rd price (E)
*-            mcustno    = customer number or portion to match
*-            lc_bitem     = beginning item
*-            lc_eitem     = ending item
*-            lc_bvprtno  = beginning vendor P/N
*-            lc_evprtno  = ending vendor P/N
*-            lc_bclass    = beginning inventory class
*-            lc_eclass    = ending inventory class
*-            mcode      = customer/inventory code or portion to match
*-            lc_dbvtype = "C" = Customer
*-                         "I" = Inventory
*-                         "V" = Vendor
*-            ln_minamt  = activity below this amount is excluded
*-            lc_0accnt  = lower account range limit
*-            lc_9accnt  = upper account range limit
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f10
      *-- Item Price List

      *-- Set code condition
      IF NOT EMPTY(lc_code)
        lc_filt = lc_filt + [a_icitem->code %=% TRIM(??lc_code) + '%/%' AND ]
      ELSE
        lc_filt = SPACE(0)
      ENDIF

      *-- Set stock code condition
      DO CASE
        CASE TRIM(lc_type) = "S"
          lc_filt = lc_filt + [a_icitem->stkcode %=% 'Y%/%' ]
        CASE TRIM(lc_type) = "N"
          lc_filt = lc_filt + [a_icitem->stkcode %=% 'N%/%' ]
        OTHERWISE
          lc_filt = lc_filt + [a_icitem->stkcode $ 'YN' ]
      ENDCASE

      IF lc_zero = "Yes"
        *-- Include zero price items
      ELSE
        *-- Exclude zero price items
        lc_filt = lc_filt + [ AND a_icitem->price > 0.00 ]
      ENDIF

      IF NOT EMPTY(lc_class)
        lc_filt = lc_filt + [ AND a_icitem->itmclss %=% TRIM(??lc_class) + '%/%']
      ENDIF

      *-- Build filter for COPY TO command
      lc_filt1 = lc_filt

      IF ALLTRIM(lc_reptyp) <> "List prices"

        *-- to top, since filter condn checking this alias.
        *-- Open Item Pricing File
        ln_opnpric = g_opnfl(gf_icpricf, "a_icpric", .f., .f.)

        *-- Set Price codes
        IF NOT EMPTY(lc_psched)
          lc_filt = lc_filt + " AND " + "IIF(a_icpric->psource <> 'I'," + ;
                    "a_icpgrp->psched %=% TRIM(??lc_psched) + '%/%', a_icpric->psched %=% TRIM(??lc_psched) + '%/%')"
        ENDIF

        IF NOT EMPTY(lc_item)
          lc_filt = lc_filt + [ AND a_icpric->item %=% TRIM(??lc_item) + '%/%']
        ENDIF

        IF lc_popt <> "All"
          lc_filt = lc_filt + " AND " + "IIF(a_icpric->psource <> 'I'," + ;
                    "a_icpgrp->popt='" + LEFT(lc_popt,1)+ "', a_icpric->popt= '" + LEFT(lc_popt,1)+ "')"
        ENDIF

        IF lc_popt == "Customer" AND NOT EMPTY(lc_scust)
          lc_filt = lc_filt + " AND " + "IIF(a_icpric->psource <> 'I'," + ;
                    "a_icpgrp->custno %=% TRIM(??lc_scust) + '%/%',a_icpric->custno %=% TRIM(??lc_scust) + '%/%')"
        ENDIF

      ENDIF

      ln_opnitm  = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

      DO CASE
        CASE ALLTRIM(lc_reptyp) = "List prices"

          *-- Select records from inventory file
          IF NOT EMPTY(lc_item)
            lc_filt = lc_filt + [ AND a_icitem->item %=% TRIM(??lc_item) + '%/%']
          ENDIF

          lc_filt = IIF(EMPTY(lc_filt), "",  lc_filt )

          *-- Order By item class and item
          go_SQL.m_SQLSelect("item, itmdesc, itmclss, stkumid, price FROM " + ;
          go_SQL.cmpA_icitem.sc_tableNameFull  + " a_icitem WHERE " + lc_filt + ;
          " ORDER BY itmclss, item", "SQL TABLE", go_SQL.m_getTempTableName(3))

          go_SQL.so_CurrentAlias.m_closeTable()
          g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f., "", .f.)

          *# DOCCODE REPORT FORM icpri1
          lc_frx = gc_icprgdv + "icpri1"

        CASE ALLTRIM(lc_reptyp) = "Price codes"
          *-- Give the filter condition a final & most imp. twist
          lc_filt = IIF(EMPTY(lc_filt), [a_icitem->item = a_icpric->item], ;
                    lc_filt + [ AND a_icitem->item = a_icpric->item])

          *-- Included location filter only if code is entered in option grid
          IF gc_pmarkup = "L" AND gl_locts AND NOT EMPTY(lc_loctid)
            lc_filt = lc_filt + [ AND a_iciloc->item = a_icpric->item]
            lc_filt = lc_filt + [ AND LOCTID %=% TRIM(??lc_loctid) + '%/%']
          ENDIF

          *-- Open Price Group File
          = g_opnfl(gf_icpgrpf, "a_icpgrp", .f., .f., "pgroup8")

          *-- Open Item By Location File
          = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item1")

          *-- Do not report on deleted price schemes

          *-- Check for Individual price records
          lc_filt1 = lc_filt + [ AND a_icpric->psource ='I']

          *-- If company is setup for multilocation and price markups
          IF gc_pmarkup = "L" AND gl_locts
            go_SQL.m_SQLSelect("DISTINCT a_icpric.item, a_icpric.popt, a_icpric.descrip, a_icpric.psched, " + ;
            "a_icpric.custno, a_icpric.pmeth, a_icpric.psource, a_icpric.pgroup, a_icpric.begqty1, a_icpric.endqty1, "+;
            "a_icpric.factor1, a_icpric.unitpr1, a_icpric.begqty2, a_icpric.endqty2, a_icpric.factor2, a_icpric.unitpr2, "+;
            "a_icpric.begqty3, a_icpric.endqty3, a_icpric.factor3, a_icpric.unitpr3, a_icpric.begqty4, a_icpric.endqty4, "+ ;
            "a_icpric.factor4, a_icpric.unitpr4, a_icpric.begqty5, a_icpric.endqty5, a_icpric.factor5, a_icpric.unitpr5, " +;
            "a_icpric.begqty6, a_icpric.endqty6, a_icpric.factor6, a_icpric.unitpr6, a_icpric.sdate, a_icpric.edate, " + ;
            "a_icpric.adduser, a_icpric.adddate, a_icpric.addtime, a_icpric.lckstat, a_icpric.lckuser, a_icpric.lckdate, "+ ;
            "a_icpric.lcktime, a_icpric.currid, " + ;
            "IIF(a_icpric->pmeth = 'C' OR a_icpric->pmeth = 'M', a_iciloc->loctid, SPACE(6)) AS loctid, " + ;
            " a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem ON a_icpric.item = a_icitem.item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc ON a_iciloc->item = a_icitem->item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp ON a_icpgrp->pgroup = a_icpric->pgroup" + ;
            " WHERE " + lc_filt1, "SQL TABLE", go_SQL.m_getTempTableName(3))
          ELSE
            go_SQL.m_SQLSelect("DISTINCT a_icpric.item, a_icpric.popt, a_icpric.descrip, a_icpric.psched, " + ;
            "a_icpric.custno, a_icpric.pmeth, a_icpric.psource, a_icpric.pgroup, a_icpric.begqty1, a_icpric.endqty1, "+;
            "a_icpric.factor1, a_icpric.unitpr1, a_icpric.begqty2, a_icpric.endqty2, a_icpric.factor2, a_icpric.unitpr2, "+;
            "a_icpric.begqty3, a_icpric.endqty3, a_icpric.factor3, a_icpric.unitpr3, a_icpric.begqty4, a_icpric.endqty4, "+ ;
            "a_icpric.factor4, a_icpric.unitpr4, a_icpric.begqty5, a_icpric.endqty5, a_icpric.factor5, a_icpric.unitpr5, " +;
            "a_icpric.begqty6, a_icpric.endqty6, a_icpric.factor6, a_icpric.unitpr6, a_icpric.sdate, a_icpric.edate, " + ;
            "a_icpric.adduser, a_icpric.adddate, a_icpric.addtime, a_icpric.lckstat, a_icpric.lckuser, a_icpric.lckdate, "+ ;
            "a_icpric.lcktime, a_icpric.currid, " + ;
            " SPACE(6) AS loctid, a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem ON a_icpric.item = a_icitem.item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc ON a_iciloc->item = a_icitem->item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp ON a_icpgrp->pgroup = a_icpric->pgroup" + ;
            " WHERE " + lc_filt1, "SQL TABLE", go_SQL.m_getTempTableName(3))
          ENDIF
          go_SQL.so_CurrentAlias.m_closeTable()
          g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f., "", .f.)

          *-- Check for Price Group records
          lc_filt2 = lc_filt +  [ AND a_icpric->psource <> 'I' AND NOT ;
                     EMPTY(a_icpric->pgroup) AND a_icpgrp->pgroup = ;
                     a_icpric->pgroup AND a_icpric->item = a_iciloc->item]

          IF gl_mc
            lc_filt2 = lc_filt2 + [ AND a_icpric->currid = a_icpgrp->currid]
          ENDIF

          *-- If company is setup for multilocation and price markups
          IF gc_pmarkup = "L" AND gl_locts
            go_SQL.m_SQLSelect("Distinct a_icpric->item, a_icpgrp.pgroup, a_icpgrp.grpdesc, a_icpgrp.popt, " +;
            "a_icpgrp.psched, a_icpgrp.custno, a_icpgrp.pmeth, a_icpgrp.begqty1, a_icpgrp.endqty1, " + ;
            "a_icpgrp.factor1, a_icpgrp.unitpr1, a_icpgrp.begqty2, a_icpgrp.endqty2, " + ;
            "a_icpgrp.factor2, a_icpgrp.unitpr2, a_icpgrp.begqty3, a_icpgrp.endqty3, " + ;
            "a_icpgrp.factor3, a_icpgrp.unitpr3,a_icpgrp.begqty4, a_icpgrp.endqty4, " + ;
            "a_icpgrp.factor4, a_icpgrp.unitpr4,a_icpgrp.begqty5, a_icpgrp.endqty5, " + ;
            "a_icpgrp.factor5, a_icpgrp.unitpr5,a_icpgrp.begqty6, a_icpgrp.endqty6, " + ;
            "a_icpgrp.factor6, a_icpgrp.unitpr6,a_icpgrp.sdate, a_icpgrp.edate, " + ;
            "a_icpgrp.descrip, a_icpgrp.adduser,a_icpgrp.adddate, a_icpgrp.addtime, " + ;
            "a_icpgrp.lckstat, a_icpgrp.lckuser,a_icpgrp.lckdate, a_icpgrp.lcktime,a_icpgrp.currid, " + ;
            "'G' as psource, " + ;
            "IIF(a_icpgrp->pmeth = 'C' OR a_icpgrp->pmeth = 'M', a_iciloc->loctid, SPACE(6)) AS LOCTID, " + ;
            "a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric, " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp, " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc, " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem" + " WHERE " + lc_filt2, "SQL TABLE", go_SQL.m_getTempTableName(1))
          ELSE
            go_SQL.m_SQLSelect("Distinct a_icpric->item, a_icpgrp.pgroup, a_icpgrp.grpdesc, a_icpgrp.popt, " +;
            "a_icpgrp.psched, a_icpgrp.custno, a_icpgrp.pmeth, a_icpgrp.begqty1, a_icpgrp.endqty1, " + ;
            "a_icpgrp.factor1, a_icpgrp.unitpr1, a_icpgrp.begqty2, a_icpgrp.endqty2, " + ;
            "a_icpgrp.factor2, a_icpgrp.unitpr2, a_icpgrp.begqty3, a_icpgrp.endqty3, " + ;
            "a_icpgrp.factor3, a_icpgrp.unitpr3,a_icpgrp.begqty4, a_icpgrp.endqty4, " + ;
            "a_icpgrp.factor4, a_icpgrp.unitpr4,a_icpgrp.begqty5, a_icpgrp.endqty5, " + ;
            "a_icpgrp.factor5, a_icpgrp.unitpr5,a_icpgrp.begqty6, a_icpgrp.endqty6, " + ;
            "a_icpgrp.factor6, a_icpgrp.unitpr6,a_icpgrp.sdate, a_icpgrp.edate, " + ;
            "a_icpgrp.descrip, a_icpgrp.adduser,a_icpgrp.adddate, a_icpgrp.addtime, " + ;
            "a_icpgrp.lckstat, a_icpgrp.lckuser,a_icpgrp.lckdate, a_icpgrp.lcktime,a_icpgrp.currid, " + ;
            " 'G' as psource, SPACE(6) AS LOCTID, " + ;
            "a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric, " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp, " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc, " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem" + " WHERE " + lc_filt2, "SQL TABLE", go_SQL.m_getTempTableName(1))
          ENDIF
          go_SQL.so_CurrentAlias.m_closeTable()
          g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f., "", .f.)

          *-- Append and Index temporary table
          IF go_SQL.cmpA_tmpf3.m_count("") > 0
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(3), "")
          ENDIF

          go_SQL.cmpA_tmpf1.m_createIndex("tagitem", ;
              "item + pgroup + psched + pmeth + popt + custno + prc_currid + loctid",;
              "", .t., .f.)
          go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .f.)
          go_SQL.cmpA_tmpf1.m_SetRelation("pgroup", "a_icpgrp", .t.)

          *-- Remove cursor from memory
          go_SQL.cmpA_tmpf3.m_closeTable()

          *-- Call report file
          *# DOCCODE REPORT FORM icpri2
          lc_frx = gc_icprgdv + "icpri2"
        OTHERWISE
          *-- Both
          lc_filt = IIF(EMPTY(lc_filt), [a_icitem->item = a_icpric->item], ;
                    lc_filt + [ AND a_icitem->item = a_icpric->item ;
                    AND a_icpric->item = a_iciloc->item])

          *-- Included location filter only if code is entered in option grid
          IF gc_pmarkup = "L" AND gl_locts AND NOT EMPTY(lc_loctid)
            lc_filt = lc_filt + [ AND a_iciloc->item = a_icpric->item]
            lc_filt = lc_filt + [ AND loctid %=% TRIM(??lc_loctid) + '%/%']
          ENDIF

          *-- Open Item Pricing File
          = g_opnfl(gf_icpgrpf, "a_icpgrp", .f., .f., "pgroup8")

          *-- Open Location File
          = g_opnfl(gf_icilocf, "a_iciloc", .f., .f., "item1")

          *-- Do not report on deleted price schemes

          go_SQL.m_TableChangeCurrent("a_icpric")
          go_SQL.cmpA_icpric.m_SetRelation("pgroup", "a_icpgrp", .f.)

          IF EMPTY(lc_psched)
            lc_filt1 = IIF(EMPTY(lc_filt1), "", lc_filt1 + " AND ") + [go_SQL.cmpA_Icpric.m_IsEof()]

            go_SQL.m_TableChangeCurrent("a_icpric")
            go_SQL.cmpA_icpric.m_SetOrder("item1")

            go_SQL.m_TableChangeCurrent("a_icitem")
            go_SQL.cmpa_icitem.m_SetOrder("item")
            go_SQL.cmpa_icitem.m_SetRelation("item", "a_icpric", .f.)

            *-- Copy records in ICITEM but not in ICPRIC to temp file2
            go_SQL.cmpa_icitem.m_CopyTo(go_SQL.m_getTempTableName(2), "FOR " + ;
            lc_filt1 + " AND a_icitem->item %=% RTRIM(??lc_item) + '%/%'")

            g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f., "", .f.)
            go_SQL.m_TableChangeCurrent("a_icitem")

            go_SQL.cmpa_icitem.m_SetRelation("", "", .f.)

          ENDIF && EMPTY(lc_psched)

          lc_filt1 = SPACE(0)

          *-- Check for Individual price records
          lc_filt1 = lc_filt + [ AND a_icpric->psource ='I']

          *-- If using location costs
          IF gc_pmarkup = "L" AND gl_locts
            go_SQL.m_SQLSelect("DISTINCT a_icpric.item, a_icpric.popt, a_icpric.descrip, a_icpric.psched, " + ;
            "a_icpric.custno, a_icpric.pmeth, a_icpric.psource, a_icpric.pgroup, a_icpric.begqty1, a_icpric.endqty1, "+;
            "a_icpric.factor1, a_icpric.unitpr1, a_icpric.begqty2, a_icpric.endqty2, a_icpric.factor2, a_icpric.unitpr2, "+;
            "a_icpric.begqty3, a_icpric.endqty3, a_icpric.factor3, a_icpric.unitpr3, a_icpric.begqty4, a_icpric.endqty4, "+ ;
            "a_icpric.factor4, a_icpric.unitpr4, a_icpric.begqty5, a_icpric.endqty5, a_icpric.factor5, a_icpric.unitpr5, " +;
            "a_icpric.begqty6, a_icpric.endqty6, a_icpric.factor6, a_icpric.unitpr6, a_icpric.sdate, a_icpric.edate, " + ;
            "a_icpric.adduser, a_icpric.adddate, a_icpric.addtime, a_icpric.lckstat, a_icpric.lckuser, a_icpric.lckdate, "+ ;
            "a_icpric.lcktime, a_icpric.currid, " + ;
            "IIF(a_icpric->pmeth='C' OR a_icpric->pmeth='M', a_iciloc->loctid, SPACE(6)) AS loctid, " + ;
            "a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem ON a_icpric.item = a_icitem.item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc ON a_iciloc->item = a_icitem->item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp ON a_icpgrp->pgroup = a_icpric->pgroup" + ;
            " WHERE " + lc_filt1, "SQL TABLE", go_SQL.m_getTempTableName(3))
          ELSE
            go_SQL.m_SQLSelect("DISTINCT a_icpric.item, a_icpric.popt, a_icpric.descrip, a_icpric.psched, " + ;
            "a_icpric.custno, a_icpric.pmeth, a_icpric.psource, a_icpric.pgroup, a_icpric.begqty1, a_icpric.endqty1, "+;
            "a_icpric.factor1, a_icpric.unitpr1, a_icpric.begqty2, a_icpric.endqty2, a_icpric.factor2, a_icpric.unitpr2, "+;
            "a_icpric.begqty3, a_icpric.endqty3, a_icpric.factor3, a_icpric.unitpr3, a_icpric.begqty4, a_icpric.endqty4, "+ ;
            "a_icpric.factor4, a_icpric.unitpr4, a_icpric.begqty5, a_icpric.endqty5, a_icpric.factor5, a_icpric.unitpr5, " +;
            "a_icpric.begqty6, a_icpric.endqty6, a_icpric.factor6, a_icpric.unitpr6, a_icpric.sdate, a_icpric.edate, " + ;
            "a_icpric.adduser, a_icpric.adddate, a_icpric.addtime, a_icpric.lckstat, a_icpric.lckuser, a_icpric.lckdate, "+ ;
            "a_icpric.lcktime, a_icpric.currid, SPACE(6) AS loctid, a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem ON a_icpric.item = a_icitem.item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc ON a_iciloc->item = a_icitem->item LEFT OUTER JOIN " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp ON a_icpgrp->pgroup = a_icpric->pgroup" + ;
            " WHERE " + lc_filt1, "SQL TABLE", go_SQL.m_getTempTableName(3))
          ENDIF
          go_SQL.so_CurrentAlias.m_closeTable()
          g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f., "", .f.)

          *-- Check for Price Group records
          lc_filt2 = lc_filt +  [ AND a_icpric->psource <> 'I' AND NOT ;
                     EMPTY(a_icpric->pgroup) AND a_icpgrp->pgroup = ;
                     a_icpric->pgroup ]

          IF gl_mc
            lc_filt2 = lc_filt2 + [ AND a_icpric->currid = a_icpgrp->currid]
          ENDIF

          go_SQL.m_TableChangeCurrent("a_icitem")

          *-- If company is setup for multilocation and price markups
          IF gc_pmarkup = "L" AND gl_locts
            go_SQL.m_SQLSelect("a_icpric->item, a_icpgrp.pgroup, a_icpgrp.grpdesc, a_icpgrp.popt, " +;
            "a_icpgrp.psched, a_icpgrp.custno, a_icpgrp.pmeth, a_icpgrp.begqty1, a_icpgrp.endqty1, " + ;
            "a_icpgrp.factor1, a_icpgrp.unitpr1, a_icpgrp.begqty2, a_icpgrp.endqty2, " + ;
            "a_icpgrp.factor2, a_icpgrp.unitpr2, a_icpgrp.begqty3, a_icpgrp.endqty3, " + ;
            "a_icpgrp.factor3, a_icpgrp.unitpr3,a_icpgrp.begqty4, a_icpgrp.endqty4, " + ;
            "a_icpgrp.factor4, a_icpgrp.unitpr4,a_icpgrp.begqty5, a_icpgrp.endqty5, " + ;
            "a_icpgrp.factor5, a_icpgrp.unitpr5,a_icpgrp.begqty6, a_icpgrp.endqty6, " + ;
            "a_icpgrp.factor6, a_icpgrp.unitpr6,a_icpgrp.sdate, a_icpgrp.edate, " + ;
            "a_icpgrp.descrip, a_icpgrp.adduser,a_icpgrp.adddate, a_icpgrp.addtime, " + ;
            "a_icpgrp.lckstat, a_icpgrp.lckuser,a_icpgrp.lckdate, a_icpgrp.lcktime,a_icpgrp.currid, " + ;
            "'G' AS psource, " + ;
            "IIF(a_icpric->pmeth='C' OR a_icpric->pmeth='M', a_iciloc->loctid, SPACE(6)) AS loctid, a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric, " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp, " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc, " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem WHERE " + lc_filt2, "SQL TABLE", go_SQL.m_getTempTableName(1))
          ELSE
            go_SQL.m_SQLSelect("Distinct a_icpric->item, a_icpgrp.pgroup, a_icpgrp.grpdesc, a_icpgrp.popt, " +;
            "a_icpgrp.psched, a_icpgrp.custno, a_icpgrp.pmeth, a_icpgrp.begqty1, a_icpgrp.endqty1, " + ;
            "a_icpgrp.factor1, a_icpgrp.unitpr1, a_icpgrp.begqty2, a_icpgrp.endqty2, " + ;
            "a_icpgrp.factor2, a_icpgrp.unitpr2, a_icpgrp.begqty3, a_icpgrp.endqty3, " + ;
            "a_icpgrp.factor3, a_icpgrp.unitpr3,a_icpgrp.begqty4, a_icpgrp.endqty4, " + ;
            "a_icpgrp.factor4, a_icpgrp.unitpr4,a_icpgrp.begqty5, a_icpgrp.endqty5, " + ;
            "a_icpgrp.factor5, a_icpgrp.unitpr5,a_icpgrp.begqty6, a_icpgrp.endqty6, " + ;
            "a_icpgrp.factor6, a_icpgrp.unitpr6,a_icpgrp.sdate, a_icpgrp.edate, " + ;
            "a_icpgrp.descrip, a_icpgrp.adduser,a_icpgrp.adddate, a_icpgrp.addtime, " + ;
            "a_icpgrp.lckstat, a_icpgrp.lckuser,a_icpgrp.lckdate, a_icpgrp.lcktime,a_icpgrp.currid, " + ;
            " 'G' AS psource, SPACE(6) AS LOCTID, " + ;
            "a_icpric->currid AS prc_currid FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric, " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp, " + ;
            go_SQL.cmpA_iciloc.sc_tableNameFull + " a_iciloc, " + ;
            go_SQL.cmpA_icitem.sc_tableNameFull + " a_icitem WHERE " + lc_filt2, "SQL TABLE", go_SQL.m_getTempTableName(1))
          ENDIF
          go_SQL.so_CurrentAlias.m_closeTable()
          g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f., "", .f.)

          *-- Append and Index temporary table
          IF go_SQL.cmpA_tmpf3.m_count("") > 0
            go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(3), "")
          ENDIF

          go_SQL.cmpA_tmpf3.m_CloseTable()

          IF EMPTY(lc_psched) AND  go_SQL.cmpA_tmpf2.m_count("")> 0
            *-- Combine the two sets of data
            go_SQL.cmpA_tmpf1.m_AppendFrom(go_SQL.m_getTempTableName(2), "")

            go_SQL.cmpA_tmpf2.m_CloseTable()
            go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))

          ENDIF

          *-- Index temporary file
          go_SQL.cmpA_tmpf1.m_createIndex("tagitem", ;
              "item + pgroup + psched + pmeth + popt + custno + prc_currid + loctid ", ;
              "", .t., .f.)
          go_SQL.cmpA_tmpf1.m_SetRelation("pgroup", "a_icpgrp", .t.)
          go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .t.)

          *-- Call report file
          *# DOCCODE REPORT FORM icpri3
          lc_frx = gc_icprgdv + "icpri3"

      ENDCASE
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F10.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F11
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f11
      *-- Open Item Price file
      = g_opnfl(gf_icpricf, "a_icpric", .f., .f.)

      *-- Set filter condition
      lc_filt = "a_icpric->psource <> 'I' AND NOT EMPTY(a_icpric->pgroup) " + ;
                "AND a_icpgrp->pgroup = a_icpric->pgroup AND "

      DO CASE
        CASE EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_filt = lc_filt + " 1=1 "
        CASE NOT EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_filt = lc_filt + "a_icpric->pgroup >= TRIM(??lc_frpgrp) "
        CASE EMPTY(lc_frpgrp) AND NOT EMPTY(lc_topgrp)
          lc_filt = lc_filt + "a_icpric->pgroup <= TRIM(??lc_topgrp) + '" + CHR(255) + "' "
        CASE lc_frpgrp = lc_topgrp
          lc_filt = lc_filt + "a_icpric->pgroup %=% TRIM(??lc_frpgrp) + '%/%'"
        OTHERWISE
          lc_filt = lc_filt + "a_icpric->pgroup >= TRIM(??lc_frpgrp) " + ;
                    " AND a_icpric->pgroup <= TRIM(??lc_topgrp) + '" + CHR(255) + "' "
      ENDCASE

      *-- Open Price Group File
      = g_opnfl(gf_icpgrpf, "a_icpgrp", .f., .f.)
      go_SQL.cmpA_icpgrp.m_SetOrder("pgroup7")

      go_SQL.m_TableChangeCurrent("a_icitem")
      go_SQL.cmpA_Icitem.m_SetOrder("item")

      go_SQL.m_TableChangeCurrent("a_icpric")
      go_SQL.cmpA_icpric.m_SetRelation("pgroup", "a_icpgrp", .f.)

      *-- Select records based on filter condition
      go_SQL.m_SQLSelect("DISTINCT a_icpric->item, a_icpgrp->pgroup FROM " + ;
            go_SQL.cmpA_icpric.sc_tableNameFull + " a_icpric, " + ;
            go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp WHERE " + lc_filt, "SQL TABLE", ;
            go_SQL.m_getTempTableName(3))
      go_SQL.so_CurrentAlias.m_closeTable()

      g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f., "", .f.)
      *-- Set relation to item files
      go_SQL.cmpA_tmpf3.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.cmpA_tmpf3.m_SetRelation("pgroup", "a_icpgrp", .t.)

      *# DOCCODE REPORT FORM icpri4
      lc_frx = gc_icprgdv + "icpri4"
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F11.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_F12
*------------------------------------------------------------------------------
PROCEDURE l_icrept_f12
      *-- Open Customer File
      IF gl_ar OR gl_so
        = g_opnfl(gf_arcustf, "a_arcust", .f., .f., "custno")
      ENDIF

      *-- Open Price Group File
      ln_opnpgrp = g_opnfl(gf_icpgrpf, "a_icpgrp", .f., .f.)

      *-- Set filter condition
      DO CASE
        CASE EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_filt = " "
        CASE NOT EMPTY(lc_frpgrp) AND EMPTY(lc_topgrp)
          lc_filt = "a_icpgrp->pgroup >= ??TRIM(lc_frpgrp) "
        CASE EMPTY(lc_frpgrp) AND NOT EMPTY(lc_topgrp)
          lc_filt = "a_icpgrp->pgroup <= TRIM(??lc_topgrp) + '" + CHR(255) + "' "
        CASE lc_frpgrp = lc_topgrp
          lc_filt = "a_icpgrp->pgroup %=% TRIM(??lc_frpgrp) + '%/%'"
        OTHERWISE
          lc_filt = "a_icpgrp->pgroup >= ??TRIM(lc_frpgrp) AND " + ;
                    "a_icpgrp->pgroup <= TRIM(??lc_topgrp) + '" + CHR(255) + "' "
      ENDCASE

      IF NOT EMPTY(lc_filt)
        lc_filt = " WHERE " + lc_filt
      ENDIF
      go_SQL.m_SQLSelect("* FROM " + go_SQL.cmpA_icpgrp.sc_tableNameFull + " a_icpgrp " + lc_filt + ;
                         " ORDER BY a_icpgrp->pgroup, a_icpgrp->psched, a_icpgrp->custno, a_icpgrp->pmeth, a_icpgrp->popt", ;
                         "SQL TABLE", go_SQL.m_getTempTableName(3))
      go_SQL.so_CurrentAlias.m_CloseTable()
      g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f., "", .f.)

      IF gl_ar OR gl_so
        go_SQL.cmpA_tmpf3.m_SetRelation("custno", "a_arcust", .f.)
      ENDIF

      *# DOCCODE REPORT FORM icpri5
      lc_frx = gc_icprgdv + "icpri5"
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_F12.PRG
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_T09
*------------------------------------------------------------------------------
PROCEDURE l_icrept_t09
     *-- Cost Variances

    *-- Set transaction date condition
    IF NOT EMPTY(ld_fbdate)
        lc_filt = lc_filt + [DTOS(tdate)>='] + DTOS(ld_fbdate) + [' AND ]

    ENDIF

    IF NOT EMPTY(ld_fedate)
      lc_filt = lc_filt + [DTOS(tdate)<='] + DTOS(ld_fedate) + [' AND ]
    ENDIF

*\ [1 Line] PTR# 78641 06/16/05 TISJ Determine whether to use current, history or both files
    lc_file = g_curhis(ld_fbdate, ld_fedate, "ICTRAN", "tdate")

    *-- Set location condition

    IF LEFT(lc_file,1)$ 'CB'

      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_ictran->loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
         lc_filt = lc_filt + [a_ictran->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF
    ENDIF

    IF LEFT(lc_file,1)$ 'H'
      IF NOT EMPTY(lc_bloc)
        lc_filt = lc_filt + [a_icytrn->loctid >= ??TRIM(lc_bloc) AND ]
      ENDIF

      IF NOT EMPTY(lc_eloc)
        lc_filt = lc_filt + [a_icytrn->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
      ENDIF
    ENDIF

    *-- Set type condition
    IF lc_type <> "All"
        lc_filt = lc_filt + [a_icitem->type= ??LEFT(lc_type,1) AND ]
    ENDIF

    *-- Set class condition
    IF NOT EMPTY(lc_bclass)
        lc_filt = lc_filt + [a_icitem->itmclss >= ??TRIM(lc_bclass) AND ]
    ENDIF

    IF NOT EMPTY(lc_eclass)
        lc_filt = lc_filt + [a_icitem->itmclss <= TRIM(??lc_eclass) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set commodity code condition
    IF NOT EMPTY(lc_bccode)
      lc_filt = lc_filt + [a_icitem->comcode >= ??TRIM(lc_bccode) AND ]
    ENDIF

    IF NOT EMPTY(lc_eccode)
      lc_filt = lc_filt + [a_icitem->comcode <= TRIM(??lc_eccode) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set misc code condition
    IF NOT EMPTY(lc_bmcode)
      lc_filt = lc_filt + [a_icitem->code>= ??TRIM(lc_bmcode) AND ]
    ENDIF

    IF NOT EMPTY(lc_emcode)
      lc_filt = lc_filt + [a_icitem->code <= TRIM(??lc_emcode) + '] + CHR(255) + [' AND ]
    ENDIF

    *-- Set item condition
    IF NOT EMPTY(lc_bitem)
      lc_filt = lc_filt + [a_icitem->item >= ??TRIM(lc_bitem) AND ]
    ENDIF

    IF NOT EMPTY(lc_eitem)
      lc_filt = lc_filt + [a_icitem->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
    ENDIF
    *-- Exclude line item tax records
    lc_filt = lc_filt + [a_icitem->item<>'_LNTAX' AND ]

    *-- Set other conditions
    lc_filt = lc_filt + [applid $ 'PO|IC' ]

    *-- Open Inventory Master file
    ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

    *-- Setup variable for status display
    ln_reccnt = 0

    IF LEFT(lc_file,1) $ "CB"
        *-- Open Inventory Transaction Detail file
        ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "tdate1")
        ln_reccnt = go_SQL.cmpA_ictran.m_Reccount()

    ENDIF

    IF LEFT(lc_file,1) $ "HB"
        *-- Retrieve records from history file
        ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "tdate1")
        ln_reccnt = ln_reccnt + go_SQL.cmpA_icytrn.m_Reccount()

    ENDIF

    IF LEFT(lc_file,1) <> "H"

        *-- Divide filter into acceptable sizes
        DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

        go_SQL.m_TableChangeCurrent("a_ictran")

        *-- Check for mutilple location
        IF gl_locts
          *-- Store tag order of location file
          lc_order = go_SQL.cmpA_Iciloc.m_GetOrder()
          go_SQL.cmpA_Iciloc.m_SetOrder("loctid1")
          *-- Set relation to item and location file
          go_SQL.cmpA_ictran.m_SetRelation("item", "a_icitem", .f.)
          go_SQL.cmpA_ictran.m_SetRelation("loctid + item", "a_iciloc", .t.)
        ELSE
          go_SQL.cmpA_ictran.m_SetRelation("item", "a_icitem", .f.)
        ENDIF

        *-- Added new fields trcost, tftcost
        lc_relate = " left join  " + go_sql.cmpA_Icitem.sc_TableNameFull + ;
                    " a_icitem on a_icitem.item = a_ictran.item "

        IF gl_locts
          lc_relate = lc_relate + " left join " + go_sql.cmpA_Iciloc.sc_tableNameFull + ;
                      " a_iciloc on a_iciloc.item = a_ictran.item AND" + ;
                      " a_iciloc.loctid = a_ictran.loctid "
        ENDIF

        go_SQL.m_SQLSelect("a_ictran.tdate, a_ictran.ttranno, a_ictran.trantyp, a_ictran.orgno, " +;
          "a_ictran.docno, a_ictran->item, a_ictran.udref, a_ictran.loctid, a_ictran.lotno, a_ictran.serial, " +;
          "a_ictran.sqty, a_ictran.tcost, a_ictran.applid, a_icitem->itmclss, a_ictran.trcost, a_ictran.tftcost FROM " +;
          go_sql.cmpA_ictran.sc_tableNameFull + " a_ictran " + lc_relate + " WHERE " +  ;
          lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(1))
        go_SQL.so_CurrentAlias.m_CloseTable()

        go_SQL.m_TableChangeCurrent("a_ictran")

        *-- Check for mutilple location
        IF gl_locts

          IF NOT EMPTY(lc_order)
            *-- Restore tag order for location file
            go_SQL.cmpA_Iciloc.m_SetOrder(lc_order)
          ENDIF

          *-- Set relation off from location file
          go_SQL.cmpA_ictran.m_SetRelation("OFF", "a_iciloc", .f.)
        ENDIF

        go_SQL.cmpA_ictran.m_SetRelation("OFF", "a_icitem", .f.)
    ENDIF

    IF LEFT(lc_file,1) <> "C"
        *-- Get records from history

        IF LEFT(lc_file,1) = 'B'
            lc_filt = STRTRAN(lc_filt, "a_ictran->loctid", "a_icytrn->loctid")
        ENDIF

        *-- Divide filter into acceptable sizes
        DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

        go_SQL.m_TableChangeCurrent("a_icytrn")

        *-- Check for mutilple location
        IF gl_locts
          *-- Store tag order of location file
          lc_order = go_SQL.cmpA_Iciloc.m_GetOrder()
          go_SQL.cmpA_Iciloc.m_SetOrder("loctid1")
          *-- Set relation to item and location file
          go_SQL.cmpA_icytrn.m_SetRelation("item", "a_icitem", .f.)
          go_SQL.cmpA_icytrn.m_SetRelation("loctid + item", "a_iciloc", .t.)
        ELSE
          go_SQL.cmpA_icytrn.m_SetRelation("item", "a_icitem", .f.)
        ENDIF

        *-- Added new fields trcost, tftcost
        lc_relate = " left join " + go_sql.cmpA_Icitem.sc_tableNameFull + ;
                    " a_icitem on a_icitem.item = a_icytrn.item "

        IF gl_locts
          lc_relate = lc_relate + " left join " + go_sql.cmpA_Iciloc.sc_tableNameFull + ;
                      " a_iciloc on a_iciloc.item = a_icytrn.item AND" + ;
                      " a_iciloc.loctid = a_icytrn.loctid "
        ENDIF


        go_SQL.m_SQLSelect("a_icytrn.tdate, a_icytrn.ttranno, a_icytrn.trantyp, a_icytrn.orgno, " + ;
          "a_icytrn.docno, a_icytrn->item, a_icytrn.udref, a_icytrn.loctid, a_icytrn.lotno, a_icytrn.serial, " + ;
          "a_icytrn.sqty, a_icytrn.tcost, a_icytrn.applid, a_icitem->itmclss, a_icytrn.trcost, a_icytrn.tftcost FROM " +;
          go_sql.cmpA_icytrn.sc_tableNameFull + " a_icytrn " + lc_relate + " WHERE " +  ;
          lc_filt1+lc_filt2+lc_filt3+lc_filt4, "SQL TABLE", go_SQL.m_getTempTableName(2))
        go_SQL.so_CurrentAlias.m_CloseTable()

        go_SQL.m_TableChangeCurrent("a_icytrn")

        *-- Check for mutilple location
        IF gl_locts

          IF NOT EMPTY(lc_order)
            *-- Restore tag order for location file
            go_SQL.cmpA_Iciloc.m_SetOrder(lc_order)
          ENDIF

          *-- Set relation off from location file
          go_SQL.cmpA_icytrn.m_SetRelation("OFF", "a_iciloc", .f.)
        ENDIF

        go_SQL.cmpA_icytrn.m_SetRelation("OFF", "a_icitem", .f.)
    ENDIF

    *-- If not retrieving from history file
    IF LEFT(lc_file,1) <> "H"
        ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

        IF go_SQL.m_isTableFound(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_SQLAppendFrom(go_SQL.m_getTempTableName(2), "")
          go_SQL.m_dropTable(go_SQL.m_getTempTableName(2))
          go_SQL.cmpA_tmpf1.m_MoveRecord(Cn_TopRec)
        ENDIF

    ELSE
        *-- If retrieving records from history file, open temp file
       ln_opntemp = g_opnfl(go_SQL.m_getTempTableName(2), "a_tmpf2", .t., .f.)
    ENDIF


    IF gl_locts
        *-- Index temporary file
        go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "loctid + item + DTOS(tdate) + docno + STR(tcost, 15, 5)", "", .t., .f.)

        *-- Report single line per document for like items with same cost
        go_SQL.so_CurrentAlias.m_total("loctid + item + DTOS(tdate) + docno + STR(tcost, 15, 5)", ;
               "sqty", go_SQL.m_getTempTableName(3), "", "S")
    ELSE
        *-- Index temporary file
        go_SQL.so_CurrentAlias.m_createIndex(IIF(LEFT(lc_file,1)<>"H","tag1","tag2"), ;
                  "item + DTOS(tdate) + docno + STR(tcost, 15, 5)", "", .t., .f.)

        *-- Report single line per document for like items with same cost
        go_SQL.so_CurrentAlias.m_total("item + DTOS(tdate) + docno + STR(tcost, 15, 5)", ;
               "sqty", go_SQL.m_getTempTableName(3), "", "S")
    ENDIF

    *-- Open temporary totals file
    = g_opnfl(go_SQL.m_getTempTableName(3), "a_tmpf3", .t., .f.)

    *-- Set relation to Item file
    go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)

    *-- Delete records with zero variance
    IF gl_locts
      *-- Store tag order of location file
      lc_order = go_SQL.cmpA_Iciloc.m_GetOrder()
      go_SQL.cmpA_Iciloc.m_SetOrder("loctid1")
      *-- Set relation to item and location file
      go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
      go_SQL.so_CurrentAlias.m_SetRelation("loctid + item", "a_iciloc", .t.)
    ELSE
      go_SQL.so_CurrentAlias.m_SetRelation("item", "a_icitem", .f.)
    ENDIF

      *-- Use standard cost from location file for multiple locations
    go_SQL.cmpA_tmpf3.m_deletebulk("F", "a_tmpf3->sqty = 0.0000 OR (a_tmpf3->tcost - " + ;
                        IIF(gl_locts, "a_iciloc->lstdcst ", "a_icitem->stdcost ") + ;
                        ") = 0", .t.)

      *-- Set scope
      lc_cond = SPACE(0)

      *-- Set report title
      lc_title = "Cost Variances Report"

      *-- Set report form file
      IF gl_locts
        *# DOCCODE REPORT FORM icvarl
        lc_frx = gc_icprgdv + "icvarl"
      ELSE
        *# DOCCODE REPORT FORM icvart
        lc_frx = gc_icprgdv + "icvart"
      ENDIF
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_t09.PRG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_S15
*------------------------------------------------------------------------------
*- Description: Reports 1/2/3/4/5/6/7/8/9/V
*------------------------------------------------------------------------------
*- Synopsis...: (1) Inventory Summary   (F1)  Inventory Master
*-              (2) Inventory On Hand   (F2)  Inventory By Location
*-              (3) Inventory Transfers (F3)  Distribution By Value
*-              (6) Recommended Reorder (F5)  Suppliers File
*-              (7) Physical Inventory  (F6)  Lot File
*-                                      (F7)  Location File
*-                                      (F8)  Product Line File
*-                                      (F9)  Units of Measure File
*------------------------------------------------------------------------------
*- Calls......: SYVALR
*------------------------------------------------------------------------------
*- Passed:
*- Variables: LEFT(lc_file,1)      = "C" for current period file
*-                           "H" for history file
*-                           "B" for both files
*-            TRIM(lc_type)      = type of report (B, D, and F3):
*-                           "A" for all items
*-                           "S" for stock items only
*-                           "N" for nonstock items only
*-                           type of report (C only):
*-                           "Y" for all transfers
*-                           "I" for inventory issues only
*-                           "R" for inventory receipts only
*-                           "C" for inventory cost changes only
*-                           "P" for physical inventory only
*-                           "A" for cost adjustment entries only
*-                         type of report (F1, F2)
*-                           "A" = Asset
*-                           "E" = Expense
*-                           "I" = Inventory
*-                           "S" = Service
*-            ln_days      = number of days before/since last sale
*-            LEFT(lc_range,1)     = " " for All Sales
*-                         "B" for Sales before number of days
*-                         "S" for Sales since number of days
*-            LEFT(lc_incld,1)     = "A" for All
*-                         "B" for below reorder point
*-            lc_bdate     = beginning date
*-            lc_edate     = ending date
*-            LEFT(lc_order,1)     = "I" to order report by item (D,F,F1,F3)
*-                         "D" to order report by description (D,F,F1.F3)
*-                         "1" to show 1st price (E)
*-                         "2" to show 2nd price (E)
*-                         "3" to show 3rd price (E)
*-            mcustno    = customer number or portion to match
*-            lc_bitem     = beginning item
*-            lc_eitem     = ending item
*-            lc_bvprtno  = beginning vendor P/N
*-            lc_evprtno  = ending vendor P/N
*-            lc_bclass    = beginning inventory class
*-            lc_eclass    = ending inventory class
*-            mcode      = customer/inventory code or portion to match
*-            lc_dbvtype = "C" = Customer
*-                         "I" = Inventory
*-                         "V" = Vendor
*-            ln_minamt  = activity below this amount is excluded
*-            lc_0accnt  = lower account range limit
*-            lc_9accnt  = upper account range limit
*-
*- Parameters.: None
*------------------------------------------------------------------------------
PROCEDURE l_icrept_s15

  PRIVATE lc_docno,;
          lc_qtranno

  *-- Serial/Lot Stock Status
  *-- Set include overshipments only
  IF LEFT(lc_incld,1) = "O"
    lc_filt = lc_filt + [a_iciqty->qonhand < 0 AND ]
  ENDIF

  *-- Set location condition
  IF NOT EMPTY(lc_bloc)
    lc_filt = lc_filt + [a_iciqty->loctid >= ??TRIM(lc_bloc) AND ]
  ENDIF

  IF NOT EMPTY(lc_eloc)
    lc_filt = lc_filt + [a_iciqty->loctid <= TRIM(??lc_eloc) + '] + CHR(255) + [' AND ]
  ENDIF

  *-- Set lot condition
  IF NOT EMPTY(lc_blot)
    lc_filt = lc_filt + [a_iciqty->lotno >= ??TRIM(lc_blot) AND ]
  ENDIF

  IF NOT EMPTY(lc_elot)
    lc_filt = lc_filt + [a_iciqty->lotno <= TRIM(??lc_elot) + '] + CHR(255) + [' AND ]
  ENDIF

  *-- Set serial number condition
  IF NOT EMPTY(lc_bserial)
    lc_filt = lc_filt + [a_iciqty->qserial >= ??TRIM(lc_bserial) AND ]
  ENDIF

  IF NOT EMPTY(lc_eserial)
    lc_filt = lc_filt + [a_iciqty->qserial <= TRIM(??lc_eserial) + '] + CHR(255) + [' AND ]
  ENDIF

  *-- Set item condition
  IF NOT EMPTY(lc_bitem)
    lc_filt = lc_filt + [a_iciqty->item >= ??TRIM(lc_bitem) AND ]
  ENDIF

  IF NOT EMPTY(lc_eitem)
    lc_filt = lc_filt + [a_iciqty->item <= TRIM(??lc_eitem) + '] + CHR(255) + [' AND ]
  ENDIF

  *-- Set other conditions - item must use lots or serial numbers
  lc_filt = lc_filt + [(a_icitem->useserl $ 'OS' OR ] + ;
                      [a_icitem->uselots $ 'OS') ]

  *-- Open Inventory Master file
  ln_opnitem = g_opnfl(gf_icitemf, "a_icitem", .f., .f., "item")

  *-- Open Inventory Transaction Detail file
  ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f.)
  go_SQL.cmpA_Ictran.m_SetOrder("ttranno")

  *-- Open History Inventory Transaction Detail file
  ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f.)

  lc_docno = SPACE(LEN(docno))

  go_SQL.cmpA_Icytrn.m_SetOrder("ttranno")

  *-- Open Quantities at Location file
  ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f., SPACE(0))

  lc_qtranno = SPACE(LEN(qtranno))

  *-- Source transaction info may be in current or history file
  *-- Try history file in first pass
  go_SQL.cmpA_iciqty.m_SetRelation("item", "a_icitem", .f.)
  go_SQL.cmpA_iciqty.m_SetRelation("qtranno", "a_icytrn", .t.)

  DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

  go_SQL.so_CurrentAlias.m_CopyTo(go_SQL.m_getTempTableName(1), ;
                                  "FIELDS a_iciqty->item, " + ;
                                  "a_iciqty->qserial, " + ;
                                  "a_iciqty->loctid, " + ;
                                  "a_iciqty->lotno, " + ;
                                  "a_iciqty->qstore, " + ;
                                  "a_iciqty->qbin, " + ;
                                  "a_iciqty->qtmaloc, " + ;
                                  "a_iciqty->qsoaloc, " + ;
                                  "a_iciqty->qwoaloc, " +;
                                  "a_iciqty->qonhand, " + ;
                                  "a_icytrn->orgno, " + ;
                                  "a_icytrn->tdate, " + ;
                                  "a_icytrn->docno, " + ;
                                  "a_iciqty->qtranno, " + ;
                                  "a_icytrn->applid FOR " + ;
                                  lc_filt1+lc_filt2+lc_filt3+lc_filt4, ;
                                  "")

  go_SQL.so_currentAlias.m_closeTable()


  *-- Open temporary file and update empty fields from current tran file
  = g_opnfl(go_SQL.m_getTempTableName(1), "a_tmpf1", .t., .f.)

  go_SQL.so_CurrentAlias.m_ReplaceBulk("docno WITH '" + "'",;
                                 "F", ;
                                 "ISNULL(docno) ", + ;
                                 .t.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("qtranno WITH '" + "'",;
                                 "F", ;
                                 "ISNULL(qtranno) ", + ;
                                 .t.)

  go_SQL.cmpA_tmpf1.m_SetRelation("qtranno", "a_ictran", .f.)
  go_SQL.cmpA_tmpf1.m_SetRelation("item", "a_icitem", .t.)

  go_SQL.cmpA_tmpf1.m_ReplaceBulk("orgno WITH a_ictran->orgno, tdate  WITH a_ictran->tdate, " + ;
                                 "docno WITH a_ictran->docno, applid WITH a_ictran->applid", ;
                                 "F", ;
                                 "(a_tmpf1->docno = '" + lc_docno + "' OR ISNULL(a_tmpf1->docno) )" + ;
                                 "AND (a_tmpf1->qtranno <> '" + lc_qtranno + "' OR NOT ISNULL(a_tmpf1->qtranno) )", ;
                                 .t.)

  DO CASE
    CASE LEFT(lc_order,1) = "I"
      go_SQL.cmpA_tmpf1.m_createIndex("tagitem","item + lotno + qserial", "", .t., .f.)

    CASE LEFT(lc_order,1) = "L"
      go_SQL.cmpA_tmpf1.m_createIndex("tagloctid","loctid + item + lotno + qserial", "", .t., .f.)
  ENDCASE

  *-- Set report title
  lc_title = "Serial/Lot Stock Status Report"

  *-- Set report form name
  *# DOCCODE REPORT FORM icskst
  lc_frx = gc_icprgdv + "icskst"
RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_s15.PRG
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Function..: l_AsOfUpdate
*------------------------------------------------------------------------------
*- Synopsis...: Detail report for all costing method
*------------------------------------------------------------------------------
*- Called by..:
*------------------------------------------------------------------------------
PROCEDURE l_AsOfUpdate

   IF go_SQL.sc_SqlTypeMain = "F" OR go_SQL.sc_SQLType = "SD"

      go_SQL.cmpA_tmpf1.m_ReplaceBulk("ohvitem WITH " + ;
                 "g_clcohv('VALUE', .t.) , icacct WITH i_getact('IC', a_tmpf1->item, a_tmpf1->loctid)" , ;
                 "A", "")
    ELSE
    	*\[BEGIN] PTR# 71515/71516 SSUB 08/26/03 Branched code for IC application not linked to GL
    	IF &gc_glob.gl_gllink
    	*\[1 Line] PTR# 73821 SSHA 03/18/04 Error account number in inventory on hand report
    		lc_acctexprn = ;
    		    "IIF(EMPTY(a_tmpf1->icacct) = .t. , " + ; 
      		              "dbo.getact_icproc(" + ;
                                        "a_icitem->resell, " + ;
                                        "a_icloct->icactm, " + ;
                                        "a_icloct->icactf, " + ;
                                        "'" + TRANSFORM(REPLICATE("0", LEN(&gc_glob.gc_acctpic)), &gc_glob.gc_acctpic) + "', " + ;
                                        "'" + TRANSFORM(SPACE(LEN(&gc_glob.gc_acctpic)), &gc_glob.gc_acctpic) + "', " + ;
                                        IIF(&gc_glob.gl_locts,"1,","0,") + ;
                                        "'" + &gc_glob.gc_icactf + "', " + ;
                                        "'" + &gc_glob.gc_icactm + "', " + ;
                                        IIF(&gc_glob.gl_gllink, "1","0") + ;
                		                "), " + ;
      		              " a_tmpf1->icacct)"
    	ELSE
    		lc_acctexprn = "'" + TRANSFORM(SPACE(LEN(&gc_glob.gc_acctpic)), &gc_glob.gc_acctpic) + "'"
    	ENDIF
  		*\[END] PTR# 71515/71516 SSUB 08/26/03

       go_SQL.cmpA_tmpf1.m_ReplaceBulk("ohvitem WITH " + ;
             "dbo.g_clcohv('VALUE', 1,a_icitem->ionhand, a_icitem->type,a_icitem->stkcode," + ;
                "a_icitem->stdcost,a_icitem->avgcost,a_iciloc->item,a_iciloc->loctid, " + ;
                "a_iciloc->lonhand,a_iciloc->lstdcst,a_iciloc->lavgcst, " + STR(&gc_glob.gn_deccst) + ", '" + ;
                &gc_glob.gc_cstmeth + "'," + IIF(&gc_glob.gl_locts, "1", "0") + "), " + ;
           "icacct WITH " + ;
            lc_acctexprn ,"A","",.t.)
    ENDIF
RETURN
*------------------------------------------------------------------------------
*- End Procedure...: l_AsOfUpdate
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: l_getfrx
*------------------------------------------------------------------------------
*- Synopsis...: Return the appropriate report file name to be used for
*-              previewing/printing
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: la_custom  - Array in which report form names
*-                           are stored
*-              lc_cusrept - Default report name/User chosen report
*-
*- Parameters.: None
*------------------------------------------------------------------------------
FUNCTION l_getfrx

  LOCAL lc_Frxfile, ;
        lc_Tmpname, ;
        ln_Row

  *-- Strip off the 'Standard' label
  lc_Tmpname = UPPER(ALLTRIM(STRTRAN(lc_Cusrept, "(Standard)", "", 1, -1, 1)))

  *-- If the grid option does not have any selection combo,
  *-- return the name of the standard/stock report.
  *-- Holds good for Cycle Count Worksheet/Physical inventory sheets
  IF ll_NoSelrpt

    *-- Check for the user's choice
    IF lc_Tmpname == UPPER(JUSTSTEM(lc_frx))
      *-- Standard/Stock
      lc_Frxfile = lc_frx
    ELSE
      *-- Custom
      ln_Row = ASCAN(la_custom, lc_Cusrept, -1, -1, -1, 14)
      lc_Frxfile = ALLTRIM(la_custom[ln_Row, 2]) + ALLTRIM(lc_Cusrept)
    ENDIF

  ELSE
    *-- Standard/Stock
    lc_Frxfile = lc_frx
  ENDIF && NOT ll_NoSelrpt

RETURN lc_Frxfile
*------------------------------------------------------------------------------
*- End Procedure...: l_getfrx
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------
*- Procedure..: L_VITEM
*------------------------------------------------------------------------------
*- Description: Validate report options
*------------------------------------------------------------------------------
*- Synopsis...: wrapper for l_valitm, returns logical value
*------------------------------------------------------------------------------
*- Calls......: l_Valitm
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: option variables
*- Parameters.: None
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: .t. if valid
*------------------------------------------------------------------------------
PROCEDURE l_vitem

  LOCAL lx_return, ;
        ll_return

  ll_return = .f.
  lx_return = l_Valitm()
  
  IF TYPE("lx_return") = "L" AND lx_return
    ll_return = .t.
  ENDIF

RETURN ll_return
*------------------------------------------------------------------------------
*- End Procedure...: l_valitm
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
*- Procedure..: L_ICREPT_T10
*------------------------------------------------------------------------------
PROCEDURE l_icrept_t10
   
  *-- Serial Number History

  LOCAL ll_First, ;
        ln_SrlNone, ;
        lc_OrderTrn, ;
        lc_OrderYtrn, ;
        lc_OrderQty, ;
        lc_idx1, ;
        lc_idx3, ;
        ln_Qty, ;
        lc_Cond1

  lc_tranno = SPACE(10)
  lc_serial = SPACE(20)

  *-- Set serial number condition
  IF NOT EMPTY(lc_bserial)
    lc_filt = lc_filt + [serial >= ??TRIM(lc_bserial) AND ]
  ENDIF

  IF NOT EMPTY(lc_eserial)
    lc_filt = lc_filt + [serial <= TRIM(??lc_eserial) + '] + CHR(255) + [' AND ]
  ENDIF

  *-- Set item condition
  IF NOT EMPTY(lc_bitem)
    lc_filt = lc_filt + [TRIM(item) == ??TRIM(lc_bitem) AND ]
  ENDIF

  *-- Set other conditions
  lc_filt = lc_filt + [ 1=1 ]

  *-- Open Quantities at Location file
  ln_opniqty = g_opnfl(gf_iciqtyf, "a_iciqty", .f., .f., "item3")

  *-- Open Inventory Transaction Detail file
  ln_opntran = g_opnfl(gf_ictranf, "a_ictran", .f., .f., "item3")

  *-- Open History transaction file
  ln_opnytrn = g_opnfl(gf_icytrnf, "a_icytrn", .f., .f., "item3")

  *-- Open History Serial number file
  ln_opnysno = g_opnfl(gf_icysnof, "a_icysno", .f., .f., "item1")

  *-- Divide filter into acceptable sizes
  DO g_brkstr WITH lc_filt, lc_filt1, lc_filt2, lc_filt3, lc_filt4

  *-- Performance Optimization. Use SQL Select instead of the
  *-- scan loop
  go_SQL.m_SQLSelect("a_ictran->ttranno, a_ictran->vpartno, a_ictran->serial, " + ;
                     "a_ictran->loctid, a_ictran->lotno, a_ictran->trantyp, " + ;
                     "a_ictran->tdate, a_ictran->sqty, a_ictran->tcost, " + ;
                     "a_ictran->applid, a_ictran->orgno, a_ictran->docno, " + ;
                     "a_ictran->price, a_ictran->trcost, a_ictran->tftcost " + ;
                     " FROM " + go_SQL.cmpa_Ictran.sc_TableNameFull + ;
                     " a_ictran WHERE " + lc_Filt1 + lc_Filt2 + ;
                     lc_Filt3 + lc_Filt4 + ;
                     " UNION " + ;
                     "SELECT a_icytrn->ttranno, a_icytrn->vpartno, a_icytrn->serial, " + ;
                     "a_icytrn->loctid, a_icytrn->lotno, a_icytrn->trantyp, " + ;
                     "a_icytrn->tdate, a_icytrn->sqty, a_icytrn->tcost, " + ;
                     "a_icytrn->applid, a_icytrn->orgno, a_icytrn->docno, " + ;
                     "a_icytrn->price, a_icytrn->trcost, a_icytrn->tftcost " + ;
                     "FROM " + go_SQL.cmpa_Icytrn.sc_TableNameFull + ;
                     " a_icytrn WHERE " + lc_Filt1 + lc_Filt2 + ;
                     lc_Filt3 + lc_Filt4, ;
                     "SQL TABLE", go_SQL.m_GetTempTableName(1))

  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- Open temporary distributions file
  = g_opnfl(go_SQL.m_getTempTableName(1), ;
    "a_tmpf1", .t., .f., Cc_NullStr, .f.)

  *-- Filter condition for item and Serial number range in Transaction file
  go_SQL.m_TableChangeCurrent("a_ictran")
  go_SQL.cmpA_ictran.m_SetFilter(lc_filt1 + lc_filt2 + lc_filt3 + lc_filt4)
  go_SQL.cmpA_ictran.m_MoveRecord(Cn_TopRec)

  *-- The scan is combained and implemented as SELECT ...UNION SELECT to fetch
  *-- records by using a single query this scan can be removed

  ln_SrlNone = 0
  ll_First = .t.
  lc_OrderTrn  = go_SQL.cmpA_ictran.m_GetOrder()
  lc_OrderQty  = go_SQL.cmpA_iciqty.m_GetOrder()
  lc_OrderYtrn = go_SQL.cmpA_icytrn.m_GetOrder()

  go_SQL.cmpA_ictran.m_SetOrder("ttranno")
  go_SQL.cmpA_icytrn.m_SetOrder("ttranno")

  go_SQL.m_TableChangeCurrent("a_iciqty")
  lc_idx1 = IIF(go_SQL.sc_SQLTypeMain = "F", gc_idrvtmp + "idx1" + gc_extndx, "idx1")
  lc_idx3 = IIF(go_SQL.sc_SQLTypeMain = "F", gc_idrvtmp + "idx3" + gc_extndx, "idx3")

  go_SQL.cmpA_iciqty.m_CreateIndex(lc_idx1, "item + otranno", , .t., .t.)
  go_SQL.cmpA_tmpf1.m_CreateIndex(lc_idx3, "ttranno", , .t., .t.)

  lc_cond1 =  "item = TRIM(??lc_bitem) AND (qserial > RTRIM(??lc_bserial) OR qserial %=% " + ;
                  " RTRIM(??lc_bserial) + '%/%') AND (qserial < RTRIM(??lc_eserial) OR qserial %=% " + ;
                  " RTRIM(??lc_eserial) + '%/%')"
  go_SQL.cmpA_iciqty.m_ScanBegin("F", lc_cond1)
  DO WHILE go_SQL.cmpA_iciqty.m_Scan()

    IF ll_First
      lc_tranno = otranno
      ll_First = .f.
    ENDIF

    IF lc_tranno <> otranno
      *-- Update the record in temporary file according to the data available
      *-- in iciqty.  If serial numbers are generated after receiving inventory
      *-- do not display the record from ictran
      go_SQL.cmpA_tmpf1.m_Seek(lc_tranno, "")
      IF ln_SrlNone > 0
        *-- Update record to display number of items with no serial number
        go_SQL.cmpA_tmpf1.m_Replace("sqty", ln_SrlNone)
      ELSE
        *-- Delete record from temporary file if all serial numbers are generated
        IF EMPTY(a_tmpf1->serial)
          go_SQL.cmpA_tmpf1.m_Delete()
        ENDIF

      ENDIF

      lc_tranno = otranno
      ln_SrlNone = 0
    ENDIF

    lc_serial = qserial

    *-- Count number of records without serial number in iciqty
    IF EMPTY(lc_serial)
      ln_SrlNone = ln_SrlNone + 1
      LOOP
    ENDIF

    go_SQL.m_TableChangeCurrent("a_ictran")
    go_SQL.cmpA_ictran.m_Seek(lc_tranno, "")

    IF go_SQL.cmpA_ictran.m_IsFound()

      IF EMPTY(serial)
        *-- Added new fields trcost, tftcost
        *-- Insert into temporary file if blank serial number
        *-- Display the qty column as 1
        IF a_iciqty->qonhand = 0
          ln_Qty = 1
        ELSE
          ln_Qty = a_iciqty->qonhand
        ENDIF

        go_SQL.cmpA_Tmpf1.m_SQLInsert("ttranno, vpartno, serial, loctid, lotno, trantyp, tdate, " +;
        "sqty, tcost, applid, orgno, docno, price, trcost, tftcost", ;
        "a_ictran->ttranno, a_ictran->vpartno, '" + lc_serial + "', a_ictran->loctid, a_ictran->lotno, a_ictran->trantyp, a_ictran->tdate, " + ;
        STR(ln_Qty) + ", a_ictran->tcost, a_ictran->applid, a_ictran->orgno, a_ictran->docno, a_ictran->price, " + ;
        "a_ictran->trcost, a_ictran->tftcost", "")
      ENDIF

    ELSE
      go_SQL.m_TableChangeCurrent("a_icytrn")
      go_SQL.cmpA_icytrn.m_Seek(lc_tranno, "")

      IF go_SQL.cmpA_icytrn.m_IsFound()

        IF EMPTY(serial)
          *-- Added new fields trcost, tftcost
          *-- Insert into temporary file if blank serial number
          *-- Display the qty as 1 for issued items
          IF a_iciqty->qonhand = 0
            ln_Qty = 1
          ELSE
            ln_Qty = a_iciqty->qonhand
          ENDIF

          go_SQL.cmpA_Tmpf1.m_SQLInsert("ttranno, vpartno, serial, loctid, lotno, trantyp, tdate, " + ;
          "sqty, tcost, applid, orgno, docno, price, trcost, tftcost", ;
          "a_icytrn->ttranno, a_icytrn->vpartno, '" + lc_serial + "', a_icytrn->loctid, a_icytrn->lotno, a_icytrn->trantyp, a_icytrn->tdate, " + ;
          STR(ln_Qty) + ", a_icytrn->tcost, a_icytrn->applid, a_icytrn->orgno, a_icytrn->docno, a_icytrn->price, " + ;
          "a_icytrn->trcost, a_icytrn->tftcost", "")
        ENDIF

      ENDIF

    ENDIF

  ENDDO
  go_SQL.cmpA_iciqty.m_ScanEnd()

  go_SQL.cmpA_iciqty.m_SetIndex()
  go_SQL.cmpA_tmpf1.m_Seek(lc_tranno, "")
  IF ln_SrlNone > 0
    *-- Update record to display number of items with no serial number
    go_SQL.cmpA_tmpf1.m_Replace("sqty", ln_SrlNone)
  ELSE
    *-- Delete record from temporary file if all serial numbers are generated
    IF EMPTY(a_tmpf1->serial)
      go_SQL.cmpA_tmpf1.m_Delete()
    ENDIF
      
  ENDIF

  *-- Reset index in alias iciqty
  go_SQL.cmpA_iciqty.m_DropIndex(lc_idx1, .t., .t.)
  go_SQL.cmpA_iciqty.m_SetOrder(lc_OrderQty)

  go_SQL.m_TableChangeCurrent("a_icysno")

  lc_cond1 =  "item = TRIM(??lc_bitem) AND (qserial > RTRIM(??lc_bserial) OR qserial %=% " + ;
                  " RTRIM(??lc_bserial) + '%/%') AND (qserial < RTRIM(??lc_eserial) OR qserial %=% " + ;
                  " RTRIM(??lc_eserial) + '%/%')"
  go_SQL.cmpA_icysno.m_ScanBegin("F", lc_Cond1)

  DO WHILE go_SQL.cmpA_icysno.m_Scan()

    lc_tranno = otranno
    lc_serial = qserial

    go_SQL.m_TableChangeCurrent("a_ictran")
    go_SQL.cmpA_ictran.m_Seek(lc_tranno, "")

    IF go_SQL.cmpA_ictran.m_IsFound()

      IF EMPTY(serial)
        *-- Added new fields trcost, tftcost
        *-- Insert into temporary file if blank serial number
        *-- Display the qty column as 1
        IF a_icysno->qonhand = 0
          ln_Qty = 1
        ELSE
          ln_Qty = a_icysno->qonhand
        ENDIF

        go_SQL.cmpA_Tmpf1.m_SQLInsert("ttranno, vpartno, serial, loctid, lotno, trantyp, tdate, sqty, tcost, " + ;
          "applid, orgno, docno, price, trcost, tftcost", ;
          "a_ictran->ttranno, '" + lc_serial + "', a_ictran->loctid, a_ictran->lotno, a_ictran->trantyp, " + ;
          "a_ictran->tdate, " + STR(ln_Qty) + ", a_ictran->tcost, a_ictran->applid, a_ictran->orgno, a_ictran->docno, " + ;
          "a_ictran->price, a_ictran->trcost, a_ictran->tftcost", "")
      ENDIF

    ELSE
      go_SQL.m_TableChangeCurrent("a_icytrn")
      go_SQL.cmpA_icytrn.m_Seek(lc_tranno, "")

      IF go_SQL.cmpA_icytrn.m_IsFound()

        IF EMPTY(serial)
          *-- Added new fields trcost, tftcost
          *-- Insert into temporary file
          *-- Display the qty column as 1
          IF a_icysno->qonhand = 0
            ln_Qty = 1
          ELSE
            ln_Qty = a_icysno->qonhand
          ENDIF

          go_SQL.cmpA_Tmpf1.m_SQLInsert("ttranno, vpartno, serial, loctid, lotno, trantyp, tdate, " + ;
          "sqty, tcost, applid, orgno, docno, price, trcost, tftcost", ;
          "a_icytrn->ttranno, a_icytrn->vpartno, '" + lc_serial + "', a_icytrn->loctid, a_icytrn->lotno, a_icytrn->trantyp, " + ;
          "a_icytrn->tdate, " + STR(ln_Qty) + ", a_icytrn->tcost, a_icytrn->applid, a_icytrn->orgno, a_icytrn->docno, " + ;
          "a_icytrn->price, a_icytrn->trcost, a_icytrn->tftcost", "")
        ENDIF

      ENDIF

    ENDIF

  ENDDO
  go_SQL.cmpA_icysno.m_ScanEnd()

  go_SQL.cmpA_tmpf1.m_DropIndex("lc_idx3", .t., .t.)

  go_SQL.m_TableChangeCurrent("a_tmpf1")
  go_SQL.cmpA_tmpf1.m_createIndex("tag1", "serial + ttranno", "", .t., .f.)

  *-- Set report title
  lc_title = "Serial Number History"

  *# DOCCODE REPORT FORM icslnw
  lc_frx = gc_icprgdv + "icslnw"

RETURN
*------------------------------------------------------------------------------
*- End: L_ICREPT_t10.PRG
*------------------------------------------------------------------------------

*\ [Begin] PTR# 77227 05/25/06 TIVK Find the Qty to be reordered
*------------------------------------------------------------------------------
*- Function...: L_QTYREORD
*------------------------------------------------------------------------------
*- Description: Qty. to be reordered
*------------------------------------------------------------------------------
*- Synopsis...: Determine the qty. that is to be reordered
*-              Used in IC Recommended Reorder Report
*-              Previously, the maximum between the Order Qty & the 
*-              shortage was taken as the Required Qty to be ordered.
*-              Now, this is being substituted with "Increments".
*-              This is done by incrementing the Order Qty, or, the Order Point
*-              until it exceeds the shortage to get a value. Similarly, the
*-              Supplier Min. Order qty is incremented along its incremental
*-              qty until it exceeds the shortage to arrive at another value.
*-              These two values are then considered and the maximum of the 
*-              two is taken. This is once again validated with the supplier 
*-              increment details to arrive at the final qty that is to be 
*-              ordered.
*------------------------------------------------------------------------------
*- Calls......: none
*------------------------------------------------------------------------------
*- Passed:
*- Variables..: none
*- Parameters.: none
*------------------------------------------------------------------------------
*- Returns:
*- Variables..: ln_QtyReord,  the qty that is to reordered
*------------------------------------------------------------------------------
FUNCTION l_QtyReord

  LOCAL ln_OrdpQty, ;
        ln_OrdQty, ;
        ln_QtyReq, ;
        ln_ExtraQty, ;
        ln_SuppQty

  *-- Use the Order Qty as the increment to cover the shortage in stock.
  *-- If no Order Qty is given, then use the Order Point as the increment instead.
  ln_OrdQty  = IIF(ordqty > 0, ordqty, orderpt)
  ln_Project = ((lonhand -lsoaloc - lwoaloc) + (lonordr + lonwkor))

  ln_QtyReq = IIF(orderpt > 0,(orderpt - ln_project), ABS(ln_project)) * ;
              IIF(EOF("a_icunms"),1,a_icunms->cnvf)/ ;
              IIF(a_icitem->pumfact = 0, 1, a_icitem->pumfact)

*\ [1 Line] PTR 83635 07/14/06 TIVK Use the default qty if order pt./qty are zero
  *-- Increment Order Qty/Order Point until it exceeds the shortage
  ln_OrdpQty = IIF(ln_OrdQty > 0, ;
                   ln_OrdQty * CEILING(ln_QtyReq / ln_OrdQty), ln_QtyReq) 

  *-- Increment supplier min. order qty until it exceeds the shortage
  IF NOT EMPTY(lsupplr) AND a_icsupl->OrdIncr > 0 AND ln_QtyReq > a_icsupl->OrdMin
    *-- Supplier has increment
    ln_ExtraQty = (ln_QtyReq - a_icsupl->OrdMin)

    IF ln_ExtraQty % a_icsupl->OrdIncr = 0
      *-- Required qty fits supplier order increment exactly
      ln_SuppQty = ln_QtyReq
    ELSE
      *-- Add some qty to order to match supplier increment
      ln_SuppQty = ln_QtyReq + a_icsupl->OrdIncr - ;
                   (ln_ExtraQty % a_icsupl->OrdIncr)
    ENDIF

  ELSE
    ln_SuppQty = a_icsupl->OrdMin
  ENDIF

  *-- Find the max. between the Order Increment and the Supplier Increment
  ln_MinQty = MAX(ln_OrdpQty, ln_SuppQty)

  IF a_icsupl->OrdIncr = 0 OR EMPTY(lsupplr)
    ln_TQtyOrd = ln_MinQty
  ELSE
    *-- Validate this once again, with the Supplier Increment
    *-- Calculate default order quantity
    *-- Supplier has increment
    ln_ExtraQty = (ln_MinQty - a_icsupl->OrdMin)

    IF ln_ExtraQty % a_icsupl->OrdIncr = 0
      *-- Required qty fits supplier order increment exactly
      ln_TQtyOrd = ln_MinQty
    ELSE
      *-- Add some qty to order to match supplier increment
      ln_TQtyOrd = ln_MinQty + a_icsupl->OrdIncr - ;
                   (ln_ExtraQty % a_icsupl->OrdIncr)
    ENDIF
  ENDIF

RETURN ln_TQtyOrd
*------------------------------------------------------------------------------
*- End Function...: L_QTYREORD
*------------------------------------------------------------------------------
*\ [End] PTR# 77227 05/25/06 TIVK Find the Qty to be reordered

*------------------------------------------------------------------------------
*- File Name..: $Workfile: ICREPT.PRG $
*- Total Lines: 13043